unit UnitClipMenu;
{
	NOTES:
        Keyboard focus is not working
}
interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms, 
  Dialogs, Buttons, ExtCtrls, Menus, UnitClipQueue;


type
  TClipMenu = class(TcustomPanel)
    {$REGION 'default'}
    btnPin: TSpeedButton;
    btnEdit: TSpeedButton;
    btnDelete: TSpeedButton;
    btnDestroy: TSpeedButton;
    btnPaste: TSpeedButton;
    btnPasteAs : TSpeedButton;
    btnPermanent: TSpeedButton;
    pmPaste: TPopupMenu;
    pnlPaste : TFlowPanel;


    btnMimic : TSpeedButton;
    btnShiftInsert : TSpeedButton;
    btnCtrlV : TSpeedButton;
    btnClipboard : TSpeedButton;

    btnAsPlain : TSpeedbutton;
    btnAsFile : TSpeedButton;
    btnAsFormat : TSpeedButton;

    pmPermanent: TPopupMenu;
    btnAsPlaintext : TSpeedButton;

    btnAsClip : TSpeedButton;

    MimickTyping1: TMenuItem;
    ShiftInsert1: TMenuItem;
    CTRLV1: TMenuItem;
    ClipboardOnly1: TMenuItem;
    AsFile1 : TMenuItem;
    timClose: TTimer;
    asPlaintext1: TMenuItem;
    asClip1: TMenuItem;
    N1: TMenuItem;
    Cancel1: TMenuItem;
    N2: TMenuItem;
    Cancel2: TMenuItem;
    procedure CreateParams(var Params: TCreateParams);  override;
    procedure btnPinClick(Sender: Tobject);
    procedure btnEditClick(Sender: TObject);
    procedure btnPasteClick(Sender: TObject);
    procedure btnPasteAsClick(Sender: TObject);
    procedure timCloseTimer(Sender: TObject);
    procedure MimickTyping1Click(Sender: TObject);
    procedure ShiftInsert1Click(Sender: TObject);
    procedure CTRLV1Click(Sender: TObject);
    procedure ClipboardOnly1Click(Sender: TObject);
    procedure AsPlainClick(Sender: TObject);
    procedure AsFile1Click(Sender: TObject);
    procedure AsFormatClick(Sender: TObject);
    procedure btnPermanentClick(Sender: TObject);
    procedure asPlaintext1Click(Sender: TObject);
    procedure asClip1Click(Sender: TObject);
    procedure btnDeleteClick(Sender: TObject);
    procedure btnDestroyClick(Sender: TObject);
    {$ENDREGION}
  private
    { Private declarations }
    fgroup, findex : integer;
    fci : TClipItem;
    isPopup : boolean;

    fOnEditClip,
    fOnRemoveClip,
    fOnDestroyClip,
    fOnPasteClip,
    fOnMakePermanentClip : TNotifyEvent;
    fShowing : boolean;

    procedure WMGetDlgCode(var Msg: TMessage); message WM_GETDLGCODE;
    procedure KeyDown(var Key: Word; Shift: TShiftState); override;
    procedure HanldeButtonClick;
    procedure HideSubmenus;
    procedure FixPosition;
  protected
    procedure paint; override;
    procedure KeyPress(var Key: Char); override;
  public
    { Public declarations }
    constructor Create(AOwner: TComponent); override;
    property OnEditClip : TNotifyEvent read fOnEditClip write fOnEditClip;
    property OnRemoveClip : TNotifyEvent read fOnRemoveClip write fOnRemoveClip;
    property OnDestroyClip : TNotifyEvent read fOnDestroyClip write fOnDestroyClip;
    property OnPasteClip : TNotifyEvent read fOnPasteClip write fOnPasteClip;
    property OnMakePermanentClip : TNotifyEvent read fOnMakePermanentClip write fOnMakePermanentClip;
    property showing read fShowing;
    procedure SetPopupClip(ci : TClipItem);
    procedure SetACPopupItem(p : TObject);
    procedure SetPermanentClip(group, index : integer);
    procedure SetPopupClipMode;
    procedure SetPermanentClipMode;
    procedure TriggerDelayedClose;
    procedure Show;
    procedure Hide;

    procedure ReportKeypress(key : Char); overload;
    procedure ReportKeypress(key : Word); overload;
end;

implementation

uses UnitFrmConfig, UnitFrmMainPopup, UnitFrmEditItem, UnitFrmPermanentNew,
  UnitFrmEditTextExternal, UnitPopupGenerate, UnitMisc, UnitPaste, UnitFramePopup, UnitMenuItemTagdata, Clipbrd,
  UnitDropFile, unitfrmClipboardManager;

{ $R *.dfm}

{ TFrmItemMenu }

procedure TClipMenu.ReportKeypress(key : Word);
var i, j, first : integer;

begin
    case key of
    VK_ESCAPE: begin
        self.Hide;
    end;
    VK_UP:  begin

    end;
    VK_DOWN: begin

    end;
    else
        ReportKeypress(char(key));
    end;
end;
procedure TClipMenu.ReportKeypress(key : Char);
var c : Char;
begin
    c := lowercase(key)[1];
    case c of
    'l' : self.btnPin.Click;
    'e' : self.btnEdit.Click;
    'u' : Self.btnPaste.Click;
    'p' : Self.btnPasteAs.Click;
    'm' : self.btnPermanent.Click;
    'd' : self.btnDelete.Click;
    's' : self.btnDestroy.Click;

    't' : self.btnMimic.Click;
    'i' : self.btnShiftInsert.Click;
    'v' : self.btnCtrlV.Click;
    'o' : Self.btnClipboard.Click;
    'f' : Self.btnAsFile.Click;

    'n' : self.btnAsPlain.Click;
    'x' : self.btnAsPlaintext.Click;
    'a' : self.asClip1.Click;
    'r' : self.btnAsFormat.Click;

    // default key
    ' ' : self.btnEdit.Click;
    end;
end;

const SUBMENU_PREFIX = '    ';
constructor TClipMenu.Create(AOwner: TComponent);
	procedure SetCommon(b : TSpeedButton; caption : string);
    begin
        b.Align := alTop;
        b.Layout := blGlyphLeft;
        b.Flat := true;
        b.Margin := 10;
        b.Margins.Top := 0;
        b.Margins.Bottom := 1;
    	b.caption := caption;
        b.AlignWithMargins := true;

        self.insertcontrol(b);
    end;
    procedure SetCommon2(b : TSpeedButton; caption : string);
    begin
        b.Align := alTop;
        b.Layout := blGlyphLeft;
        b.Flat := true;
        b.Margin := 10;
        b.Margins.Top := 0;
        b.Margins.Bottom := 1;
    	b.caption := caption;
        b.AlignWithMargins := true;

//        self.insertcontrol(b);
    end;
    procedure SetCommonSubButton(b : TSpeedButton; caption : string);
    begin
        SetCommon(b, caption);
    	b.caption := SUBMENU_PREFIX + caption;
        b.Height := b.Height - 5;
    end;
    procedure SetCommonSubButton2(b : TSpeedButton; caption : string);
    begin
        SetCommon2(b, caption);
    	b.caption := SUBMENU_PREFIX + caption;
        b.Height := b.Height - 5;
    end;
    procedure NewLine;
    var sh : TShape;
        c : TPanel;
    begin
        sh := TShape.Create(self);
        sh.Align := alTop;
        sh.Shape := stRectangle;
        sh.Height := 1;
        sh.Width := 110;
        sh.AlignWithMargins := true;
        sh.Margins.Top := 0;
        sh.Margins.Left := 4;
        sh.Margins.Right := 4;
        sh.Margins.Bottom := 0;
        sh.Pen.Color := dimColor(clBtnFace,0.9);

        self.InsertControl(sh);

        sh := TShape.Create(self);
        sh.Align := alTop;
        sh.Shape := stRectangle;
        sh.Height := 1;
        sh.Width := 110;
        sh.AlignWithMargins := true;
        sh.Margins.Top := 0;
        sh.Margins.Left := 4;
        sh.Margins.Right := 4;
        sh.Margins.Bottom := 1;
        sh.Pen.Color := dimColor(clBtnFace,1.5);

        self.InsertControl(sh);

        {
        c := TPanel.Create(self);
        c.Align := alTop;
        c.Height := 3;
        c.Width := 116;
        self.InsertControl(c);}
    end;

begin
    visible := false;
	inherited create(nil);
    visible := false;

    self.Name := '';
    self.ParentWindow := GetDesktopWindow;

    self.ControlStyle := self.controlstyle- [csNoStdEvents];

    self.AlignWithMargins := true;

    btnPin := TSpeedButton.Create(self);
    btnPin.OnClick := self.btnPinClick;
    SetCommon(btnPin, 'P&in to List');

    NewLine;

    btnEdit := TSpeedButton.Create(self);
    btnEdit.OnClick := self.btnEditClick;
    SetCommon(btnEdit, '&Edit');

    btnDelete := TSpeedButton.create(self);
    btnDelete.OnClick := self.btnDeleteClick;
    SetCommon(btnDelete,'&Delete');

    btnDestroy := TSpeedButton.Create(self);
    btnDestroy.OnClick := self.btnDestroyClick;
    SetCommon(btnDestroy, 'De&stroy');

    NewLine;




    btnPaste := TSpeedButton.Create(self);
    btnPaste.OnClick := self.btnPasteClick;
    SetCommon(btnPaste,'Paste &Using ...');
        btnMimic := TSpeedButton.Create(self);
        btnMimic.OnClick := self.MimickTyping1Click;
        SetCommonSubButton(btnMimic,'Mimic &Typing');

        btnShiftInsert := TSpeedButton.Create(self);
        btnShiftInsert.OnClick := self.ShiftInsert1Click;
        SetCommonSubButton(btnShiftInsert,'Shift+&Insert');

        btnCtrlV := TSpeedButton.Create(self);
        btnCtrlV.OnClick := self.CTRLV1Click;
        SetCommonSubButton(btnCtrlV,'Ctrl+&V');

        btnClipboard := TSpeedButton.Create(self);
        btnClipboard.OnClick := self.ClipboardOnly1Click;
        SetCommonSubButton(btnClipboard,'Clipboard &Only');

    btnPasteAs := TSpeedButton.Create(self);
    btnPasteAs.OnClick := self.btnPasteAsClick;
    SetCommon(btnPasteAs, '&Paste As ...');

        btnAsPlain := TSpeedButton.Create(self);
        btnAsPlain.OnClick := self.AsPlainClick;
        SetCommonSubButton(btnAsPlain,'Plai&ntext Only');
        btnAsPlain.Visible := false;

        btnAsFile := TSpeedButton.Create(self);
        btnAsFile.OnClick := self.AsFile1Click;
        SetCommonSubButton(btnAsFile,'&File');

        btnAsFormat := TSpeedButton.Create(self);
        btnAsFormat.OnClick := self.AsFormatClick;
        SetCommonSubButton(btnAsFormat,'Fo&rmat ');
        btnAsFormat.Visible := false;

    btnPermanent := TSpeedButton.Create(self);
    btnPermanent.OnClick := self.btnPermanentClick;
    SetCommon(btnPermanent,'&Make Permanent ...');

        btnAsPlaintext := TSpeedButton.Create(self);
        btnAsPlaintext.OnClick := self.asPlaintext1Click;
        SetCommonSubButton(btnAsPlaintext,'as Plainte&xt');

        btnAsClip := TSpeedButton.Create(self);
        btnAsClip.OnClick := self.asClip1Click;
        SetCommonSubButton(btnAsClip,'&as Clip');

    timClose := TTimer.Create(self);
    timClose.Enabled := false;
    timClose.Interval := 500;
    timclose.OnTimer := self.timCloseTimer;

    self.Width := 125;
    self.Height := 150;
    self.ParentColor := false;
    self.Color := clBtnFace;
    self.AutoSize := true;
    self.BorderWidth := 0;

    self.Padding.top := 2;
    self.Padding.bottom := 2;
    self.Padding.left := 2;
    self.Padding.right := 2;
end;

procedure TClipMenu.CreateParams(var Params: TCreateParams);
begin
    inherited;
    visible := false;

    Params.Style := WS_CHILDWINDOW or WS_CLIPCHILDREN; // WS_CHILDWINDOW doesn't close a WS_POPUP window
    params.ExStyle := {WS_EX_NOACTIVATE or} WS_EX_TOOLWINDOW or WS_EX_TOPMOST or WS_EX_COMPOSITED ;

    if CheckWin32Version(6, 0) then
       params.WindowClass.Style := params.WindowClass.style or CS_DROPSHADOW;

    self.SetPopupClipMode;
end;

var acpopupitem : TACPopupItem;
procedure TClipMenu.SetACPopupItem(p: TObject);
begin
    {dirty trick to get around circular reference problem}
    acpopupitem := TACPopupItem(p);
    fci := acpopupitem.Clip;
end;

procedure TClipMenu.SetPermanentClip(group, index: integer);
begin
    self.isPopup := false;
    self.SetPermanentClipMode;
    fgroup := group;
    findex := index;
end;
procedure TClipMenu.SetPopupClip(ci : TClipItem);
begin
    self.isPopup := true;
    self.SetPopupClipMode;
    fci := ci;
end;
procedure TClipMenu.SetPermanentClipMode;
begin
    btnEdit.Enabled := true;
    btnDelete.Enabled := false;
    btnDestroy.Enabled := false;
    btnPaste.Enabled := true;
    btnPasteAs.Enabled := false;
    btnPermanent.Enabled := false;

    btnAsFormat.Visible := false;
end;
procedure TClipMenu.SetPopupClipMode;
begin
    btnEdit.Enabled := true;
    btnDelete.Enabled := true;
    btnDestroy.Enabled := true;
    btnPaste.Enabled := true;
    btnPermanent.Enabled := true;


end;



procedure TClipMenu.timCloseTimer(Sender: TObject);
begin
    timClose.Enabled := false;
    self.hide;
end;

procedure TClipMenu.TriggerDelayedClose;
begin
    timclose.Enabled := true;
end;


procedure TClipMenu.WMGetDlgCode(var Msg: TMessage);
begin
	inherited;
    Msg.Result:= Msg.Result or DLGC_WANTARROWS or DLGC_WANTALLKEYS;
end;


procedure TClipMenu.HanldeButtonClick;
begin
    self.Hide;
end;
procedure TClipMenu.btnPinClick(Sender: Tobject);
begin
    self.Hide;
    case acpopupitem.ItemType of
    IT_MENU: begin
        PinnedClipQueue.InsertAtStart(acpopupitem.clip);
    end;
    IT_PINNED: begin
        PinnedClipQueue.DeleteItem( PinnedClipQueue.IndexOf(acpopupitem.clip));
    end;
    end;
    CallEventSafe(fOnRemoveClip, Self);
end;

procedure TClipMenu.btnDeleteClick(Sender: TObject);
var i : integer;
begin
	case acpopupitem.ItemType of
    IT_CLIPBOARD: begin
        frmClipboardManager.ClearClipboard;
    end;
    IT_TEMP: begin
        i := TempClipQueue.IndexOf(fci);
        if (i <> -1) then begin
            TempClipQueue.DeleteItem2(i, false);
    	end;
    end;
    IT_MENU: begin
        i := ClipQueue.IndexOf(fci);
        if (i <> -1) then begin
            ClipQueue.DeleteItem(i);
        end;
    end;
    IT_CLICKED: begin
        i := ClickedClipQueue.IndexOf(fci);
        if (i <> -1) then begin
			ClickedClipQueue.DeleteItem(i);
        end;
    end;
    end;

    self.Hide;
    CallEventSafe(fOnRemoveClip, self);
end;
procedure TClipMenu.btnDestroyClick(Sender: TObject);
begin
    Windows.SetForegroundWindow(self.Handle);

    if (MessageDlg('Destroy: Permanently delete this item?', mtConfirmation, [mbyes, mbno],0) = mrYes) then begin
        if ClipQueue.IndexOf(fci) <> -1 then begin
            clipqueue.DestroyItem(ClipQueue.IndexOf(self.fci));
            CallEventSafe(fOnDestroyClip, self);
        // not yet implemented
        {end else if TempClipQueue.IndexOf(self.fci) <> -1  then begin
            TempClipQueue.DeleteItem(TempClipQueue.IndexOf(self.fci));
            CallEventSafe(fOnDestroyClip, self);}
        end;
    end;
end;
procedure TClipMenu.btnEditClick(Sender: TObject);
begin
    CallEventSafe(fOnEditClip, self);
    FrmMainPopup.SkipFocusReturnOnce;
    self.HanldeButtonClick;
    
    if (acpopupitem<>nil) and (acpopupitem.ItemType <> IT_PERMANENT) then begin
        if frmConfig.cbEditClipWindow.checked then begin
            FrmEditItem.SetText(fci.GetAsPlaintext, nil);
            FrmMainPopup.ShowPreviewEditForm;
        end else begin
            frmEditTextExternal.EditClip(self.fci);
        end;
    end else begin
        FrmPermanent.ShowAndSelect(fgroup, findex);
    end;
end;
procedure TClipMenu.btnPasteClick(Sender: TObject);
var x : integer;
begin
//    self.HideSubmenus;
    self.AutoSize := false;

    btnMimic.Visible := true;
    btnShiftInsert.Visible := true;
    btnCtrlV.Visible := true;
    btnClipboard.Visible := True;

    x := btnPaste.Top + btnPaste.Height;

    btnMimic.top := x;
    btnShiftInsert.top := x;
    btnCtrlV.top := x;
    btnClipboard.top := x;

    btnPaste.Enabled := false;

    self.AutoSize := true;

    FixPosition;
end;
procedure TClipMenu.btnPasteAsClick(Sender: TObject);
var x : integer;
begin
//    self.HideSubmenus;

    self.AutoSize := false;

    btnAsPlain.Visible := false;
    btnAsFile.Visible := true;
    btnAsFormat.Visible := false;
    if not (fci.GetFormatType in [FT_UNICODE, FT_TEXT, FT_PICTURE])  then begin
        btnAsFormat.Visible := true;
        btnAsFormat.Top := btnAsFile.Top + btnAsFile.Height;
        self.Realign;
        case fci.GetFormatType of
        FT_HTML, FT_RICHTEXT: begin
            btnAsPlain.Visible := true;
            btnAsFormat.Caption := SUBMENU_PREFIX + 'as Fo&rmatted Text';
        end;
        FT_FILE:
            begin
                btnAsPlain.Visible := true;
                btnAsFormat.Caption := SUBMENU_PREFIX +'as Fo&rmat File(s)';
                btnAsFile.Visible := false;
            end
        else
            btnAsFormat.Caption := SUBMENU_PREFIX +'as Fo&rmat';
        end;
    end;

    x := btnPasteAs.Top + btnPaste.Height;
    btnAsFile.Top := x;
    btnAsFormat.Top := x;
    btnAsPlain.Top := x;

    btnPasteAs.Enabled := false;
    self.AutoSize := true;

    FixPosition;
end;
procedure TClipMenu.btnPermanentClick(Sender: TObject);
var ft : TClipFormatType;
begin
//    self.HideSubmenus;

    self.AutoSize := false;
    self.DisableAlign;
    ft := fci.GetFormatType;
    if not (ft = FT_UNICODE) and not (ft = FT_PICTURE) then
        btnAsPlaintext.Visible := true;
    btnAsClip.Visible := true;
    btnAsClip.Caption := SUBMENU_PREFIX+'[No Format Found]';
    case ft of
        FT_UNICODE: begin
        	btnAsClip.Caption := SUBMENU_PREFIX+'&as Unicode';
        end;
        FT_PICTURE: begin
            btnAsClip.Caption := SUBMENU_PREFIX+'&as Picture';
        end;
        FT_HTML: begin;
            btnAsClip.Caption := SUBMENU_PREFIX+'&as HTML';
    	end;
        FT_RICHTEXT: begin
        	btnAsClip.Caption := SUBMENU_PREFIX+'&as Rich Text';
        end;
        FT_FILE: begin
        	btnAsClip.Caption := SUBMENU_PREFIX+'&as Files';
        end;
    end;

    btnPermanent.Enabled := false;
    self.EnableAlign;
    self.AutoSize := true;

    FixPosition;
end;
procedure TClipMenu.ClipboardOnly1Click(Sender: TObject);
var
    s : string;
begin
    CallEventSafe(fOnPasteClip, self);
    self.HanldeButtonClick;

    if isPopup then begin
        Paste.SetClipboardOnlyOnce;
        if fci.GetFormatType <> FT_PICTURE then begin
            FrmMainPopup.SendText(fci.GetAsPlaintext,nil);
        end else begin
            FrmMainPopup.SendText('',fci);
        end;
    end else begin
        if fgroup <> -1 then begin
            FrmPermanent.PermFolderPush;
            FrmPermanent.SetPermanentPath(frmpermanent.PermFoldersGetItem(fgroup));
        end;

        s := FrmPermanent.GetItemText(findex);

        if fgroup <> -1 then begin
            FrmPermanent.PermFolderPop;
        end;

        Paste.SetClipboardOnlyOnce;
        FrmMainPopup.SendText(s);
    end;
end;
procedure TClipMenu.CTRLV1Click(Sender: TObject);
var
    s : string;
begin
    CallEventSafe(fOnPasteClip, self);
    self.HanldeButtonClick;

    if isPopup then begin
        Paste.SetUsePasteCVOnce;
        FrmMainPopup.SendText(fci.GetAsPlaintext,nil);
    end else begin
        if fgroup <> -1 then begin
            FrmPermanent.PermFolderPush;
            FrmPermanent.SetPermanentPath(frmpermanent.PermFoldersGetItem(fgroup));
        end;

        s := FrmPermanent.GetItemText(findex);

        if fgroup <> -1 then begin
            FrmPermanent.PermFolderPop;
        end;

        Paste.SetUsePasteCVOnce;
        FrmMainPopup.SendText(s);
    end;
end;

procedure TClipMenu.AsPlainClick(Sender: TObject);
var s : string;
begin
    if isPopup then begin
        FrmMainPopup.SendText(fci.GetAsPlaintext,nil);
    end else begin
        if fgroup <> -1 then begin
            FrmPermanent.PermFolderPush;
            FrmPermanent.SetPermanentPath(frmpermanent.PermFoldersGetItem(fgroup));
        end;

        s := FrmPermanent.GetItemText(findex);

        if fgroup <> -1 then begin
            FrmPermanent.PermFolderPop;
        end;

        FrmMainPopup.SendText(s);
    end;
end;
procedure TClipMenu.AsFile1Click(Sender: TObject);
var ci : TClipItem;
    s : string;
    procedure PasteClipAsFile(c : TClipItem);
    begin
        if FrmMainPopup.TargetData.DropFilesCompatible then begin
            UnitDropFile.DropFile(c,  FrmMainPopup.TargetData.ForegroundWindow);
        end else begin
            UnitDropFile.DropFile(c);
        end;
    end;
begin
    CallEventSafe(fOnPasteClip, self);
    FrmMainPopup.ShowPopupCallback(nil);  // close the popup

    if isPopup then begin
        PasteClipAsFile(fci);
    end else begin
        if fgroup <> -1 then begin
            FrmPermanent.PermFolderPush;
            FrmPermanent.SetPermanentPath(frmpermanent.PermFoldersGetItem(fgroup));
        end;

        s := FrmPermanent.GetItemText(findex);
        if FrmPermanent.IsComplexItem(s) then begin
            ci := FrmPermanent.GetComplexItem(s);
        end else begin
            ci := TClipItem.Create;
            ci.SetFromPlainText(s);
        end;

        PasteClipAsFile(ci);
        MyFree(ci);
    end;
end;
procedure TClipMenu.AsFormatClick(Sender: TObject);
begin
    CallEventSafe(fOnPasteClip, self);
    FrmMainPopup.ShowPopupCallback(nil);  // close the popup

    Paste.SendText('', fci, TRUE);
end;
procedure TClipMenu.MimickTyping1Click(Sender: TObject);
var
    s : string;
begin
//    self.HanldeButtonClick;
    CallEventSafe(fOnPasteClip, self);
    FrmMainPopup.ShowPopupCallback(nil);  // close the popup
    MySleep(200);
    if isPopup then begin
        Paste.SetKeyboardMimicOnce;
        FrmMainPopup.SendText(fci.GetAsPlaintext,nil);
    end else begin
        if fgroup <> -1 then begin
            FrmPermanent.PermFolderPush;
            FrmPermanent.SetPermanentPath(frmpermanent.PermFoldersGetItem(fgroup));
        end;

        s := FrmPermanent.GetItemText(findex);

        if fgroup <> -1 then begin
            FrmPermanent.PermFolderPop;
        end;

        Paste.SetKeyboardMimicOnce;
        FrmMainPopup.SendText(s);
    end;
end;
procedure TClipMenu.ShiftInsert1Click(Sender: TObject);
var
    s : string;
begin
    CallEventSafe(fOnPasteClip, self);
    self.HanldeButtonClick;
    if isPopup then begin
        Paste.SetUsePasteSIOnce;
        FrmMainPopup.SendText(fci.GetAsPlaintext,nil);
    end else begin
        if fgroup <> -1 then begin
            FrmPermanent.PermFolderPush;
            FrmPermanent.SetPermanentPath(frmpermanent.PermFoldersGetItem(fgroup));
        end;

        s := FrmPermanent.GetItemText(findex);

        if fgroup <> -1 then begin
            FrmPermanent.PermFolderPop;
        end;

        Paste.SetUsePasteSIOnce;
        FrmMainPopup.SendText(s);
    end;
end;
procedure TClipMenu.asClip1Click(Sender: TObject);
begin
    CallEventSafe(fOnMakePermanentClip, self);
    self.HanldeButtonClick;
    FrmPermanent.ShowWithNewComplexItem(fci);
end;
procedure TClipMenu.asPlaintext1Click(Sender: TObject);
begin
    CallEventSafe(fOnMakePermanentClip, self);
    self.HanldeButtonClick;
    FrmPermanent.ShowWithNewItem(fci.GetAsPlaintext);
end;

procedure TClipMenu.paint;
var
	r : TRect;
begin
	r := self.clientrect;
	InflateRect(r,0,0);
    canvas.Brush.Color := clBtnText;
    Windows.DrawEdge(canvas.Handle, r, EDGE_RAISED, BF_RECT  or BF_SOFT);
	//inherited;
end;


procedure TClipMenu.HideSubmenus;
begin
    self.DisableAlign; // keeps the correct order when buttons shown again

    btnClipboard.Visible := false;
    btnCtrlV.Visible := false;
    btnShiftInsert.Visible := false;
    btnMimic.Visible := False;
    btnPaste.Visible := false;
    btnPaste.Visible := true;

    btnAsPlain.Visible := false;
    btnAsFormat.Visible := false;
    btnAsFile.Visible := false;
    btnPasteAs.Visible := false;
    btnPasteAs.Visible := true;


    btnAsClip.Visible := false;
    btnAsPlaintext.Visible := false;
    btnPermanent.Visible := False;
    btnPermanent.Visible := True;

    btnPaste.Enabled := true;
    btnPasteAs.Enabled := true;
    btnPermanent.Enabled := true;

    self.EnableAlign;
end;
procedure TClipMenu.Show;
begin
    self.HideSubmenus;

    btnPin.Enabled := false;
    btnEdit.Enabled := true;
    btnDelete.Enabled := true;
    btnDestroy.Enabled := true;
    btnPaste.Enabled := true;
    btnPasteAs.Enabled := true;
    btnPermanent.Enabled := true;

    self.Height := 150;

    if acpopupitem <> nil then begin
        case acpopupitem.ItemType of
        IT_TEMP: begin
           btnDestroy.Enabled := false;
        end;
        IT_PINNED: begin
            btnPin.Caption := 'Unpin from &List';
            btnPin.Enabled := true;

            btnEdit.Enabled := true;

            btnDelete.Enabled := false;
            btnDestroy.Enabled := false;
        end;
        IT_MENU: begin
            btnPin.Enabled := true;
            btnPin.Caption := 'Pin to &List';
        end;
        IT_PERMANENT:begin
            btnDelete.Enabled := false;
            btnDestroy.Enabled := false;
            btnPermanent.Enabled := false;
        end;
        IT_CLIPBOARD: begin
            btnDestroy.Enabled := false;
        end;
        end;
    end;
    

    Windows.SetWindowPos(self.handle,HWND_TOPMOST,self.left,self.top,self.Width,self.Height,
    	{SWP_NOACTIVATE or SWP_NOMOVE or} SWP_NOSIZE or SWP_SHOWWINDOW or SWP_NOACTIVATE);
    self.Visible := True;

    if isPopup then begin
        self.SetPopupClipMode;
    end else begin
        self.SetPermanentClipMode;
    end;


    {SWP_NOACTIVATE has no effect on focus and did not affect closing the popup}
	Windows.SetFocus(self.Handle);
    fShowing := true;

    if btnEdit.Enabled then begin
        btnEdit.Font.Style  := btnEdit.Font.Style + [fsBold];
    end;
end;
procedure TClipMenu.Hide;
begin
    windows.ShowWindow(self.Handle,SW_HIDE);
    self.Visible := false;
    fShowing := false;
end;

procedure TClipMenu.FixPosition;
begin
    if self.Left+self.Width > screen.DesktopRect.Right then begin
        self.Left := screen.DesktopRect.Right - self.Width;
    end;
    if self.Top + self.Height > screen.DesktopRect.Bottom then begin
        self.Top := screen.DesktopRect.Bottom - self.Height;
    end;
end;

procedure TClipMenu.KeyDown(var Key: Word; Shift: TShiftState);
begin
  inherited;

end;

procedure TClipMenu.KeyPress(var Key: Char);
begin
  inherited;

end;


end.
