unit UnitFrmConfig;
{
    Purpose:
        This form configures the hotkey as well as receives messages
        when the hotkey is pressed.

        This form also reads the current configuration and passes those
        option onto the responsible form (mainly FrmMainPopup)

    Updates:
        New panel for Popup "Config -> Popup - Keystrokes"
        Updated for option to show popup on double-click
        Removed Items now saved << no longer needed with cached removed items


        --------------
        New Form Mode show option
        Fixed logic for "Show Permanent Items" and selecting a
        display method.
        ------------
        New "SHIFT+INSERT" pasting options
        
        Moved the popup "show" options to their own panel
        New "Show Options" subitem under Popup
        New user definable function key for copy & permanent
        popup keystrokes.


        New Clipboard option - "Disable clipboard Monitoring when Scroll Lock is on"

        New look
        New way to do hotkeys

        Used ini.ReadInteger where appropriate
        Using UnitClipQueue
}
interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ComCtrls, ExtCtrls, ImgList, UnitHotKey, UnitFrmPermanentNew, UnitFrmHotkey,
  Buttons, UnitFrmTriggerWindow, UnitFrameMySlide, Vcl.Menus,
  Vcl.PlatformDefaultStyleActnCtrls, Vcl.ActnPopup;


type FormatOrder = (FO_UNICODE, FO_HTML, FO_RICHTEXT);
type TMenuOrderType =
(
    MOT_MENU,
    MOT_OTHER,
    MOT_CANCEL,
    MOT_LAST,
    MOT_CURRENT,
    MOT_REMOVED,
    MOT_PROGRAM,
    MOT_SYSTEM,
    MOT_PASTEUTILS,
    MOT_PERMANENT,
    MOT_SWITCH,
    MOT_FULL,
    MOT_ALLPERMANENT,
    MOT_SELECTED,
    MOT_CLICKED,
    MOT_SEARCH,
    MOT_BREAK
);
Type TClickAction = (
    CA_Run = 0,
    CA_RemoveUndelete = 1,
    CA_Destroy_Clip = 2,
    CA_Edit_Clip = 3,
    CA_Edit_Clip_as_file = 4,
    //CA_Preview_Clip = 5,
    CA_Paste_using_Mimic_Typing = 5,
    CA_Paste_on_Clipboard_only = 6,
    CA_Paste_using_ShiftInsert = 7,
    CA_Paste_using_CtrlV = 8,
    CA_Make_Permanent_Clip = 9,
    CA_Make_Permanent_Clip_as_Plain_Text = 10,
    CA_Show_RightClick_Menu = 11,
    CA_Paste_and_Keep_Popup_Open = 12,
    CA_Paste_as_Plaintext_only = 13,
    CA_Pin_Unpin_Clip = 14,
    CA_Paste_as_Formatted_only
);




type
  TFrmConfig = class(TForm)
    {$REGION 'Default'}
    btnSave: TButton;
    btnCancel: TButton;
    ImageList1: TImageList;
    FontDialog: TFontDialog;
    Panel10: TPanel;
    tvOptions: TTreeView;
    pcPanels: TPageControl;
    tsHotkey: TTabSheet;
    pHotkey: TPanel;
    Shape6: TShape;
    Shape1: TShape;
    lblKeyname: TLabel;
    Label5: TLabel;
    Label23: TLabel;
    lblPlaintext: TLabel;
    bEditPopupHotkey: TButton;
    btnEditPlaintextHotkey: TButton;
    Panel8: TPanel;
    tsClipboard: TTabSheet;
    pClipboard: TPanel;
    cbDisable: TCheckBox;
    cbRemember: TCheckBox;
    TabSheet3: TTabSheet;
    pClipboard_TextItems: TPanel;
    Label24: TLabel;
    lvFormats: TListView;
    TabSheet4: TTabSheet;
    pClipboard_NonText: TPanel;
    Label9: TLabel;
    Label35: TLabel;
    cbOtherItems: TCheckBox;
    txtOtherSizeLimitKB: TEdit;
    TabSheet5: TTabSheet;
    pPasting: TPanel;
    TabSheet6: TTabSheet;
    pPopup: TPanel;
    cbMoveFirst: TCheckBox;
    tsMenuOrder: TTabSheet;
    Panel4: TPanel;
    Label25: TLabel;
    Label30: TLabel;
    lvOrder: TListView;
    tsShowOptions: TTabSheet;
    pPopupShow: TPanel;
    TabSheet8: TTabSheet;
    pPopupKeystrokes: TPanel;
    TabSheet12: TTabSheet;
    Panel7: TPanel;
    TabSheet10: TTabSheet;
    pTooltipPopup: TPanel;
    Label37: TLabel;
    cbFullHeader: TCheckBox;
    cbCopyVisibleItem: TCheckBox;
    TabSheet11: TTabSheet;
    Panel6: TPanel;
    Label28: TLabel;
    Label22: TLabel;
    Label39: TLabel;
    tsTriggerWindow: TTabSheet;
    tbDelay: TTrackBar;
    Label41: TLabel;
    cbTriggerWindow: TCheckBox;
    Label42: TLabel;
    Label43: TLabel;
    Label44: TLabel;
    Label45: TLabel;
    GroupBox1: TGroupBox;
    sbbottomleft: TSpeedButton;
    sbLeft: TSpeedButton;
    sbtopleft: TSpeedButton;
    sbTop: TSpeedButton;
    sbBottom: TSpeedButton;
    sbtopright: TSpeedButton;
    sbRight: TSpeedButton;
    sbbottomright: TSpeedButton;
    TabSheet14: TTabSheet;
    Label27: TLabel;
    Panel5: TPanel;
    cbShowAllItems: TRadioButton;
    cbShowAllAsSubmenus: TRadioButton;
    Label26: TLabel;
    Panel3: TPanel;
    cbShowPermanentItemGroups: TRadioButton;
    cbPermanentItemsSubmenu: TRadioButton;
    sbEditPermanentClips: TSpeedButton;
    TabSheet15: TTabSheet;
    cbDontCopySelectedForAll: TCheckBox;
    Label38: TLabel;
    cbDisableChainNotification: TCheckBox;
    cbEnableExtendedChainChecking: TCheckBox;
    cbDisableWatcher: TCheckBox;
    tsHotkeyAlternatives: TTabSheet;
    cbPopupDoubleclick: TCheckBox;
    cbPopupSingleclick: TCheckBox;
    cbPopupDoubleclickTray: TCheckBox;
    cbPopupSingleclickTray: TCheckBox;
    cbRightTriggerEnable: TCheckBox;
    Label17: TLabel;
    Label49: TLabel;
    Label50: TLabel;
    Label51: TLabel;
    Label52: TLabel;
    Label56: TLabel;
    Label57: TLabel;
    Label58: TLabel;
    lblTriggerWindow: TLabel;
    Label60: TLabel;
    Label61: TLabel;
    lbMenuOrder: TLabel;
    Label59: TLabel;
    Label62: TLabel;
    Panel9: TPanel;
    Shape2: TShape;
    Label12: TLabel;
    lblTooltipKeyname: TLabel;
    Shape3: TShape;
    Label16: TLabel;
    lblPreviousTooltipKeyname: TLabel;
    bEditToolTipHotkey: TButton;
    bEditPreviousToolTipHotkey: TButton;
    cbUseTooltipHotkey: TCheckBox;
    Label63: TLabel;
    tsProgramOptions: TTabSheet;
    Label64: TLabel;
    cbDisableTrigger: TCheckBox;
    cbDisableMonitoring: TCheckBox;
    cbxPasteMethod: TComboBox;
    Label65: TLabel;
    lvPrograms: TListView;
    cbUseVirtualDesktop: TCheckBox;
    TabSheet7: TTabSheet;
    tsClipboardBar: TTabSheet;
    Label66: TLabel;
    Label67: TLabel;
    Label68: TLabel;
    Label69: TLabel;
    cbEditClipWindow: TCheckBox;
    tsHistory: TTabSheet;
    Panel12: TPanel;
    btnEditPopupClips: TSpeedButton;
    Label73: TLabel;
    Panel14: TPanel;
    btnRemovedClips: TSpeedButton;
    Label71: TLabel;
    Panel15: TPanel;
    Label76: TLabel;
    Label1: TLabel;
    Panel16: TPanel;
    Label19: TLabel;
    Label20: TLabel;
    Label31: TLabel;
    Label21: TLabel;
    txtMinHeightx: TEdit;
    udMinHeightx: TUpDown;
    UDWidthx: TUpDown;
    txtWidthx: TEdit;
    SpeedButton5: TSpeedButton;
    cbDisplayAtMouseCursor: TCheckBox;
    cbSearchDefault: TCheckBox;
    odSound: TOpenDialog;
    tsSound: TTabSheet;
    Panel18: TPanel;
    cbEnableSound: TCheckBox;
    btnSoundBrowse: TButton;
    btnTest: TSpeedButton;
    Label29: TLabel;
    cbCopyIcons: TCheckBox;
    Panel17: TPanel;
    Label48: TLabel;
    cbDisableSystemTrayIconNotification: TCheckBox;
    cbDisableWhenScrollLock: TCheckBox;
    Label53: TLabel;
    lblSound: TLabel;
    Label55: TLabel;
    cbMonitorFilenames: TCheckBox;
    cbDontCopy: TCheckBox;
    Label8: TLabel;
    lblHotkey: TLabel;
    Label72: TLabel;
    Label54: TLabel;
    btnPreview: TSpeedButton;
    timUpdatePreview: TTimer;
    cbDoubleHeight: TCheckBox;
    cbShowEmptyMenus: TCheckBox;
    cbFullMode: TCheckBox;
    cbAutoExpand: TCheckBox;
    cbAutoCollapse: TCheckBox;
    btnAddName: TButton;
    GroupBox3: TGroupBox;
    tbTooltipDelay: TTrackBar;
    Label75: TLabel;
    Label77: TLabel;
    GroupBox4: TGroupBox;
    Label6: TLabel;
    Edit1: TEdit;
    UDToolHeightx: TUpDown;
    UDToolWidthx: TUpDown;
    Label32: TLabel;
    Edit2: TEdit;
    Label18: TLabel;
    Label2: TLabel;
    udQueueSize: TJJSlide;
    udRemovedSize: TJJSlide;
    udRecentlyRemoved: TJJSlide;
    UDWidth: TJJSlide;
    udMinHeight: TJJSlide;
    UDToolHeight: TJJSlide;
    UDToolWidth: TJJSlide;
    GroupBox5: TGroupBox;
    rbPlainAndFormatted: TRadioButton;
    rbFormattedOnly: TRadioButton;
    rbPlainOnly: TRadioButton;
    Label36: TLabel;
    cbAlwaysPicture: TCheckBox;
    cbFontColor: TCheckBox;
    cbBackgroundColor: TCheckBox;
    ColorDialog1: TColorDialog;
    pnlFontColor: TPanel;
    pnlBackgroundColor: TPanel;
    cbHighlightColor: TCheckBox;
    pnlHighlightColor: TPanel;
    cbNoThumbnails: TCheckBox;
    TabSheet1: TTabSheet;
    Label79: TLabel;
    cbEnableClipSets: TCheckBox;
    cbEnableClipsSetsWhenTall: TCheckBox;
    udClipsPerSet: TMySlide;
    Label80: TLabel;
    Label81: TLabel;
    cbClickedColor: TCheckBox;
    pnlClickedColor: TPanel;
    btnColorExamples: TSpeedButton;
    pmExampleColors: TPopupMenu;
    DefaultScheme1: TMenuItem;
    SuperDark1: TMenuItem;
    JoeJoeSpecial1: TMenuItem;
    Greyscale1: TMenuItem;
    MetroGreen1: TMenuItem;
    MetroSteelBlue1: TMenuItem;
    Woodgrain1: TMenuItem;
    GroupBox6: TGroupBox;
    cbSystemTrayTooltip: TCheckBox;
    cbTooltipRichText: TCheckBox;
    cbShowHeaderFooter: TCheckBox;
    pnl1: TPanel;
    imgPreview: TImage;
    tsJumplist: TTabSheet;
    Label40: TLabel;
    cbxClickedAction: TComboBox;
    Label82: TLabel;
    Label83: TLabel;
    lblJumpList: TLabel;
    Label85: TLabel;
    lblHotkeyAlternatives: TLabel;
    Label88: TLabel;
    lblClipboardBar: TLabel;
    GroupBox7: TGroupBox;
    cbEnableClipboardBar: TCheckBox;
    Label70: TLabel;
    GroupBox8: TGroupBox;
    cbShowPopupWhenClicked: TCheckBox;
    cbShowTooltipOnHover: TCheckBox;
    GroupBox2: TGroupBox;
    udNormalOpacity: TMySlide;
    Label13: TLabel;
    pmPermClips: TPopupActionBar;
    cbxMouseButton: TComboBox;
    GroupBox9: TGroupBox;
    Label15: TLabel;
    cbxMiddleClickAction: TComboBox;
    cbxCtrlClickAction: TComboBox;
    Label47: TLabel;
    Label46: TLabel;
    cbxShiftClickAction: TComboBox;
    GroupBox10: TGroupBox;
    cbPinnedShortcuts: TCheckBox;
    cbPopupCharLimit: TCheckBox;
    cbUseKeyboard: TCheckBox;
    udPopupKeysLimit: TMySlide;
    Label86: TLabel;
    cbxAltClickAction: TComboBox;
    Label10: TLabel;
    GroupBox11: TGroupBox;
    Label11: TLabel;
    Label14: TLabel;
    Label84: TLabel;
    Label74: TLabel;
    pnl3: TPanel;
    btnMenuUp: TSpeedButton;
    btnMenuDown: TSpeedButton;
    btnToggle: TButton;
    pnl4: TPanel;
    Label78: TLabel;
    txtTextSizeLimitKB: TEdit;
    cbDontCopyLargeText: TCheckBox;
    cbIgnoreSmallText: TCheckBox;
    cbCaseSensitive: TCheckBox;
    cbMoveDuplicate: TCheckBox;
    cbAutofixURLs: TCheckBox;
    cbRemoveFormat: TCheckBox;
    Label34: TLabel;
    pnl5: TPanel;
    btnFormatUp: TSpeedButton;
    btnFormatDown: TSpeedButton;
    SpeedButton3: TSpeedButton;
    SpeedButton4: TSpeedButton;
    GroupBox12: TGroupBox;
    rbPaste: TRadioButton;
    rbPasteSI: TRadioButton;
    rbClipboardOnly: TRadioButton;
    rbTyping: TRadioButton;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure cbUseKeyboardClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure txtPopupClipQueueSizeKeyPress(Sender: TObject; var Key: Char);
    procedure udQueueSizeXClick(Sender: TObject; Button: TUDBtnType);
    procedure cbDisableClick(Sender: TObject);
    procedure btnEditPermanentItemsClick(Sender: TObject);
    procedure rbTypingClick(Sender: TObject);
    procedure rbPasteClick(Sender: TObject);
    procedure btnSaveClick(Sender: TObject);
    procedure btnCancelClick(Sender: TObject);
    procedure cbMonitorFilenamesClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure rbClipboardOnlyClick(Sender: TObject);
    procedure cbMoveFirstClick(Sender: TObject);
    procedure cbRememberClick(Sender: TObject);
    procedure cbCopyIconsClick(Sender: TObject);
    procedure cbMoveDuplicateClick(Sender: TObject);
    procedure txtOldHistorySizeKeyPress(Sender: TObject; var Key: Char);
    procedure udRemovedSizeXClick(Sender: TObject; Button: TUDBtnType);
    procedure txtOtherSizeKeyPress(Sender: TObject; var Key: Char);
    procedure txtOtherSizeLimitKBChange(Sender: TObject);
    procedure tvOptionsClick(Sender: TObject);
    procedure tvOptionsCollapsing(Sender: TObject; Node: TTreeNode;
      var AllowCollapse: Boolean);
    procedure bEditPopupHotkeyClick(Sender: TObject);
    procedure cbDisableWhenScrollLockClick(Sender: TObject);
    procedure cbShowEditHistoryClick(Sender: TObject);
    procedure rbPasteSIClick(Sender: TObject);
    procedure tvOptionsChange(Sender: TObject; Node: TTreeNode);
    procedure cbShowFormModeClick(Sender: TObject);
    procedure bEditToolTipHotkeyClick(Sender: TObject);
    procedure bEditPreviousToolTipHotkeyClick(Sender: TObject);
    procedure cbPopupDoubleclickClick(Sender: TObject);
    procedure cbPopupDoubleclickTrayClick(Sender: TObject);
    procedure bntSetFontClick(Sender: TObject);
    procedure XcbShowAllItemsClick(Sender: TObject);
    procedure XcbShowAllAsSubmenusClick(Sender: TObject);
    procedure FormKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure btnEditPlaintextHotkeyClick(Sender: TObject);
    procedure btnFormatUpClick(Sender: TObject);
    procedure btnFormatDownClick(Sender: TObject);
    procedure cbDisableWatcherClick(Sender: TObject);
    procedure btnMenuUpClick(Sender: TObject);
    procedure btnMenuDownClick(Sender: TObject);
    procedure btnToggleClick(Sender: TObject);
    procedure lvOrderInfoTip(Sender: TObject; Item: TListItem;
      var InfoTip: string);
    procedure Panel8Click(Sender: TObject);
    procedure cbEnableSoundClick(Sender: TObject);
    procedure cbRightTriggerEnableClick(Sender: TObject);
    procedure cbTriggerWindowClick(Sender: TObject);
    procedure sbTopClick(Sender: TObject);
    procedure sbBottomClick(Sender: TObject);
    procedure sbLeftClick(Sender: TObject);
    procedure sbbottomleftClick(Sender: TObject);
    procedure sbtopleftClick(Sender: TObject);
    procedure sbtoprightClick(Sender: TObject);
    procedure sbbottomrightClick(Sender: TObject);
    procedure sbRightClick(Sender: TObject);
    procedure sbEditPermanentClipsClick(Sender: TObject);
    procedure SpeedButton5Click(Sender: TObject);
    procedure lblShowOptionsClick(Sender: TObject);
    procedure lbMenuOrderClick(Sender: TObject);
    procedure tsProgramOptionsShow(Sender: TObject);
    procedure cbxPasteMethodChange(Sender: TObject);
    procedure cbDisableTriggerMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure cbDisableMonitoringMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure lvProgramsClick(Sender: TObject);
    procedure cbUseVirtualDesktopMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure tsClipboardBarShow(Sender: TObject);
    procedure cbEnableClipboardBarMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure btnRemovedClipsClick(Sender: TObject);
    procedure pcPanelsChange(Sender: TObject);
    procedure lblTriggerWindowClick(Sender: TObject);
    procedure btnEditPopupClipsClick(Sender: TObject);
    procedure btnTestClick(Sender: TObject);
    procedure btnSoundBrowseClick(Sender: TObject);
    procedure lblSoundClick(Sender: TObject);
    procedure cbDontCopyClick(Sender: TObject);
    procedure lblHotkeyClick(Sender: TObject);
    procedure tvOptionsExpanding(Sender: TObject; Node: TTreeNode;
      var AllowExpansion: Boolean);
    procedure tvOptionsCustomDrawItem(Sender: TCustomTreeView; Node: TTreeNode;
      State: TCustomDrawState; var DefaultDraw: Boolean);
    procedure tvOptionsMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure btnPreviewClick(Sender: TObject);
    procedure timUpdatePreviewTimer(Sender: TObject);
    procedure lvOrderChange(Sender: TObject; Item: TListItem;
      Change: TItemChange);
    procedure FormHide(Sender: TObject);
    procedure lvOrderClick(Sender: TObject);
    procedure cbFullModeClick(Sender: TObject);
    procedure btnAddNameClick(Sender: TObject);

    procedure UpdatePreview(Sender : TObject=nil);
    procedure pnlColorClick(Sender: TObject);
    procedure btnColorExamplesClick(Sender: TObject);
    procedure DefaultScheme1Click(Sender: TObject);
    procedure SuperDark1Click(Sender: TObject);
    procedure JoeJoeSpecial1Click(Sender: TObject);
    procedure Greyscale1Click(Sender: TObject);
    procedure MetroGreen1Click(Sender: TObject);
    procedure MetroSteelBlue1Click(Sender: TObject);
    procedure Woodgrain1Click(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure lblJumpListClick(Sender: TObject);
    procedure lblHotkeyAlternativesClick(Sender: TObject);
    procedure lblClipboardBarClick(Sender: TObject);
    procedure btnPermClipsClick(Sender: TObject);
    procedure pmPermClipsPopup(Sender: TObject);
    procedure lvFormatsClick(Sender: TObject);
    {$ENDREGION}
  private
    { Private declarations }
    HotKeyPopup : TACHotKey;
    TTHotKeyPopup : TACHotKey;
    PTTHotKeyPopup : TACHotKey;
    PlainTextHotKey : TACHotKey;
    PlainTextData : THotkeyData;
    //LastShownPanel : TPanel;

    Hotkey_Ctrl : boolean;
    Hotkey_Alt : boolean;
    Hotkey_Winkey : boolean;
    Hotkey_Shift : boolean;
    Hotkey_Key :  word;

    TTHotkey_Ctrl : boolean;
    TTHotkey_Alt : boolean;
    TTHotkey_Winkey : boolean;
    TTHotkey_Shift : boolean;
    TTHotkey_Key :  word;

    PTTHotkey_Ctrl : boolean;
    PTTHotkey_Alt : boolean;
    PTTHotkey_Winkey : boolean;
    PTTHotkey_Shift : boolean;
    PTTHotkey_Key :  word;

    PreCaptureDelayMS : integer;
    RightClickDelay : integer;
    OldTrayPopup : boolean;
    CopySelected : boolean;

    RightclickTriggerWarned : boolean;
    PasteDelay : integer;
    ClipboardBarVisible : boolean;
    Sound_NewClip : string;

    DefaultMenuOrder : array[TMenuOrderType] of integer;
    ignorecollapse : boolean;

    tempFont : TFont;
    symbolkeys : string;
    alphanumerickeys : string;
    MimicDelayMS : integer;

    fTXTProgram : string;
    fBMPProgram : string;

    isLoading : boolean;

    procedure HotkeySave;
    procedure HotkeyLoad;
    function GetINIFileName: string;
    {function HotKeyAssign(
            Ctrl: boolean; Alt: boolean; Shift: boolean; WinKey: boolean;
            Keystroke: word; FunctionKey : boolean): boolean;
    //function HotKeyRelease(): boolean;
    }
    function GetHumanReadableTTHotkey : string;
    function GetHumanReadablePTTHotkey : string;
    function GetHumanReadablePlaintextHotkey : string;

    procedure UpdateColorExample;

    procedure PermClipClick(Sender : TObject);
    {function SetHotKey : boolean;}

  protected
    procedure CreateParams(var Params: TCreateParams); override;
  public
    function GetHumanReadableHotkey: string;

    function GetRightclickTriggerWarned : boolean;
    function GetPasteDelay : integer;
    procedure SetRightclickTriggerWarned;
    function GetPreCaptureDelayMS : integer;
    function GetRightClickDelay : integer;
    function GetHotKeyID: integer;
    function GetTTHotKeyID: integer;
    function GetPTTHotKeyID: integer;
    function GetPlaintextHokeyID : integer;
    function GetOldTrayPopup : boolean;
    procedure ForceOldTrayPopup; 
    procedure SaveLastPermPath;

    function FormatCount : integer;
    function MenuOrderText(m : TMenuOrderType; description:boolean) : string;
    function GetFormat(index : integer) : FormatOrder;

    function CopySelectedForPopup : boolean;

    function ClipboardBarSetVisible : boolean;

    procedure SaveClipboardBarState;
    procedure LoadClipboardBarState;

    function GetShiftClickAction : TClickAction;
    function GetCtrlClickAction : TClickAction;
    function GetMiddleClickAction : TClickAction;
    function GetAltClickAction : TClickAction;

    function GetNewClipWav : string;

    function GetFont : TFont;

    procedure MoveItem(x, before : TMenuOrderType);
    function GetAccelSymbols : string;
    function GetAccelAlphaNumeric : string;
    function GetMimicDelayMS : integer;

    function GetTXTProgram : string;
    function GetBMPProgram : string;

    procedure ReportTXTProgram(s : string);
    procedure ReportBMPProgram(s : string);
    { Public declarations }
  end;

var
  FrmConfig: TFrmConfig;

implementation


uses
    INIFiles,Math,

    UnitFrmMainPopup, UnitClipQueue, UnitOtherQueue,
  UnitFrmSysTrayMenu, {UnitFrmRemoved,} UnitPaste,
  UnitMisc, {UnitfrmDummyUnicodePopup,} UnitFrmClipboardManager,
  UnitFrmChainWatcher
  , UnitPopupGenerate, UnitSound, UnitFrmDummyClipboardBar, {UnitFrmScratchpad,} Registry,
   UnitFramePopup, StrUtils, GraphUtil, UnitFrmPreviewPopup;




{$R *.dfm}

CONST LVORDER_ID = '2';


procedure MoveListViewItem(lv: TListView; old, new : integer);
var lisource, lidest: TListItem;
begin
    if old < new then begin
        MoveListViewItem(lv, new, old);
        EXIT;
    end;
    lv.Items.BeginUpdate;
    try
        lisource := lv.Items[old];
        lidest := lv.Items.Insert(new);
        lidest.Assign(lisource);
        lisource.Free;
    finally
        lv.Items.EndUpdate;
    end;
end;
procedure MoveListViewItem2(lv: TListView; old, new : integer);
var lisource, lidest: TListItem;
begin
    lv.Items.BeginUpdate;
    try
        lisource := lv.Items[old];
        lidest := lv.Items.Insert(new);
        lidest.Assign(lisource);
        lisource.Free;
    finally
        lv.Items.EndUpdate;
    end;
end;


procedure TFrmConfig.CreateParams(var Params: TCreateParams);
begin
    inherited CreateParams(Params);
    // allow context taskbar context menu and
    // show me on the taskbar - independant of main form
    with Params do begin
        ExStyle := ExStyle or WS_EX_APPWINDOW;
        WndParent := GetDesktopwindow;
    end;
end;


procedure TFrmConfig.FormCreate(Sender: TObject);
var tn : TTreeNode;
    i : integer;
    li : TListItem;

    function NewOrderItem(mo : TMenuOrderType; line : boolean; checked : boolean = true) : TListItem;
    begin
        result := lvOrder.items.add;
        result.Caption := MenuOrderText(mo, false);

        if line then
            result.SubItems.Add('Yes')
        else
            result.SubItems.Add('no');

        result.Data := Pointer(mo);
        result.checked := checked;
        if mo = MOT_BREAK then
            result.Checked := false;

        DefaultMenuOrder[mo] := result.Index;
    end;
begin
    UnitMisc.AppendLog('FrmConfig - Creating');

    tempFont := TFont.Create;


    pcPanels.ActivePageIndex := 0;

    lvFormats.Items.Count := -1;
    li := lvFormats.Items.Add;
    li.Caption := 'RichText';
    li.Checked := true;
    li := lvFormats.Items.Add;
    li.Caption := 'HTML';
    li.Checked := true;
    li := lvFormats.Items.Add;
    li.Caption := 'Unicode';
    li.Checked := true;

    //Application.ProcessMessages;
    // BUG - this invalidates the listview count by sending the message LVSICF_NOINVALIDATEALL


    // set default Popup state
    lvOrder.Items.Clear;
    li := NewOrderItem(MOT_MENU, false);
    //li := NewOrderItem(MOT_OTHER, false, false);
    li := NewOrderItem(MOT_CURRENT, true);
    li := NewOrderItem(MOT_REMOVED, false);
    li := NewOrderITem(MOT_CLICKED, false);

    li := NewOrderItem(MOT_CANCEL, true);

    //li := NewOrderItem(MOT_LAST, false, false);
    //li := NewOrderItem(MOT_SELECTED, false, false);
    self.CopySelected := false;


    li := NewOrderItem(MOT_PERMANENT, true);
    li := NewOrderItem(MOT_ALLPERMANENT, false, false);
    li := NewOrderItem(MOT_SWITCH, false);
    li := NewOrderItem(MOT_BREAK, false);
    li := NewOrderItem(MOT_SEARCH, true, false);
    li := NewOrderItem(MOT_PROGRAM, false, false);
    li := NewOrderItem(MOT_SYSTEM, false);

    li := NewOrderItem(MOT_PASTEUTILS, false, false);

    li := NewOrderItem(MOT_FULL, true);
    lvOrder.items.Count := -1;
    Application.ProcessMessages;

    {
    for i := 0 to lvOrder.items.Count - 1 do begin
        tn := tvGroup.Items.Add(nil, lvOrder.items[i].Caption);
        tn.ImageIndex := 1;
        tn.SelectedIndex := 1;
        tn.Data := lvOrder.items[i].data;
    end;
    }

    self.HotkeyLoad();
    if not (cbPermanentItemsSubmenu.Checked or cbShowPermanentItemGroups.checked) then begin
        cbPermanentItemsSubmenu.Checked := true;
    end;

    if frmClipboardManager <> nil then begin
        if frmClipboardManager.IsNewClipboardAPI then begin
            cbDisableWatcher.Checked := true;
            cbDisableWatcher.Enabled := false;
            cbEnableExtendedChainChecking.Checked := false;
            cbEnableExtendedChainChecking.Enabled := false;
            cbDisableChainNotification.Checked := true;
            cbDisableChainNotification.Enabled := false;
        end;
    end;


    //
    //Hook onto keystoke
    //
    TTHotKeyPopup := nil;
    PTTHotKeyPopup := nil;
    PlainTextHotKey := nil;
    try
        HotKeyPopup := TACHotKey.Create(FrmMainPopup.handle, 'ArsClip.exe.MyHotKey',
            Hotkey_Ctrl, Hotkey_Alt, Hotkey_Shift,
            Hotkey_Winkey, Hotkey_Key
        );
    except
        ShowMessage('Failed to set hotkey ' + self.lblKeyname.Caption );
    end;
    try
        PlainTextHotkey:= TACHotKey.Create(FrmMainPopup.handle, 'ArsClip.exe.PlainText',
            PlainTextData.Ctrl, PlainTextData.Alt, PlainTextData.Shft,
            PlainTextData.Win, PlainTextData.Key
        );
    except
        ShowMessage('Failed to set hotkey ' + self.lblPlaintext.Caption );
    end;
    try
        if (self.cbUseTooltipHotkey.checked) then begin
            TTHotKeyPopup := TACHotKey.Create(FrmMainPopup.handle, 'ArsClip.exe.MyTTHotKey',
                TTHotkey_Ctrl, TTHotkey_Alt, TTHotkey_Shift,
                TTHotkey_Winkey, TTHotkey_Key
            );
        end;
    except
        ShowMessage('Failed to set hotkey ' + self.lblTooltipKeyname.Caption );
    end;
    try
        if (self.cbUseTooltipHotkey.checked) then begin
            PTTHotKeyPopup := TACHotKey.Create(FrmMainPopup.handle, 'ArsClip.exe.MyPTTHotKey',
                PTTHotkey_Ctrl, PTTHotkey_Alt, PTTHotkey_Shift,
                PTTHotkey_Winkey, PTTHotkey_Key
            );
        end;
    except
        ShowMessage('Failed to set hotkey ' + self.lblPreviousTooltipKeyname.Caption );
    end;


    {
    if (rbKey.Checked) then begin
        w := ord(txtKey.text[1]);
    end else begin
        w := Hotkey_Key;
    end;
    {
    if not self.HotKeyAssign(Hotkey_Ctrl, Hotkey_Alt, Hotkey_Shift,
        Hotkey_Winkey, Hotkey_Key, false) then begin
        ShowMessage('ERROR: Unable to assign a hotkey. Please change the key.');
    end;
    }

    // expand all tree branches
    tn := tvOptions.Items.GetFirstNode;
    while tn <> nil do begin
        if tn.HasChildren then
            tn.expand(true);
        tn := tn.getNextSibling;
    end;

    for i := 0 to pcPanels.PageCount - 1 do begin
        pcPanels.Pages[i].TabVisible := false;
    end;

    // click the first node by default
    tvOptions.Selected := tvOptions.Items.GetFirstNode;
    tvOptions.HideSelection := false;
    //tvOptions.OnClick(self);

    self.ignorecollapse := true;
    tvOptions.FullCollapse;
    self.ignorecollapse := false;

	//FrmTriggerWindow := TFrmTriggerWindow.Create(application);
end;
procedure TFrmConfig.FormDestroy(Sender: TObject);
begin
    MyFree(HotKeyPopup);
    MyFree(TTHotKeyPopup);
    MyFree(PTTHotKeyPopup);
end;
procedure TFrmConfig.FormClose(Sender: TObject; var Action: TCloseAction);
begin
    self.HotkeyLoad;
end;
procedure TFrmConfig.FormHide(Sender: TObject);
begin
    frmPreviewPopup.Hide;
end;
procedure TFrmConfig.FormShow(Sender: TObject);
begin
    ShowWindow(Application.Handle, SW_HIDE);

    tsProgramOptionsShow(sender);
    tsClipboardBarShow(sender);


    tvOptions.Selected := tvOptions.Items[pcPanels.ActivePageIndex];
    Self.UpdateColorExample;

end;


function TFrmConfig.GetTXTProgram : string;
begin
    result := fTXTProgram;
end;

function TFrmConfig.GetBMPProgram : string;
begin
    result := fBMPProgram;
end;
procedure TFrmConfig.ReportTXTProgram(s : string);
begin
    if fTXTProgram = '' then begin
        fTXTProgram := s;
    end;
end;
procedure TFrmConfig.ReportBMPProgram(s : string);
begin
    if fBMPProgram = '' then begin
        fBMPProgram := s;
    end;

end;



function TFrmConfig.GetMimicDelayMS : integer;
begin
    result := self.MimicDelayMS;
end;

function TFrmConfig.GetHotKeyID: integer;
begin
    result := HotKeyPopup.GetID;
end;
function TFrmConfig.GetTTHotKeyID: integer;
begin
    result := -1;
    if TTHotKeyPopup <> nil then
        result := TTHotKeyPopup.GetID;
end;
function TFrmConfig.GetPTTHotKeyID: integer;
begin
    result := -1;
    if PTTHotKeyPopup <> nil then
        result := PTTHotKeyPopup.GetID;
end;

function TFrmConfig.GetRightClickDelay: integer;
begin
    result := self.RightClickDelay;
end;
function TFrmConfig.GetRightclickTriggerWarned: boolean;
begin
    result := self.RightclickTriggerWarned;
end;

function TFrmConfig.GetAccelAlphaNumeric: string;
begin
	result := alphanumerickeys; 
end;
function TFrmConfig.GetAccelSymbols: string;
begin
	result := symbolkeys;
end;

function TFrmConfig.GetCtrlClickAction: TClickAction;
begin
    result := TClickAction(cbxCtrlClickAction.ItemIndex);
end;
function TFrmConfig.GetShiftClickAction: TClickAction;
begin
    result := TClickAction(cbxShiftClickAction.ItemIndex);
end;
function TFrmConfig.GetMiddleClickAction : TClickAction;
begin
    result := TClickAction(cbxMiddleClickAction.ItemIndex);
end;
function TFrmConfig.GetAltClickAction : TClickAction;
begin
    result := TClickAction(cbxAltClickAction.ItemIndex);
end;

function TFrmConfig.GetPasteDelay: integer;
begin
    result := self.PasteDelay;
end;

function TFrmConfig.GetPlaintextHokeyID: integer;
begin
    result := -1;
    if PlainTextHotKey <> nil then
        result := PlainTextHotKey.GetID;
end;

function TFrmConfig.GetHumanReadableHotkey : string;
var b : boolean;
begin
    result := '';
    if assigned(frmhotkey) then

    result := FrmHotkey.GetHumanReadable(Hotkey_alt, Hotkey_shift, Hotkey_ctrl, Hotkey_winkey, Hotkey_key, b);
end;
function TFrmConfig.GetHumanReadableTTHotkey : string;
var b : boolean;
begin
    result := FrmHotkey.GetHumanReadable(TTHotkey_alt, TTHotkey_shift, TTHotkey_ctrl, TTHotkey_winkey, TTHotkey_key, b);
end;
function TFrmConfig.GetHumanReadablePTTHotkey: string;
var b : boolean;
begin
    result := FrmHotkey.GetHumanReadable(PTTHotkey_alt, PTTHotkey_shift, PTTHotkey_ctrl, PTTHotkey_winkey, PTTHotkey_key, b);
end;
function TFrmConfig.GetHumanReadablePlaintextHotkey: string;
var b : boolean;
begin
    result := FrmHotkey.GetHumanReadable(
        PlainTextData.alt,
        PlainTextData.shft,
        PlainTextData.ctrl,
        PlainTextData.win,
        PlainTextData.key,
        b
    );
end;

function TFrmConfig.ClipboardBarSetVisible: boolean;
begin
    result := self.ClipboardBarVisible;
end;
function TFrmConfig.CopySelectedForPopup: boolean;
begin
    result := self.CopySelected;
end;

function TFrmConfig.GetPreCaptureDelayMS: integer;
begin
    result := PreCaptureDelayMS;
end;

function TFrmConfig.GetFont: TFont;
begin
    result := tempFont;
end;

function TFrmConfig.GetINIFileName: string;
begin
    Result := UnitMisc.GetAppPath + 'arsclip.ini';
end;
function TFrmConfig.GetNewClipWav: string;
begin
    result := self.sound_newclip;
end;
function TFrmConfig.GetOldTrayPopup: boolean;
begin
    result := self.OldTrayPopup;
end;

procedure TFrmConfig.FormActivate(Sender: TObject);
begin
    self.UpdateColorExample;
end;

function TFrmConfig.FormatCount: integer;
var i : integer;
begin
    result := 0;
    for i := 0 to lvFormats.Items.count - 1 do begin
        if lvFormats.Items[i].Checked then inc(result);
    end;
end;
function TFrmConfig.GetFormat(index: integer): FormatOrder;

var i, j : integer;
    s : string;
begin
    result := FO_UNICODE;
    // find the index of the N-th checked item
    j := -1;
    for i := 0 to lvFormats.Items.count - 1 do begin
        if lvFormats.Items[i].Checked then inc(j);
        if j = index then begin
            j := i;
            BREAK;
        end;
    end;


    if (j <> -1) then begin
        s := lvFormats.Items[j].Caption;
        result := FO_UNICODE;
        if s = 'Unicode' then result := FO_UNICODE;
        if s = 'RichText' then result := FO_RICHTEXT;
        if s = 'HTML' then result := FO_HTML;
    end;
end;

const ArsClip = 'ArsClip';
procedure TFrmConfig.HotkeySave;
var ini: TInifile;
    i : integer;
begin
    ini := TInifile.Create( self.GetINIFileName );



    //
    // Hotkey Panel
    //
    ini.WriteInteger(ArsClip,'Hotkey_Key', Hotkey_Key);
    ini.WriteBool(ArsClip,'Hotkey_Alt', Hotkey_Alt);
    ini.WriteBool(ArsClip,'Hotkey_Shift', Hotkey_Shift);
    ini.WriteBool(ArsClip,'Hotkey_Ctrl', Hotkey_Ctrl);
    ini.WriteBool(ArsClip,'Hotkey_Winkey', Hotkey_Winkey);

    ini.WriteBool(ArsClip,'UseTooltipHotkey', cbUseTooltipHotkey.Checked );
    ini.WriteInteger(ArsClip,'TTHotkey_Key', TTHotkey_Key);
    ini.WriteBool(ArsClip,'TTHotkey_Alt', TTHotkey_Alt);
    ini.WriteBool(ArsClip,'TTHotkey_Shift', TTHotkey_Shift);
    ini.WriteBool(ArsClip,'TTHotkey_Ctrl', TTHotkey_Ctrl);
    ini.WriteBool(ArsClip,'TTHotkey_Winkey', TTHotkey_Winkey);

    ini.WriteInteger(ArsClip,'PTTHotkey_Key', PTTHotkey_Key);
    ini.WriteBool(ArsClip,'PTTHotkey_Alt', PTTHotkey_Alt);
    ini.WriteBool(ArsClip,'PTTHotkey_Shift', PTTHotkey_Shift);
    ini.WriteBool(ArsClip,'PTTHotkey_Ctrl', PTTHotkey_Ctrl);
    ini.WriteBool(ArsClip,'PTTHotkey_Winkey', PTTHotkey_Winkey);


    ini.WriteInteger(ArsClip, 'PlainTextData_key', PlainTextData.key);
    ini.WriteBool(ArsClip, 'PlainTextData_alt', PlainTextData.alt);
    ini.WriteBool(ArsClip, 'PlainTextData_shft', PlainTextData.shft);
    ini.WriteBool(ArsClip, 'PlainTextData_ctrl', PlainTextData.ctrl);
    ini.WriteBool(ArsClip, 'PlainTextData_win', PlainTextData.win);

//    ini.WriteBool('ArsClip',cbHighlightMove.Name, cbHighlightMove.Checked);

    //----------
    //'Popup' panel

    ini.WriteBool(Arsclip, 'MoveSelectedToFirst', cbMoveFirst.Checked );


    if (cbUseKeyboard.Checked) then begin
        ini.WriteString(ArsClip, 'PopupUseKeyboard', 'Y');
    end else begin
        ini.WriteString(ArsClip, 'PopupUseKeyboard', 'N');
    end;
    //ini.WriteInteger(ArsClip, 'CharactersToShow', udCharacters.position);
    //ini.WriteBool(ArsClip, cbDisplayUnicode.Name, cbDisplayUnicode.checked );
    ini.WriteBool(ArsClip, cbAutoExpand.Name, cbAutoExpand.Checked);
	ini.WriteBool(ArsClip, cbAutoCollapse.Name, cbAutoCollapse.Checked);


    ini.WriteBool(Arsclip, 'PopupDoubleclick', cbPopupDoubleclick.checked);
    ini.WriteBool(Arsclip, 'PopupDoubleclickTray', cbPopupDoubleclickTray.checked);
    ini.WriteBool(Arsclip, cbPopupSingleclickTray.Name, cbPopupSingleclickTray.checked);
    ini.WriteBool(Arsclip, cbPopupSingleclick.Name, cbPopupSingleclick.Checked);

    // Hotkey Alternatives / Keystrokes

    ini.WriteInteger(ArsClip, cbxShiftClickAction.Name, cbxShiftClickAction.ItemIndex);
    ini.WriteInteger(ArsClip, cbxCtrlClickAction.Name, cbxCtrlClickAction.ItemIndex);
    ini.WriteInteger(ArsClip, cbxMiddleClickAction.Name, cbxMiddleClickAction.ItemIndex);
    ini.WriteInteger(ArsClip, cbxAltClickAction.Name, cbxAltClickAction.ItemIndex);

    ini.WriteBool(ArsClip, cbPopupCharLimit.name, cbPopupCharLimit.Checked);
    ini.WriteInteger(ArsClip, udPopupKeysLimit.Name, udPopupKeysLimit.position);
    ini.WriteBool(ArsClip, cbPinnedShortcuts.Name, cbPinnedShortcuts.Checked);


//    ini.WriteInteger(ArsClip, 'CopyClickKey', cboCopyClickKey.ItemIndex  );
//    ini.WriteInteger(ArsClip, 'PermanentClickKey', cboPermanentClickKey.ItemIndex );
//    ini.WriteInteger(ArsClip, 'MimicClickKey', cboMimicClickKey.ItemIndex );
//    ini.WriteBool(ArsClip, rbCtrlClickRun.Name, rbCtrlClickRun.Checked );
//    ini.WriteBool(ArsClip, rbCtrlClickMenu.Name, rbCtrlClickMenu.Checked );
    ini.WriteBool(ArsClip, cbRightTriggerEnable.Name, cbRightTriggerEnable.checked);
    ini.WriteInteger(ArsClip, cbxMouseButton.Name, cbxMouseButton.ItemIndex);
    ini.WriteBool(ArsClip, cbEditClipWindow.Name, cbEditClipWindow.checked);


    //


    if (cbDisable.Checked) then begin
        ini.WriteString(ArsClip, 'DisableMonitoring', 'Y');
    end else begin
        ini.WriteString(ArsClip, 'DisableMonitoring', 'N');
    end;
    ini.WriteBool(ArsClip, cbShowAllAsSubmenus.Name, cbShowAllAsSubmenus.checked);
    ini.WriteBool(ArsClip, 'DisableWhenScrollLock', cbDisableWhenScrollLock.checked);

    ini.WriteBool(ArsClip, 'DisableSystemTrayIconNotification', cbDisableSystemTrayIconNotification.Checked   );
    ini.WriteBool(ArsClip, cbDisableChainNotification.name, cbDisableChainNotification.checked );
    ini.WriteBool(ArsClip, cbEnableExtendedChainChecking.Name, cbEnableExtendedChainChecking.Checked);
    ini.WriteBool(ArsClip, cbDisableWatcher.name, cbDisableWatcher.checked );

    ini.WriteBool(ArsClip, cbSearchDefault.Name, cbSearchDefault.Checked);


    ini.WriteBool(ArsClip, cbDontCopySelectedForAll.name, cbDontCopySelectedForAll.Checked);



    ini.WriteString(ArsClip, 'LastPermanentPath', frmPermanent.GetPermanentPath);

    ini.WriteBool(ArsClip,'ShowPermanentItemGroups', cbShowPermanentItemGroups.checked );
    ini.WriteBool(ArsClip, 'ShowPermanentItemSubmenu', cbPermanentItemsSubmenu.Checked );
    //ini.WriteBool(ArsClip, 'ShowFormMode', cbShowFormMode.Checked);


    //
    // Pasting Options
    //
    if (rbTyping.Checked) then begin
        ini.WriteString(ArsClip,'PasteMethod', 'MimicTyping');
    end else if (rbPaste.checked) then begin
        ini.WriteString(ArsClip, 'PasteMethod', 'CTRL+V');
    end else if (rbPasteSI.Checked) then begin
        ini.WriteString(ArsClip, 'PasteMethod', 'SHIFT+INSERT');
    end else begin
        ini.WriteString(ArsClip, 'PasteMethod', 'ClipboardOnly');
    end;
//    ini.WriteBool(ArsClip, cbPasteComplex.Name, cbPasteComplex.Checked);

    ini.WriteBool(ArsClip, rbPlainAndFormatted.Name, rbPlainAndFormatted.Checked);
    ini.WriteBool(ArsClip, rbFormattedOnly.Name, rbFormattedOnly.Checked);
    ini.WriteBool(ArsClip, rbPlainOnly.Name, rbPlainOnly.Checked);


    // clipboard
    ini.WriteBool(ArsClip, 'RememberHistory', cbRemember.checked);
    //ini.WriteBool(ArsClip, 'ShowEditHistory', cbShowEditHistory.Checked);
    //ini.WriteBool(ArsClip, cbShowTypes.Name, cbShowTypes.checked);
    ini.WriteBool(ArsClip, cbAutofixURLs.Name, cbAutofixURLs.Checked);
    ini.WriteBool(ArsClip, cbShowAllItems.Name, cbShowAllItems.checked);
//    ini.WriteBool(ArsClip, cbExecuteClip.Name, cbExecuteClip.Checked);
//    ini.WriteString(ArsClip, lblPermClip.Name, lblPermClip.Caption);

//
//     History
//
    ini.WriteInteger(ArsClip, 'RemovedItemsSize', udRemovedSize.Position);
    RemovedQueue.SetQueueSize(udRemovedSize.position);
    ini.WriteInteger(ArsClip, udRecentlyRemoved.Name, udRecentlyRemoved.Position);
    UnitClipQueue.TempClipQueue.SetQueueSize(udRecentlyRemoved.Position);
    UnitClipQueue.ResyncTempClipQueue;
    ini.WriteInteger(ArsClip, 'QueueSize', udQueueSize.position);
    ClipQueue.SetQueueSize(udQueueSize.position);




    ini.WriteBool(ArsClip, 'MonitorFilenames', cbMonitorFilenames.checked);
    ini.WriteBool(ArsClip, 'MoveDuplicate', cbMoveDuplicate.checked );
    ini.writeBool(ArsClip, cbRemoveFormat.name, cbRemoveFormat.checked );
    ini.WriteBool(ArsClip, cbCaseSensitive.name, cbCaseSensitive.checked);
    ini.WriteBool(ArsClip, cbIgnoreSmallText.name, cbIgnoreSmallText.checked);
    ini.WriteBool(ArsClip, cbDontCopyLargeText.name, cbDontCopyLargeText.checked);
    ini.WriteInteger(ArsClip, txtTextSizeLimitKB.name, StrToInt(txtTextSizeLimitKB.text));

    for i := 0 to lvFormats.items.Count - 1 do begin
        ini.WriteString(ArsClip, lvFormats.name  + IntToStr(i) , lvFormats.Items[i].Caption);
        ini.WriteBool(ArsClip, lvFormats.name  + IntToStr(i) + 'checked' , lvFormats.Items[i].checked);
    end;

    //self.CopySelected := false;
    for i := ord(low(TMenuOrderType)) to ord(high(TMenuOrderType)) do begin
        ini.DeleteKey(ArsClip, LVORDER_ID +  lvOrder.name  + IntToStr(i) + 'data');
		ini.DeleteKey(ArsClip, LVORDER_ID +  lvOrder.name  + IntToStr(i) + 'sub');
		ini.DeleteKey(ArsClip, LVORDER_ID +  lvOrder.name  + IntToStr(i) + 'checked');
    end;

    self.CopySelected := false;
    for i := 0 to lvOrder.items.Count - 1 do begin
        {if TMenuOrderType(lvOrder.Items[i].data) = MOT_SELECTED then
            self.CopySelected := lvOrder.Items[i].Checked;}
        ini.WriteInteger(ArsClip, LVORDER_ID +  lvOrder.name  + IntToStr(i) + 'data' , Integer(lvOrder.Items[i].data));
        ini.WriteString(ArsClip, LVORDER_ID + lvOrder.name  + IntToStr(i) + 'sub' , lvOrder.Items[i].SubItems[0]);
        ini.WriteBool(ArsClip, LVORDER_ID + lvOrder.name  + IntToStr(i) + 'checked', lvOrder.Items[i].Checked);
    end;

    //-------------------
    // Non-text items
    //-------------------
    ini.WriteBool(ArsClip,'EnableOtherItems', cbOtherItems.Checked);
//    ini.WriteInteger(ArsClip, 'OtherSize', udOtherSize.Position);
    ini.WriteInteger(ArsClip,'OtherSizeLimitKB', StrToInt(txtOtherSizeLimitKB.text));
    ini.WriteBool(ArsClip,cbAlwaysPicture.Name, cbAlwaysPicture.Checked);
//    if (rbOtherPaste.Checked) then begin
//        ini.WriteString(ArsClip, 'OtherPasteMethod', 'CTRL+V' );
//    end else begin
//        ini.WriteString(ArsClip, 'OtherPasteMethod',  'ClipboardOnly');
//    end;

//    ini.WriteBool(ArsClip, cbSeparateNontextList.Name, cbSeparateNontextList.Checked);

    //-------------
    // Tooltip
    //-------------
    ini.WriteBool(ArsClip,'FullHeader', cbFullHeader.Checked);
    ini.WriteBool(ArsClip,'CopyVisibleItem', cbCopyVisibleItem.Checked);

    // Tooltip Hint
    ini.WriteInteger(ArsClip, UDToolHeight.Name, UDToolHeight.Position);
    ini.WriteInteger(ArsClip, UDToolWidth.Name, UDToolWidth.Position);
    ini.WriteInteger(ARsClip, tbTooltipDelay.Name, tbTooltipDelay.Position);
    ini.WriteBool(ArsClip, cbSystemTrayTooltip.Name, cbSystemTrayTooltip.Checked);
    ini.WriteBool(ArsClip, cbTooltipRichText.Name, cbTooltipRichText.Checked);
    ini.WriteBool(ArsClip, cbShowHeaderFooter.Name, cbShowHeaderFooter.Checked);



    Ini.WriteBool(ArsClip,'EnableSound', cbEnableSound.Checked);
    //lblKeyname.Caption := self.GetHumanReadableHotkey;


    // Show Options
    ini.WriteInteger(ArsClip, UDWidth.Name, udWidth.Position);
    ini.WriteInteger(ArsClip, udMinHeight.Name, udMinHeight.Position);
    ini.WriteBool(ArsClip,cbDoubleHeight.Name, cbDoubleHeight.checked);
    ini.WriteBool(ArsClip, 'CopyIcons', cbCopyIcons.checked);
    ini.WriteBool(ArsClip, cbDisplayAtMouseCursor.Name, cbDisplayAtMouseCursor.checked);
//    ini.WriteBool(ArsClip, cbShowEditInstead.Name, cbShowEditInstead.checked);
    ini.WriteBool(ArsClip, cbShowEmptyMenus.Name, cbShowEmptyMenus.checked);
    ini.WriteBool(ArsClip, cbNoThumbnails.Name, cbNoThumbnails.checked);


    ini.WriteBool(ArsClip, cbFontColor.Name, cbFontColor.checked);
    ini.WriteBool(ArsClip, cbBackgroundColor.Name, cbBackgroundColor.checked);
    ini.WriteBool(ArsClip, cbHighlightColor.Name, cbHighlightColor.checked);
    ini.WriteBool(ArsClip, cbClickedColor.Name, cbClickedColor.checked);

    ini.WriteInteger(ArsClip, pnlFontColor.Name, pnlFontColor.color);
    ini.WriteInteger(ArsClip, pnlBackgroundColor.Name, pnlBackgroundColor.color);
    ini.WriteInteger(ArsClip, pnlHighlightColor.Name, pnlHighlightColor.color);
    ini.WriteInteger(ArsClip, pnlClickedColor.Name, pnlClickedColor.color);

    // Clip Sets
    ini.WriteInteger(ArsClip, udClipsPerSet.Name, udClipsPerSet.Position);
    ini.WriteBool(ArsClip, cbEnableClipSets.name, cbEnableClipSets.checked);
    ini.WriteBool(ArsClip, cbEnableClipsSetsWhenTall.Name, cbEnableClipsSetsWhenTall.checked);


    // trigger window
    ini.WriteBool(ArsClip, cbTriggerWindow.Name, cbTriggerWindow.Checked);
    ini.WriteInteger(ArsClip, tbDelay.name, tbdelay.Position);
    ini.writebool(ArsClip, sbtop.name, sbtop.down);
    ini.writebool(ArsClip, sbbottom.name, sbbottom.down);
    ini.writebool(ArsClip, sbleft.name, sbleft.down);
    ini.writebool(ArsClip, sbright.name, sbright.down);
    ini.writebool(ArsClip, sbtopleft.name, sbtopleft.down);
    ini.writebool(ArsClip, sbtopright.name, sbtopright.down);
    ini.writebool(ArsClip, sbbottomleft.name, sbbottomleft.down);
    ini.writebool(ArsClip, sbbottomright.name, sbbottomright.down);

    // JumpList
    ini.WriteInteger(ArsClip, cbxClickedAction.Name, cbxClickedAction.ItemIndex);

    //
    // CLipboard Bar
    //

    ini.WriteBool(ArsClip, cbShowPopupWhenClicked.name, cbShowPopupWhenClicked.checked);
    ini.WriteBool(ArsClip, cbShowTooltipOnHover.name, cbShowTooltipOnHover.checked);
    ini.WriteInteger(ArsClip, udNormalOpacity.Name, udNormalOpacity.Position);
    if assigned(frmClipboardBar) then begin
        frmClipboardBar.NormalOpacity := udNormalOpacity.Position;
    end;
    //'''

    //-----------
    // no visible control
    ini.WriteInteger(ArsClip,'RightClickDelay', self.RightClickDelay);
    ini.WriteBool(ArsClip, 'RightclickTriggerWarned', self.RightclickTriggerWarned);
    ini.WriteInteger(ArsClip,'PasteDelay', self.PasteDelay);

//    ini.WriteString(ArsClip, 'TXTProgram', self.fTXTProgram);
//    ini.WriteString(ArsClip, 'BMPProgram', self.fBMPProgram);


    //
    // Sound
    //

    ini.WriteString('Sound','NewClip',self.Sound_NewClip);

    MyFree(ini);

end;
procedure TFrmConfig.HotkeyLoad;
var ini: TInifile;
    s : string;
    data : integer;
    i, j,k,m : integer;
    c : cardinal;
    fs : TFontStyles;

    showorderfound : array[TMenuOrderType] of boolean;
    li : TListItem;


    procedure CopyLI(dest, src : TListItem);
    begin
        dest.caption := src.caption;
        dest.SubItems.Clear;
        dest.SubItems.AddStrings(src.SubItems);
        dest.checked := src.Checked;
        dest.Data := src.data;
    end;
const ACCEL_SECTION  = 'Acellerators';
begin
    isLoading := true;
    try
    AppendLog('HotkeyLoad - start');
    //
    // read last assigned hotkey
    // CTRL+SHIFT+Z is default
    //
    // fake the user selecting the Modifier and the Normal Key

    ini := TInifile.Create( self.GetINIFileName );

    tempFont.Name := ini.ReadString('Font','Name', 'Arial');
    tempFont.Charset := ini.ReadInteger('Font','CharSet', self.Font.Charset);
    tempFont.Color := ini.ReadInteger('Font','Color', self.Font.Color);
    tempFont.Size := ini.ReadInteger('Font','Size', self.Font.Size);

    if not ini.ValueExists(ACCEL_SECTION, 'Symbols') then begin
    	ini.WriteString(ACCEL_SECTION, 'Symbols', '-=[]\;'',./~!@#$%^&*()_+{}|:"<>?`');
    end;
    if not ini.ValueExists(ACCEL_SECTION, 'AlphaNumeric') then begin
    	ini.WriteString(ACCEL_SECTION, 'AlphaNumeric', '1234567890ABCDEFGHIJKLMNOPQRSTUVWXYZ');
    end;
    alphanumerickeys := ini.ReadString(ACCEL_SECTION,'AlphaNumeric','');
    symbolkeys := ini.ReadString(ACCEL_SECTION,'Symbols','');


    c := ini.ReadInteger('Font','Style',0);
    move(c, fs, 4);
    tempFont.Style := fs;

    FontDialog.Font := tempFont;
    //tempFont:= FrmDummyUnicodePopup.Font;


    // hidden settings
    self.PreCaptureDelayMS := ini.ReadInteger(ArsClip,'PreCaptureDelay', 50);
    ini.WriteInteger(ArsClip,'PreCaptureDelay', self.PreCaptureDelayMS);
    self.RightClickDelay := ini.ReadInteger(ArsClip,'RightClickDelay', 600);
    self.RightClickDelay := max(200, self.RightClickDelay);
    ini.WriteInteger(ArsClip,'RightClickDelay', self.RightClickDelay);
    self.OldTrayPopup := ini.ReadBool(ArsClip, 'OldTrayPopup', false);
    ini.WriteBool(ArsClip,'OldTrayPopup', self.OldTrayPopup);
    self.MimicDelayMS := ini.ReadInteger(ArsClip,'MimicDelayMS', 10);
    ini.WriteInteger(ArsClip, 'MimicDelayMS', self.MimicDelayMS);

    self.fTXTProgram := ini.ReadString(ArsClip,'TXTProgram','');
    if fTXTProgram = '' then begin
        fTXTProgram := UnitMisc.GetAssociation('test.txt');
        if fTXTProgram = '' then begin
            fTXTProgram := UnitMisc.GetAssociation('test.txt','edit');
        end;

        ini.WriteString(ArsClip, 'TXTProgram',
            ReplaceStr(self.fTXTProgram,'"','\"')
        );
    end else begin
        self.fTXTProgram := ReplaceStr(self.fTXTProgram,'\"','"');
    end;

    self.fBMPProgram := ini.ReadString(ArsClip,'BMPPRogram','');
    if fBMPProgram = '' then begin
        fBMPProgram := UnitMisc.GetAssociation('test.bmp');
        if fBMPProgram = '' then begin
            fBMPProgram := UnitMisc.GetAssociation('test.bmp','edit');
        end;
        ini.WriteString(ArsClip, 'BMPProgram', ReplaceStr(self.fBMPProgram,'"','\"'));
    end else begin
        self.fBMPProgram := ReplaceStr(self.fBMPProgram,'\"','"');
    end;




    //----------
    // HotKey
    //----------
    Hotkey_Key := ini.ReadInteger(ArsClip,'Hotkey_Key', Ord('Z'));
    Hotkey_Alt := ini.ReadBool(ArsClip,'Hotkey_Alt', false);
    Hotkey_Shift := ini.ReadBool(ArsClip,'Hotkey_Shift', true);
    Hotkey_Ctrl := ini.ReadBool(ArsClip,'Hotkey_Ctrl', true);
    Hotkey_Winkey := ini.ReadBool(ArsClip,'Hotkey_Winkey', false);

    cbUseTooltipHotkey.Checked := ini.ReadBool(ArsClip,'UseTooltipHotkey',false);
    TTHotkey_Key := ini.ReadInteger(ArsClip,'TTHotkey_Key', Ord('X'));
    TTHotkey_Alt := ini.ReadBool(ArsClip,'TTHotkey_Alt', false);
    TTHotkey_Shift := ini.ReadBool(ArsClip,'TTHotkey_Shift', true);
    TTHotkey_Ctrl := ini.ReadBool(ArsClip,'TTHotkey_Ctrl', true);
    TTHotkey_Winkey := ini.ReadBool(ArsClip,'TTHotkey_Winkey', false);

    PTTHotkey_Key := ini.ReadInteger(ArsClip,'PTTHotkey_Key', Ord('C'));
    PTTHotkey_Alt := ini.ReadBool(ArsClip,'PTTHotkey_Alt', false);
    PTTHotkey_Shift := ini.ReadBool(ArsClip,'PTTHotkey_Shift', true);
    PTTHotkey_Ctrl := ini.ReadBool(ArsClip,'PTTHotkey_Ctrl', true);
    PTTHotkey_Winkey := ini.ReadBool(ArsClip,'PTTHotkey_Winkey', false);

    PlainTextData.key := ini.ReadInteger(ArsClip, 'PlainTextData_key', ord('X'));
    PlainTextData.alt := ini.ReadBool(ArsClip, 'PlainTextData_alt', false);
    PlainTextData.shft := ini.ReadBool(ArsClip, 'PlainTextData_shft', false);
    PlainTextData.ctrl := ini.ReadBool(ArsClip, 'PlainTextData_ctrl', false);
    PlainTextData.win := ini.ReadBool(ArsClip, 'PlainTextData_win', true);

//    cbHighlightMove.Checked := ini.ReadBool('ArsClip',cbHighlightMove.Name, false);

    //----------------
    // 'Popup' panel
    //----------------
    cbMoveFirst.Checked := ini.ReadBool(ArsClip, 'MoveSelectedToFirst', false);
    cbUseKeyboard.Checked := (ini.ReadString(ArsClip,'PopupUseKeyboard', 'Y') = 'Y');
    cbPopupDoubleclick.checked := ini.ReadBool(Arsclip, 'PopupDoubleclick', false);
    cbPopupDoubleclickTray.checked := ini.ReadBool(Arsclip, 'PopupDoubleclickTray', false);
    //udCharacters.position := ini.ReadInteger(ArsClip, 'CharactersToShow', 30);
    //frmMainPopup.SetVisibleCharacterCount(udCharacters.position);

    cbAutoExpand.Checked := ini.readBool(ArsClip, cbAutoExpand.Name, false);
	cbAutoCollapse.Checked := ini.readBool(ArsClip, cbAutoCollapse.Name, false);


    cbEditClipWindow.checked := ini.ReadBool(ArsClip, cbEditClipWindow.Name, false);

    //
    // Hotkey Alternatives / Keystrokes
    //

    cbxShiftClickAction.ItemIndex := ini.ReadInteger(ArsClip, cbxShiftClickAction.Name, cbxShiftClickAction.ItemIndex);
    cbxCtrlClickAction.ItemIndex := ini.ReadInteger(ArsClip, cbxCtrlClickAction.Name, cbxCtrlClickAction.ItemIndex);
    cbxMiddleClickAction.ItemIndex := ini.ReadInteger(ArsClip, cbxMiddleClickAction.Name, cbxMiddleClickAction.ItemIndex);
    cbxAltClickAction.ItemIndex := ini.ReadInteger(ArsClip, cbxAltClickAction.Name, cbxAltClickAction.ItemIndex);

    cbPopupCharLimit.Checked := ini.ReadBool(ArsClip, cbPopupCharLimit.name, cbPopupCharLimit.Checked);
    udPopupKeysLimit.Position := ini.ReadInteger(ArsClip, udPopupKeysLimit.Name, udPopupKeysLimit.position);
    cbPinnedShortcuts.Checked := ini.ReadBool(ArsClip, cbPinnedShortcuts.Name, true);


//    cboCopyClickKey.ItemIndex :=  ini.ReadInteger(ArsClip, 'CopyClickKey', 0 );
//    cboPermanentClickKey.ItemIndex :=  ini.ReadInteger(ArsClip, 'PermanentClickKey', 1);
//    cboMimicClickKey.ItemIndex := ini.ReadInteger(ArsClip, 'MimicClickKey', 2 );
//    rbCtrlClickRun.Checked := false;
//    rbCtrlClickMenu.Checked := false;
//    rbCtrlClickRun.Checked := ini.ReadBool(ArsClip, rbCtrlClickRun.Name, false);
//    rbCtrlClickMenu.Checked := ini.ReadBool(ArsClip, rbCtrlClickMenu.name, true );
    //cbDisplayUnicode.checked := ini.ReadBool(ArsClip, cbDisplayUnicode.Name,  false);
    //cbDisplayUnicode.checked := true;
    cbDisplayAtMouseCursor.checked :=ini.ReadBool(ArsClip, cbDisplayAtMouseCursor.Name, false);

    cbPopupSingleclickTray.checked := ini.ReadBool(Arsclip, cbPopupSingleclickTray.Name, false);
    cbPopupSingleclick.Checked := ini.ReadBool(Arsclip, cbPopupSingleclick.Name, false);
    udWidth.Position := ini.ReadInteger(ArsClip, UDWidth.Name, 320);
    udMinHeight.Position := ini.ReadInteger(ArsClip, udMinHeight.Name, 16);
    cbRightTriggerEnable.Checked := ini.readbool(ArsClip, cbRightTriggerEnable.Name, true);
    cbxMouseButton.ItemIndex := ini.ReadInteger(ArsClip, cbxMouseButton.Name, 0);

//    self.cboCopyClickKeyClick(self);
//    self.cboPermanentClickKeyClick(self);
//    self.cboMimicClickKeyClick(self);
    self.cbRightTriggerEnableClick(self);
    // setting the ItemIndex doesn't auto set of any event

    //-------------------
    // Show Options
    //-------------------

    cbDoubleHeight.checked := ini.ReadBool(ArsClip, cbDoubleHeight.name, false);
    //cbShowEditHistory.checked := ini.ReadBool(ArsClip,'ShowEditHistory', false);
    //txtRecentlyRemoved.Text := IntToStr(udRecentlyRemoved.Position);
//    cbShowEditInstead.checked := ini.ReadBool(ArsClip, cbShowEditInstead.Name, false);
    cbShowEmptyMenus.checked := ini.ReadBool(ArsClip, cbShowEmptyMenus.Name, true);
    cbShowPermanentItemGroups.checked := ini.ReadBool(ArsClip,'ShowPermanentItemGroups', true );
    cbPermanentItemsSubmenu.checked := ini.Readbool(ArsClip,'ShowPermanentItemSubmenu', false);
    //cbShowFormMode.Checked := ini.ReadBool(ArsClip, 'ShowFormMode', false);
    //cbShowTypes.checked  := ini.ReadBool(ArsClip, cbShowTypes.Name, true);
    //cbShowTypes.checked := false;
    cbShowAllItems.checked := ini.ReadBool(ArsClip, cbShowAllItems.Name, true);
    cbShowAllAsSubmenus.checked := ini.ReadBool(ArsClip, cbShowAllAsSubmenus.Name, false);
    cbSearchDefault.Checked := ini.ReadBool(ArsClip, cbSearchDefault.Name, true);
    cbNoThumbnails.checked := ini.ReadBool(ArsClip, cbNoThumbnails.Name, false);

    cbFontColor.checked := ini.Readbool(ArsClip, cbFontColor.Name, false);
    cbBackgroundColor.checked := ini.Readbool(ArsClip, cbBackgroundColor.Name, false);
    cbHighlightColor.checked := ini.Readbool(ArsClip, cbHighlightColor.Name, false);
    cbClickedColor.Checked := ini.Readbool(ArsClip, cbClickedColor.Name, false);

    pnlFontColor.color :=  ini.readInteger(ArsClip, pnlFontColor.Name, pnlFontColor.color);
    pnlBackgroundColor.color := ini.readInteger(ArsClip, pnlBackgroundColor.Name, pnlBackgroundColor.color);
    pnlHighlightColor.color := ini.readInteger(ArsClip, pnlHighlightColor.Name, pnlHighlightColor.color);
    pnlClickedColor.color := ini.readInteger(ArsClip, pnlClickedColor.Name, pnlClickedColor.color);

    UpdateColorExample;

    //
    // Clip Sets
    //

    udClipsPerSet.Position := ini.ReadInteger(ArsClip, udClipsPerSet.Name, udClipsPerSet.Position);
    cbEnableClipSets.checked := ini.ReadBool(ArsClip, cbEnableClipSets.name, cbEnableClipSets.checked);
    cbEnableClipsSetsWhenTall.checked := ini.ReadBool(ArsClip, cbEnableClipsSetsWhenTall.Name, cbEnableClipsSetsWhenTall.checked);


    //-------------------
    // Pasting
    //-------------------
    rbTyping.Checked := ini.ReadString(ArsClip, 'PasteMethod', 'CTRL+V') = 'MimicTyping';
    rbPaste.Checked := ini.ReadString(ArsClip, 'PasteMethod', 'CTRL+V') = 'CTRL+V';
    rbClipboardOnly.checked := ini.ReadString(ArsClip, 'PasteMethod', 'CTRL+V') = 'ClipboardOnly';
    rbPasteSI.Checked := ini.ReadString(ArsClip, 'PasteMethod', 'CTRL+V') = 'SHIFT+INSERT';
//    rbOtherClipboardOnly.Checked := ini.ReadString(ArsClip, 'OtherPasteMethod',  'ClipboardOnly') = 'ClipboardOnly';
//    rbOtherPaste.Checked := ini.ReadString(ArsClip, 'OtherPasteMethod',  'ClipboardOnly') = 'CTRL+V';
//    cbPasteComplex.Checked := ini.ReadBool(ArsClip, cbPasteComplex.Name, false);

    rbPlainAndFormatted.Checked := ini.ReadBool(ArsClip, rbPlainAndFormatted.Name, true);
    rbFormattedOnly.Checked := ini.ReadBool(ArsClip, rbFormattedOnly.Name, false);
    rbPlainOnly.Checked := ini.ReadBool(ArsClip, rbPlainOnly.Name, false);

    //-------------------
    // Clipboard
    //-------------------
    cbCopyIcons.Checked := ini.ReadBool(ArsClip,'CopyIcons', true);
    cbDisable.Checked := (ini.ReadString(ArsClip,'DisableMonitoring','N') = 'Y');
    cbDisableWhenScrollLock.Checked := ini.ReadBool(ArsClip, 'DisableWhenScrollLock', true);
    cbDisableSystemTrayIconNotification.Checked := ini.ReadBool(ArsClip,'DisableSystemTrayIconNotification', false);
    cbDisableChainNotification.checked := ini.ReadBool(ArsClip, cbDisableChainNotification.name,  false);
    cbEnableExtendedChainChecking.Checked := ini.ReadBool(ArsClip, cbEnableExtendedChainChecking.Name, false);
    cbAutofixURLs.Checked := ini.ReadBool(ArsClip, cbAutofixURLs.Name, false);
    cbDisableWatcher.checked := ini.ReadBool(ArsClip, cbDisableWatcher.name,  false);
    cbDontCopySelectedForAll.Checked := ini.ReadBool(ArsClip, cbDontCopySelectedForAll.name, True);

//    cbExecuteClip.Checked := ini.ReadBool(ArsClip, cbExecuteClip.Name, false);
//    lblPermClip.Caption := ini.ReadString(ArsClip, lblPermClip.Name, '[none]');

    //------------------------
    // Clipboard Non-text
    //------------------------

    cbOtherItems.Checked := ini.ReadBool(ArsClip,'EnableOtherItems', true);
    cbAlwaysPicture.Checked := ini.ReadBool(ArsClip,cbAlwaysPicture.Name, true);
    txtOtherSizeLimitKB.text := IntToStr(ini.ReadInteger(ArsClip,'OtherSizeLimitKB', 500));
//    cbSeparateNontextList.Checked := ini.ReadBool(ArsClip,cbSeparateNontextList.Name, false);
//    cbSeparateNontextList.Checked := false; // no longer used

    // Ect - util stuff
    // HuH? The "Other" config options above seem not to work
    txtOtherSizeLimitKB.OnChange(self);


    cbEnableSound.Checked := Ini.ReadBool(ArsClip,'EnableSound', False);
    PlaySound_Init;


    //
    // History
    //

    udRecentlyRemoved.Position := ini.ReadInteger(ArsClip, udRecentlyRemoved.Name, 5);
    udqueuesize.Position  := ini.ReadInteger(ArsClip, 'QueueSize', 15);
    udRemovedSize.Position := ini.ReadInteger(ArsClip, 'RemovedItemsSize', 50);
//    udOtherSize.Position := ini.ReadInteger(ArsClip, 'OtherSize', 5);

//    OtherQueue.SetQueueSize(udOtherSize.position);
    ClipQueue.SetQueueSize(udQueueSize.position);
    RemovedQueue.SetQueueSize(udRemovedSize.position);
    UnitClipQueue.ResyncTempClipQueue;


    //-----------------------
    // Clipboard Text
    //-----------------------

    cbMonitorFilenames.Checked :=  ini.ReadBool(ArsClip, 'MonitorFilenames', false);
    cbRemember.Checked := ini.ReadBool(ArsClip, 'RememberHistory', true);
    cbMoveDuplicate.checked := ini.ReadBool(ArsClip, 'MoveDuplicate', true);
    cbRemoveFormat.checked := ini.ReadBool(ArsClip, cbremoveformat.name, false);
    cbCaseSensitive.checked := ini.ReadBool(ArsClip, cbCaseSensitive.name, false);
    cbIgnoreSmallText.Checked := ini.ReadBool(ArsClip,cbIgnoreSmallText.name, false);
    cbDontCopyLargeText.checked := ini.ReadBool(ArsClip, cbDontCopyLargeText.name, false);
    txtTextSizeLimitKB.text := IntToStr(ini.ReadInteger(ArsClip, txtTextSizeLimitKB.name, StrToInt(txtTextSizeLimitKB.text)));

    s := '';
    i := 0;
    repeat
        s := ini.ReadString(ArsClip, lvFormats.name  + IntToStr(i) ,'');
        if s <> '' then begin
            lvFormats.Items[i].Caption := s;
            lvFormats.Items[i].checked := ini.ReadBool(ArsClip, lvFormats.name  + IntToStr(i) + 'checked', true);
        end;
        inc(i);
    until s = '';



    //------------------------
    //  Show Order
    //------------------------


    s := '';

    //self.CopySelected := false;

    // First, generate a list of all found items with their default states
    for i := ord(low(tmenuordertype)) to ord(high(tmenuordertype)) do begin
        showorderfound[tmenuordertype(i)] := false;
    end;
    for i := ord(low(tmenuordertype)) to ord(high(tmenuordertype)) do begin
        data := ini.ReadInteger(ArsClip, LVORDER_ID +  lvOrder.name  + IntToStr(i)+'data' ,-1);
        if (data <> -1) then begin
        	if TMenuOrderType(data) in [MOT_LAST, MOT_SELECTED] then CONTINUE;
            li := lvorder.FindCaption(0,self.MenuOrderText(TMenuOrderType(data),false),false,true,false);

            if li <> nil then begin
                showorderfound[tmenuordertype(data)] := true;
                defaultmenuorder[tmenuordertype(data)] := i;
                li.subitems[0] := ini.ReadString(ArsClip, LVORDER_ID + lvOrder.name  + IntToStr(i) + 'sub' , 'no');
                li.Checked := ini.ReadBool(ArsClip, LVORDER_ID +  lvOrder.name  + IntToStr(i) + 'checked', true);

                if TMenuOrderType(data) = MOT_SELECTED  then
                    self.CopySelected := lvOrder.Items[i].Checked;
            end;
        end;
    end;
    //
    // move all items to default positions
    // (basic bubble sort)
    for i := ord(low(tmenuordertype)) to ord(high(tmenuordertype)) {- 1} do begin
    	//if TMenuOrderType(i) in [MOT_LAST, MOT_SELECTED] then CONTINUE;
        li := lvorder.FindCaption(0,self.MenuOrderText(TMenuOrderType(i),false),false,true,false);
        if (li <> nil) and showorderfound[TMenuOrderType(i)] then begin
            k := Min(lvorder.Items.Count-1, DefaultMenuOrder[TMenuOrderType(i)]);

            j := li.Index;
            if (j>k) then begin
                for m := j downto k + 1 do begin
                    // swap m and (m-1)
                    li := lvOrder.Items.Add;
                    CopyLI(li, lvOrder.items[m]);
                    CopyLI(lvOrder.items[m], lvOrder.items[m-1]);
                    CopyLI(lvOrder.items[m-1], li);
                    lvOrder.Items.Delete(li.Index);
                end;
            end else if (j<k) then begin
                for m := j to k - 1 do begin
                    // swap m and (m-1)
                    li := lvOrder.Items.Add;
                    CopyLI(li, lvOrder.items[m]);
                    CopyLI(lvOrder.items[m], lvOrder.items[m+1]);
                    CopyLI(lvOrder.items[m+1], li);
                    lvOrder.Items.Delete(li.Index);
                end;

            end;
        end;
    end;

    li := lvorder.findcaption(0,self.MenuOrderText(MOT_LAST,false),false,true,false);
    if (li <> nil) then lvorder.Items.Delete(li.index);
    li := lvorder.findcaption(0,self.MenuOrderText(MOT_SELECTED,false),false,true,false);
    if (li <> nil) then lvorder.Items.Delete(li.index);


    cbUseKeyboard.OnClick(self);
    cbDisable.OnClick(self);

    frmPermanent.SetPermanentPath(ini.ReadString(ArsClip, 'LastPermanentPath', UnitFrmPermanentNew.DEFAULT_FOLDER));

    //------------------------
    //  Tooltip
    //------------------------
    cbFullHeader.Checked := ini.ReadBool(ArsClip,'FullHeader', true);
    cbCopyVisibleItem.Checked := ini.ReadBool(ArsClip,'CopyVisibleItem', false);


    //------------------------
    //  Tooltip Hint
    //------------------------

    UDToolHeight.Position := ini.ReadInteger(ArsClip, UDToolHeight.Name, 200);
    UDToolWidth.Position := ini.ReadInteger(ArsClip, UDToolWidth.Name, 320);
    tbTooltipDelay.Position := ini.ReadInteger(ARsClip, tbTooltipDelay.Name, 300);
    cbSystemTrayTooltip.Checked := ini.ReadBool(ArsClip, cbSystemTrayTooltip.Name, true);
    cbTooltipRichText.Checked := ini.ReadBool(ArsClip, cbTooltipRichText.Name, cbTooltipRichText.Checked);
    cbShowHeaderFooter.Checked := ini.ReadBool(ArsClip, cbShowHeaderFooter.Name, cbShowHeaderFooter.Checked);

    //
    // these are here because because there is no "onchange"
    // triggered when the control's state is changed
    //
//    if (rbOtherPaste.Checked) then begin
//        frmMainPopup.SetOtherPasteMethodPasting;
//    end else begin
//        FrmMainPopup.SetOtherPasteMethodClipboardOnly;
//    end;

    if rbTyping.checked then
        Paste.SetMimicTyping;

    if rbClipboardOnly.checked then
        Paste.SetClipboardOnly;

    if rbPaste.Checked then
        Paste.SetUsePaste;
    if rbPasteSI.Checked then
        Paste.SetUsePasteSI;

    lblKeyname.Caption := self.GetHumanReadableHotkey;
    lblTooltipKeyname.Caption := self.GetHumanReadableTTHotkey;
    lblPreviousTooltipKeyname.Caption := self.GetHumanReadablePTTHotkey;
    lblPlaintext.Caption := self.getHumanReadablePlaintextHotkey;

    // ----------------
    // Trigger Window
    // ----------------


    tbdelay.Position := ini.ReadInteger(ArsClip, tbDelay.name, 50);
    sbtop.down := ini.Readbool(ArsClip, sbtop.name, false);
    sbbottom.down := ini.Readbool(ArsClip, sbbottom.name, false);
    sbleft.down := ini.Readbool(ArsClip, sbleft.name, false);
    sbright.down := ini.Readbool(ArsClip, sbright.name, true);
    sbtopleft.down := ini.Readbool(ArsClip, sbtopleft.name, false);
    sbtopright.down := ini.Readbool(ArsClip, sbtopright.name, false);
    sbbottomleft.down := ini.Readbool(ArsClip, sbbottomleft.name, false);
    sbbottomright.down := ini.Readbool(ArsClip, sbbottomright.name, false);
    cbTriggerWindow.Checked := ini.ReadBool(ArsClip, cbTriggerWindow.Name, false);

    // JumpList
    cbxClickedAction.ItemIndex := ini.ReadInteger(ArsClip, cbxClickedAction.Name, 0);

    //
    // Clipboard Bar
    //

    cbShowPopupWhenClicked.checked := ini.ReadBool(ArsClip, cbShowPopupWhenClicked.name, true);
    cbShowTooltipOnHover.checked := ini.ReadBool(ArsClip, cbShowTooltipOnHover.name, false);
    udNormalOpacity.Position := ini.ReadInteger(ArsClip, udNormalOpacity.Name, 255);

    //
    // Etc - non controls
    //

    self.RightclickTriggerWarned := ini.ReadBool(ArsClip, 'RightclickTriggerWarned', false);
    self.PasteDelay := ini.ReadInteger(ArsClip,'PasteDelay', 10);
    self.ClipboardBarVisible := ini.ReadBool(arsclip, 'ClipboardBarVisible', false);

    //
    // Sound
    //

    self.Sound_NewClip := ini.ReadString('Sound','NewClip','c:\Windows\Media\chimes.wav');

    MyFree(ini);

    AppendLog('HotkeyLoad - end :=FrmConfig.lvOrder.items.Count=' + IntToStr(FrmConfig.lvOrder.items.Count));
    finally
        isLoading := false;
    end;
end;
{
--============================
-- // Load/Save hotkey info //
--============================
}

function SelectedIsDefault : boolean;
begin
	result := true;
    if frmconfig.lvprograms.selected = nil then EXIT;
	result := (frmconfig.cbxPasteMethod.ItemIndex = 4) and
    	not frmconfig.cbDisableMonitoring.checked and
        not frmconfig.cbDisableTrigger.checked;
end;

procedure TFrmConfig.SaveLastPermPath;
var ini: TInifile;

begin
    ini := TInifile.Create( self.GetINIFileName );

    ini.WriteString(ArsClip, 'LastPermanentPath', frmPermanent.GetPermanentPath);

    MyFree(ini);
end;

procedure TFrmConfig.SaveClipboardBarState;
var ini : TIniFile;
    x,y,width,height : integer;
begin
    ini := TInifile.Create( self.GetINIFileName );

    ini.WriteBool(ArsClip, 'ClipboardBarVisible', frmClipboardBar.isvisible);

    if frmClipboardBar.isvisible then begin
        frmClipboardBar.GetSizePos(x,y,width,height);

        ini.writeinteger(ArsClip, 'ClipboardBarX', x);
        ini.writeinteger(ArsClip, 'ClipboardBarY', y);
        ini.writeinteger(ArsClip, 'ClipboardBarWidth', width);
        ini.writeinteger(ArsClip, 'ClipboardBarHeight', height);
        ini.writebool(ArsClip, 'ClipboardBarCaption', false);

        ini.WriteBool(ArsClip, 'ClipboardBarCompactWhitespace', frmClipboardBar.CompactWhitespace1.Checked);
        ini.WriteBool(ArsClip, 'ClipboardBarSmallFont', frmClipboardBar.SmallFont1.Checked);
        ini.WriteBool(ArsClip, 'ClipboardBarMediumFont', frmClipboardBar.MediumFont1.Checked);
        ini.WriteBool(ArsClip, 'ClipboardBarLargeFont', frmClipboardBar.LargeFont1.Checked);

        ini.WriteBool(ArsClip, 'ClipboardBarToolbar', frmClipboardBar.pnlToolbar.Visible);
    end;


    MyFree(ini);
end;
procedure TFrmConfig.LoadClipboardBarState;
var ini : TIniFile;
    x,y,width,height : integer;
    b : boolean;
begin
    ini := TInifile.Create( self.GetINIFileName );
    height := 80; width := 150;
    b := ini.ReadBool(ArsClip, 'ClipboardBarVisible', false);

    frmClipboardBar.pnlToolbar.Visible := ini.ReadBool(ArsClip, 'ClipboardBarToolbar', false);

    x := ini.readinteger(ArsClip, 'ClipboardBarX', 0);
    y := ini.readinteger(ArsClip, 'ClipboardBarY', 0);
    width := ini.readinteger(ArsClip, 'ClipboardBarWidth', width);
    height := ini.readInteger(ArsClip, 'ClipboardBarHeight', height);
    frmClipboardBar.SetSizePos(x,y,width,height);

    frmClipboardBar.CompactWhitespace1.Checked := ini.ReadBool(ArsClip, 'ClipboardBarCompactWhitespace', false);
    frmClipboardBar.SmallFont1.Checked := ini.ReadBool(ArsClip, 'ClipboardBarSmallFont', false);
    frmClipboardBar.MediumFont1.Checked := ini.ReadBool(ArsClip, 'ClipboardBarMediumFont', true);
    frmClipboardBar.LargeFont1.Checked := ini.ReadBool(ArsClip, 'ClipboardBarLargeFont', false);

    frmClipboardBar.NormalOpacity := udNormalOpacity.Position;

    if b then frmClipboardBar.SetVisible(true, false);
    MyFree(ini);
end;

procedure TFrmConfig.lblHotkeyClick(Sender: TObject);
begin
    pcPanels.ActivePageIndex := tsHotkey.PageIndex;
    tvOptions.Selected := tvOptions.Items[pcPanels.ActivePageIndex];
end;
procedure TFrmConfig.lblShowOptionsClick(Sender: TObject);
begin
    pcPanels.ActivePageIndex := tsShowOptions.PageIndex;
    tvOptions.Selected := tvOptions.Items[pcPanels.ActivePageIndex];
end;
procedure TFrmConfig.lblSoundClick(Sender: TObject);
begin
    tvOptions.Selected := tvOptions.Items[ tssound.pageIndex];
end;
procedure TFrmConfig.lblTriggerWindowClick(Sender: TObject);
begin
   pcPanels.ActivePageIndex := tsTriggerWindow.PageIndex;
   tvOptions.Selected := tvOptions.Items[pcPanels.ActivePageIndex];
end;
procedure TFrmConfig.lblJumpListClick(Sender: TObject);
begin
   pcPanels.ActivePageIndex := tsJumplist.PageIndex;
   tvOptions.Selected := tvOptions.Items[pcPanels.ActivePageIndex];
end;
procedure TFrmConfig.lblClipboardBarClick(Sender: TObject);
begin
    pcPanels.ActivePageIndex := tsClipboardBar.PageIndex;
    tvOptions.Selected := tvOptions.Items[pcPanels.ActivePageIndex];
end;

procedure TFrmConfig.lblHotkeyAlternativesClick(Sender: TObject);
begin
    pcPanels.ActivePageIndex := tsHotkeyAlternatives.PageIndex;
   tvOptions.Selected := tvOptions.Items[pcPanels.ActivePageIndex];
end;

procedure TFrmConfig.lbMenuOrderClick(Sender: TObject);
begin
    tvOptions.Selected := tvOptions.Items[ tsmenuorder.pageIndex];
end;
procedure TFrmConfig.sbBottomClick(Sender: TObject);
begin
    sbTop.Down := false;
    sbBottom.Down := true;
    sbLeft.Down := false;
    sbright.down := false;
    sbtopleft.down := false;
    sbtopright.down := false;
    sbbottomleft.down := false;
    sbbottomright.down := false;
    if cbTriggerWindow.checked then begin
        FrmTriggerWindow.prEnable := false;
        FrmTriggerWindow.prEnable := true;
    end;
end;
procedure TFrmConfig.sbbottomleftClick(Sender: TObject);
begin
    sbTop.Down := false;
    sbBottom.Down := false;
    sbLeft.Down := false;
    sbright.down := false;
    sbtopleft.down := false;
    sbtopright.down := false;
    sbbottomleft.down := true;
    sbbottomright.down := false;
    if cbTriggerWindow.checked then begin
        FrmTriggerWindow.prEnable := false;
        FrmTriggerWindow.prEnable := true;
    end;
end;
procedure TFrmConfig.sbbottomrightClick(Sender: TObject);
begin
    sbTop.Down := false;
    sbBottom.Down := false;
    sbLeft.Down := false;
    sbright.down := false;
    sbtopleft.down := false;
    sbtopright.down := false;
    sbbottomleft.down := false;
    sbbottomright.down := true;
    if cbTriggerWindow.checked then begin
        FrmTriggerWindow.prEnable := false;
        FrmTriggerWindow.prEnable := true;
    end;
end;
procedure TFrmConfig.sbEditPermanentClipsClick(Sender: TObject);
begin
    frmSysTrayMenu.PermanentClipsMenuItemClickEvent(sender);
end;
procedure TFrmConfig.sbLeftClick(Sender: TObject);
begin
    sbTop.Down := false;
    sbBottom.Down := false;
    sbLeft.Down := true;
    sbright.down := false;
    sbtopleft.down := false;
    sbtopright.down := false;
    sbbottomleft.down := false;
    sbbottomright.down := false;
    if cbTriggerWindow.checked then begin
        FrmTriggerWindow.prEnable := false;
        FrmTriggerWindow.prEnable := true;
    end;
end;
procedure TFrmConfig.sbRightClick(Sender: TObject);
begin
    sbTop.Down := false;
    sbBottom.Down := false;
    sbLeft.Down := false;
    sbright.down := true;
    sbtopleft.down := false;
    sbtopright.down := false;
    sbbottomleft.down := false;
    sbbottomright.down := false;

    if cbTriggerWindow.checked then begin
        FrmTriggerWindow.prEnable := false;
        FrmTriggerWindow.prEnable := true;
    end;

end;
procedure TFrmConfig.sbTopClick(Sender: TObject);
begin
    sbTop.Down := true;
    sbBottom.Down := false;
    sbLeft.Down := false;
    sbright.down := false;
    sbtopleft.down := false;
    sbtopright.down := false;
    sbbottomleft.down := false;
    sbbottomright.down := false;
    if cbTriggerWindow.checked then begin
        FrmTriggerWindow.prEnable := false;
        FrmTriggerWindow.prEnable := true;
    end;
end;
procedure TFrmConfig.sbtopleftClick(Sender: TObject);
begin
    sbTop.Down := false;
    sbBottom.Down := false;
    sbLeft.Down := false;
    sbright.down := false;
    sbtopleft.down := true;
    sbtopright.down := false;
    sbbottomleft.down := false;
    sbbottomright.down := false;
    if cbTriggerWindow.checked then begin
        FrmTriggerWindow.prEnable := false;
        FrmTriggerWindow.prEnable := true;
    end;
end;
procedure TFrmConfig.sbtoprightClick(Sender: TObject);
begin
    sbTop.Down := false;
    sbBottom.Down := false;
    sbLeft.Down := false;
    sbright.down := false;
    sbtopleft.down := false;
    sbtopright.down := true;
    sbbottomleft.down := false;
    sbbottomright.down := false;
    if cbTriggerWindow.checked then begin
        FrmTriggerWindow.prEnable := false;
        FrmTriggerWindow.prEnable := true;
    end;

end;

procedure TFrmConfig.SetRightclickTriggerWarned;
begin
    self.RightclickTriggerWarned := true;
    self.HotkeySave;
end;

procedure TFrmConfig.ForceOldTrayPopup;
begin
    self.OldTrayPopup := true;
end;

procedure TFrmConfig.lvFormatsClick(Sender: TObject);
begin
    btnFormatUp.Enabled := lvFormats.ItemIndex <> -1;
    btnFormatDown.Enabled := btnFormatUp.Enabled;
end;

procedure TFrmConfig.lvOrderChange(Sender: TObject; Item: TListItem;  Change: TItemChange);
begin
	self.UpdatePreview;
end;
procedure TFrmConfig.lvOrderClick(Sender: TObject);
begin
    btnToggle.Enabled := lvOrder.ItemIndex <> -1;
    btnMenuUp.Enabled := btnToggle.Enabled;
    btnMenuDown.Enabled := btnToggle.Enabled;
end;
procedure TFrmConfig.lvOrderInfoTip(Sender: TObject; Item: TListItem; var InfoTip: string);
begin
    InfoTip := MenuOrderText(TMenuOrderType(item.Data), true);
end;

function TFrmConfig.MenuOrderText(m: TMenuOrderType; description:boolean): string;
begin
    if description then begin
        case m of
            MOT_MENU:result := 'Popup Clip history';
            MOT_OTHER:result := 'Non-Text Clip history';
            MOT_CANCEL:result := 'Closes the popup';
            MOT_LAST:result := 'Last clicked text item on popup';
            MOT_CURRENT:result := 'Current clipboard''s contents';
            MOT_REMOVED:result := 'Submenu of Clips recently removed from the list';
            MOT_PROGRAM: result := 'Custom options for the current target program';
            MOT_SYSTEM:result := 'ArsClip''s System Options menu';
            MOT_PASTEUTILS:   result := 'Misc items menu';
            MOT_PERMANENT:result := 'Clips in the current Permanent Group';
            MOT_SWITCH:result := 'Switches to another Permanent Group';
            MOT_FULL: result := 'Switches to Full/Configured Mode';
            MOT_ALLPERMANENT: result := 'A submenu of All Permanent Clips and Groups';
            MOT_SELECTED: result := 'Edit the selected text in the current window';
            MOT_CLICKED: result := 'Submenu of Clips recently clicked on';
            MOT_SEARCH: result := 'Search all text Clips ';
            MOT_BREAK: result := 'Creates a new Column';
        end;
    end else begin
        case m of
            MOT_MENU:result := 'Popup Clips';
            MOT_OTHER:result := 'Non-Text';
            MOT_CANCEL:result := 'Cancel';
            MOT_CURRENT:result := '[Clipboard]:';
            MOT_LAST:result := 'Last:';
            MOT_REMOVED:result := 'Recently Removed';
            MOT_PROGRAM: result := 'Program Options';
            MOT_SYSTEM:result := 'System';
            MOT_PASTEUTILS:   result := 'Pasting Tools';
            MOT_PERMANENT:result := 'Current Permanent Clips';
            MOT_SWITCH:result := 'Permanent Groups Switch';
            MOT_FULL: result := 'Full/Configured';
            MOT_ALLPERMANENT: result := 'All Permanent';
            MOT_SELECTED : result := 'Edit Selected:';
            MOT_CLICKED: result := 'Recently Clicked';
            MOT_SEARCH: result := 'Search and Paste ...';
            MOT_BREAK: result := '(Column Break)';
        end;
    end;
end;




procedure TFrmConfig.MoveItem(x, before: TMenuOrderType);
var li1, li2 : TListItem;
begin
    AppendLog('FrmConfig - MoveItem');
	self.HotkeyLoad;
	li1 := lvorder.FindCaption(0,self.MenuOrderText(TMenuOrderType(x),false),false,true,false);
    li2 := lvorder.FindCaption(0,self.MenuOrderText(TMenuOrderType(before),false),false,true,false);
    if (li1 <> nil) and (li2 <> nil) then begin

    	MoveListViewItem2(lvorder, lvorder.items.IndexOf(li1), lvorder.items.IndexOf(li2));
        self.HotkeySave;
    end;
end;

procedure TFrmConfig.Panel8Click(Sender: TObject);
begin
   frmMainPopup.Visible := frmMainPopup.Visible xor true;
end;
procedure TFrmConfig.pcPanelsChange(Sender: TObject);
begin
    tvOptions.Selected := tvOptions.Items[pcPanels.ActivePageIndex];

end;


procedure TFrmConfig.pnlColorClick(Sender: TObject);
var p : TPanel;
begin
    p := TPanel(Sender);
    ColorDialog1.Color := p.Color;
    if ColorDialog1.Execute( p.Handle ) then begin
        p.Color := ColorDialog1.Color;
    end;

    self.UpdatePreview(sender);
    UpdateColorExample;
end;

procedure TFrmConfig.FormKeyUp(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
    if (KEY = VK_ESCAPE) then begin
        self.btnCancel.Click;
    end;
end;


//============================
// Clipboard Options
//============================
procedure TFrmConfig.UpdatePreview(Sender : TObject=nil);
begin
	if self.Visible then begin
    	timUpdatePreview.Enabled := false;
		timUpdatePreview.Enabled := true;
    end;
end;



procedure TFrmConfig.cbUseKeyboardClick(Sender: TObject);
begin
    frmMainPopup.setpopupusekeyboard(cbUseKeyboard.Checked);
    self.UpdatePreview;
end;
procedure TFrmConfig.cbUseVirtualDesktopMouseUp(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
    if cbTriggerWindow.checked then begin
        FrmTriggerWindow.prEnable := false;
        FrmTriggerWindow.prEnable := true;
    end;
end;
{
Make the user use the up/down to change the queue size
}
procedure TFrmConfig.txtPopupClipQueueSizeKeyPress(Sender: TObject; var Key: Char);
begin
    // ignore keystrokes
    key := chr(0);
end;
procedure TFrmConfig.txtOldHistorySizeKeyPress(Sender: TObject;  var Key: Char);
begin
    // ignore keystrokes
    Key := Chr(0);
end;
procedure TFrmConfig.txtOtherSizeKeyPress(Sender: TObject; var Key: Char);
begin
    key := chr(0);
end;
procedure TFrmConfig.txtOtherSizeLimitKBChange(Sender: TObject);
var limit : integer;
begin
    limit := StrToInt(FrmConfig.txtOtherSizeLimitKB.text) * 1024;

    cbDontCopy.Checked := limit <> 0;
    OtherQueue.SetClipSizeLimit( limit );
end;
procedure TFrmConfig.udQueueSizeXClick(Sender: TObject; Button: TUDBtnType);
begin
    ClipQueue.SetQueueSize(udQueueSize.position);
end;
procedure TFrmConfig.udRemovedSizeXClick(Sender: TObject; Button: TUDBtnType);
begin
    //RemovedQueue.SetQueueSize(udRemovedSize.position);
end;
procedure TFrmConfig.cbDisableClick(Sender: TObject);
begin
    if assigned(frmClipboardManager) then
        frmClipboardManager.SetDisableMonitoring(cbdisable.Checked);
end;
procedure TFrmConfig.cbMonitorFilenamesClick(Sender: TObject);
begin
    frmClipboardManager.SetFilenameMonitoring(cbMonitorFilenames.checked);
end;
procedure TFrmConfig.cbRememberClick(Sender: TObject);
begin
    frmMainPopup.SetRememberHistory(cbRemember.checked);
    // this loads only the first time

    if (cbRemember.Checked) then begin
        frmClipboardManager.LoadHistory(False);
        //frmRemoved.LoadHistory;
    end;
end;
procedure TFrmConfig.cbRightTriggerEnableClick(Sender: TObject);
begin
    if cbRightTriggerEnable.checked then begin
        frmmainpopup.timMouseHeld.Enabled := true;
    end else begin
        frmmainpopup.timMouseHeld.Enabled := false;
    end;
end;
procedure TFrmConfig.cbCopyIconsClick(Sender: TObject);
begin
    frmClipboardManager.SetCopyIcon(cbCopyIcons.Checked);
    self.UpdatePreview;
end;
procedure TFrmConfig.cbMoveDuplicateClick(Sender: TObject);
begin
    ClipQueue.SetMoveDuplicateTop(cbMoveDuplicate.checked);
end;
procedure TFrmConfig.cbShowEditHistoryClick(Sender: TObject);
begin
    //FrmMainPopup.SetShowEditHistory(cbShowEditHistory.checked);
end;
procedure TFrmConfig.btnEditPermanentItemsClick(Sender: TObject);
begin
    frmPermanent.ShowModal;
end;
procedure TFrmConfig.rbTypingClick(Sender: TObject);
begin
    Paste.SetMimicTyping;
end;
procedure TFrmConfig.rbPasteClick(Sender: TObject);
begin
    Paste.SetUsePaste;
end;
procedure TFrmConfig.rbPasteSIClick(Sender: TObject);
begin
    Paste.SetUsePasteSI;
end;
procedure TFrmConfig.rbClipboardOnlyClick(Sender: TObject);
begin
    Paste.SetClipboardOnly;
end;
procedure TFrmConfig.cbMoveFirstClick(Sender: TObject);
begin
    frmMainPopup.SetMoveSelectedItemToTop(cbmovefirst.checked);
end;
//
// close/save/cancel
// TreeView clicks
//
procedure TFrmConfig.btnSaveClick(Sender: TObject);
begin
    self.HotkeySave;
    
    try
        if HotKeyPopup = nil then begin
            try
                HotKeyPopup := TACHotKey.Create(
                    FrmMainPopup.Handle, 'ArsClip.HotkeyPopup',
                    Hotkey_Ctrl, Hotkey_Alt,
                    Hotkey_Shift, Hotkey_Winkey, Hotkey_key);
            except
                // if it wasn't already created, this save is likely
                // generating the same error as when the program started
                // -- ignore here
            end;

        end else begin
            HotKeyPopup.SetHotKey(Hotkey_Ctrl, Hotkey_Alt,
                Hotkey_Shift, Hotkey_Winkey, Hotkey_key);
        end;

        if PlainTextHotKey = nil then begin
            try
                PlainTextHotKey := TACHotKey.Create(
                    FrmMainPopup.Handle, 'ArsClip.PlainTextHotKey',
                    PlainTextData.Ctrl, PlainTextData.Alt,
                    PlainTextData.Shft, PlainTextData.Win, PlainTextData.key);
            except

            end;

        end else begin
            PlainTextHotKey.SetHotKey(PlainTextData.Ctrl, PlainTextData.Alt,
                PlainTextData.Shft, PlainTextData.Win, PlainTextData.key);
        end;

        if (cbUseTooltipHotkey.checked) then begin
            if (TTHotKeyPopup <> nil) then begin
                TTHotKeyPopup.SetHotKey(TTHotkey_Ctrl, TTHotkey_Alt,
                    TTHotkey_Shift, TTHotkey_Winkey, TTHotkey_key);
                PTTHotKeyPopup.SetHotKey(PTTHotkey_Ctrl, PTTHotkey_Alt,
                    PTTHotkey_Shift, PTTHotkey_Winkey, PTTHotkey_key)
            end else begin
                TTHotKeyPopup := TACHotKey.Create(FrmMainPopup.handle, 'ArsClip.exe.MyTTHotKey',
                    TTHotkey_Ctrl, TTHotkey_Alt, TTHotkey_Shift,
                    TTHotkey_Winkey, TTHotkey_Key
                );
                PTTHotKeyPopup := TACHotKey.Create(FrmMainPopup.handle, 'ArsClip.exe.MyPTTHotKey',
                    PTTHotkey_Ctrl, PTTHotkey_Alt, PTTHotkey_Shift,
                    PTTHotkey_Winkey, PTTHotkey_Key
                );
            end;
        end else begin
            MyFree(TTHotKeyPopup);
            MyFree(PTTHotKeyPopup);
        end;
    except
        //EXIT;
    end;
    {if (self.SetHotKey) then begin}
        self.close;
    {end;}
end;
procedure TFrmConfig.btnSoundBrowseClick(Sender: TObject);
var ini : TInifile;

begin
    odSound.InitialDir := 'C:\Windows\media';
    odSound.Filter :=  'Wave files (*.wav)|*.WAV';
    if odSound.Execute(self.Handle) then begin
        //PlaySound_SetWavefile(odSound.FileName);

        ini := TInifile.Create( self.GetINIFileName );
        self.Sound_NewClip := odSound.Filename;
        myfree(ini);
    end;
end;
procedure TFrmConfig.btnTestClick(Sender: TObject);
begin
    //UnitSound.PlaySound_NewClipboardItem;
    UnitSound.PlaySound_PlayFile(self.Sound_NewClip);

end;
procedure TFrmConfig.btnToggleClick(Sender: TObject);
var li : TListITem;
begin
	timUpdatePreview.Enabled := false;
    timUpdatePreview.Enabled := true;
    li := lvOrder.Selected;
    if li <> nil then begin
        if li.SubItems[0] = 'Yes' then
         li.SubItems[0] := 'no'
        else
         li.SubItems[0] := 'Yes';

    end;
end;
procedure TFrmConfig.btnAddNameClick(Sender: TObject);
var s : string;
	li : TListITem;
begin
	if InputQuery('Add Executable','Enter the name in "filename.exe" format',s) then begin
        li := lvprograms.Items.Add;
        li.Caption := s;
        li.ImageIndex := -1;
    end;
end;
procedure TFrmConfig.btnCancelClick(Sender: TObject);
begin
    self.Close;
end;

procedure TFrmConfig.tvOptionsChange(Sender: TObject; Node: TTreeNode);
begin
    //self.ShowNewPanel;
    pcPanels.ActivePageIndex := (tvOptions.Selected.AbsoluteIndex);
end;
procedure TFrmConfig.tvOptionsClick(Sender: TObject);
var tn : TTreeNode;
begin
    tn := tvOptions.Selected;
    if tn <> nil then begin
        self.OnMouseUp(sender, mbLeft,[ssShift],0,0)
    end;


end;
procedure TFrmConfig.tvOptionsCollapsing(Sender: TObject; Node: TTreeNode; var AllowCollapse: Boolean);
begin
    AllowCollapse := false;
    if ignorecollapse  then begin
        AllowCollapse := true;
        EXIT;
    end;

    AllowCollapse := false;
    if tvOptions.Selected <> nil then begin
        AllowCollapse := tvOptions.Selected.HasChildren
        {and (tvOptions.selected <> node)};
    end;
end;
procedure TFrmConfig.tvOptionsCustomDrawItem(Sender: TCustomTreeView; Node: TTreeNode; State: TCustomDrawState; var DefaultDraw: Boolean);
begin
    defaultdraw := true;
    if (cdsFocused in state) or
        (cdsHot in state) or
        (cdsSelected in state)  then begin
        if (cdsHot in state) then begin
                sender.canvas.brush.Color := dimColor(ColorToRGB(clInactiveCaption),1.05);
            end else begin
                sender.canvas.brush.Color := dimColor(ColorToRGB(cl3DLight ));
            end;
        //sender.canvas.brush.Color := DimColor(ColorToRGB(clInactiveCaption),1.05);
        if (cdsHot in state)  then begin
                //sender.Canvas.font.color := ColorToRGB(clHighlighttext);
            end else begin
                sender.Canvas.font.color := ColorToRGB(clBtnText);
            end;
    end;
    if node.parent = nil then begin
        sender.Canvas.Brush.color := ColorToRGB(clWindow);
        if (cdsSelected in state) or
        (cdsHot in state) then begin
            if (cdsHot in state) then begin
                sender.canvas.brush.Color := dimColor(ColorToRGB(clInactiveCaption),1.05);
            end else begin
                sender.canvas.brush.Color := dimColor(ColorToRGB(cl3DLight ));
            end;

            if (cdsHot in state)  then begin
                //sender.Canvas.font.color := ColorToRGB(clHighlighttext);
            end else begin
                sender.Canvas.font.color := ColorToRGB(clBtnText);
            end;
        end;
    end;
end;
procedure TFrmConfig.tvOptionsExpanding(Sender: TObject; Node: TTreeNode; var AllowExpansion: Boolean);
begin
    AllowExpansion := true;

    self.ignorecollapse := true;
    tvOptions.FullCollapse;
    self.ignorecollapse := false;
end;
procedure TFrmConfig.tvOptionsMouseUp(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
    pcPanels.ActivePageIndex := (tvOptions.Selected.AbsoluteIndex);

end;

procedure TFrmConfig.bEditPopupHotkeyClick(Sender: TObject);
var w : word;
    s : string;
    ha, hs, hc, hw : boolean;
begin
    if FrmHotkey.GetHotkey( ha, hs ,hc , hw, w, s) then begin
       Hotkey_Alt    := ha;
       Hotkey_Shift  := hs;
       Hotkey_Ctrl   := hc;
       Hotkey_Winkey := hw;
       Hotkey_Key    := w;
       lblKeyname.caption := s;
    end;
end;
procedure TFrmConfig.btnEditPlaintextHotkeyClick(Sender: TObject);
var w : word;
    s : string;
    ha, hs, hc, hw : boolean;
begin
    if FrmHotkey.GetHotkey( ha, hs ,hc , hw, w, s) then begin
       PlainTextData.Alt    := ha;
       PlainTextData.Shft   := hs;
       PlainTextData.Ctrl   := hc;
       PlainTextData.Win    := hw;
       PlainTextData.Key    := w;
       lblPlaintext.caption := s;
    end;
end;
procedure TFrmConfig.btnEditPopupClipsClick(Sender: TObject);
begin
    frmSysTrayMenu.EditHistoryMenuItemClickEvent(sender); 
end;

{Clipboard > Execute Permanent Clip}
procedure TFrmConfig.btnPermClipsClick(Sender: TObject);
begin
    UnitMisc.ShowPopupRight(TControl(sender), pmPermClips);
end;
procedure TFrmConfig.pmPermClipsPopup(Sender: TObject);
var
    i, j : integer;
    mi : TMenuItem;
    submi : TMenuItem;
begin
    pmPermClips.Items.Clear;
    mi := TMenuItem.Create(pmPermClips);
    mi.Caption := '[none]';
    mi.hint := '';
    mi.OnClick := PermClipClick;
    pmPermClips.Items.Add(mi);

    for i := 0 to FrmPermanent.PermFoldersGetCount-1 do begin
        mi := TMenuItem.Create(pmPermClips);
        mi.Caption := FrmPermanent.PermFoldersGetItem(i);
        mi.Enabled := false;

        FrmPermanent.PermFolderPush;
        FrmPermanent.SetPermanentPath(mi.Caption);
        for j := 0 to FrmPermanent.GetCount-1 do begin
            submi := TMenuItem.Create(pmPermClips);
            submi.Caption := FrmPermanent.GetItemName(j);
            submi.Hint := mi.Caption;
            submi.OnClick := PermClipClick;
            mi.Enabled := true;
            mi.Add(submi);
        end;
        FrmPermanent.PermFolderPop;

        pmPermClips.Items.Add(mi);
    end;

end;
procedure TFrmConfig.PermClipClick(Sender : TObject);
var
    group, clip : string;
begin
end;

procedure TFrmConfig.btnPreviewClick(Sender: TObject);

begin
    frmPreviewPopup.top := self.top;
    frmPreviewPopup.Left := self.Left+self.width;
    if not frmPreviewPopup.Visible  then
    	frmPreviewPopup.Show;
    frmPreviewPopup.UpdatePreview;
    //Windows.SetFocus(frmPreviewPopup.Handle);
    //Windows.SetFocus(self.Handle);
end;
procedure TFrmConfig.btnRemovedClipsClick(Sender: TObject);
begin
    frmSysTrayMenu.RemovedItemsMenuItemClickEvent(sender);
end;
procedure TFrmConfig.bEditToolTipHotkeyClick(Sender: TObject);
var w : word;
    s : string;
    ha, hs, hc, hw : boolean;
begin
    if FrmHotkey.GetHotkey( ha, hs ,hc , hw, w, s) then begin
       TTHotkey_Alt    := ha;
       TTHotkey_Shift  := hs;
       TTHotkey_Ctrl   := hc;
       TTHotkey_Winkey := hw;
       TTHotkey_Key    := w;
       lblToolTipKeyname.caption := s;
    end;
end;
procedure TFrmConfig.bEditPreviousToolTipHotkeyClick(Sender: TObject);
var w : word;
    s : string;
    ha, hs, hc, hw : boolean;
begin
    if FrmHotkey.GetHotkey( ha, hs ,hc , hw, w, s) then begin
       PTTHotkey_Alt    := ha;
       PTTHotkey_Shift  := hs;
       PTTHotkey_Ctrl   := hc;
       PTTHotkey_Winkey := hw;
       PTTHotkey_Key    := w;
       lblPreviousTooltipKeyname.caption := s;
    end;
end;

procedure TFrmConfig.cbDisableWatcherClick(Sender: TObject);
begin
    if FrmChainWatcher <> nil then begin
        FrmChainWatcher.PermanentDisable(cbDisableWatcher.checked);
    end;
end;
procedure TFrmConfig.cbDisableWhenScrollLockClick(Sender: TObject);
begin
    frmClipboardManager.SetDisableWhenScrollLock(cbDisableWhenScrollLock.checked);
end;
procedure TFrmConfig.cbDontCopyClick(Sender: TObject);
begin
    if cbDontCopy.checked then begin
        if strtoint(txtOtherSizeLimitKB.Text) = 0 then
            txtOtherSizeLimitKB.Text := '500';
    end else begin
        txtOtherSizeLimitKB.Text := '0';
    end;
end;
procedure TFrmConfig.cbEnableClipboardBarMouseUp(Sender: TObject;  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
    frmClipboardBar.SetVisible(cbEnableClipboardBar.checked);
end;
procedure TFrmConfig.cbEnableSoundClick(Sender: TObject);
begin
    btnSoundBrowse.Enabled := false;
    btnTest.Enabled := false;
    if cbEnableSound.Checked then begin
        PlaySound_Init;
        btnSoundBrowse.Enabled := true;
        btnTest.Enabled := true;
    end else begin
        PlaySound_Remove;
        //self.Sound_NewClip := '';
    end;
end;
procedure TFrmConfig.cbFullModeClick(Sender: TObject);
begin
	if self.Visible then begin
    	timUpdatePreview.Enabled := false;
		timUpdatePreview.Enabled := true;
    end;
end;
//
// Per-program Options
//
procedure TFrmConfig.lvProgramsClick(Sender: TObject);
var exename : string;
begin
    if lvPrograms.Selected = nil then begin
        cbxPasteMethod.Enabled := false;
        cbDisableTrigger.Enabled := false;
        cbDisableMonitoring.Enabled := false;

        EXIT;
    end;

    exename := lvPrograms.selected.caption;

    cbxPasteMethod.Enabled := true;
    cbDisableTrigger.Enabled := true;
    cbDisableMonitoring.Enabled := true;

    cbxPasteMethod.ItemIndex :=  Integer(Paste.GetPasteMethod( exename ));
    cbDisableTrigger.checked :=  FrmSysTrayMenu.IsNoRightClickEXE(ExeName);
    cbDisableMonitoring.checked := FrmSysTrayMenu.IsDisabledEXE(ExeName);
end;
procedure TFrmConfig.cbDisableTriggerMouseUp(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
var s : string;
begin
    s := lvPrograms.Selected.Caption;
    lvPrograms.Selected.ImageIndex := 5;

    frmSysTrayMenu.ToggleNoRightClickEXE(s);
    cbDisableTrigger.Checked := frmSysTrayMenu.IsNoRightClickEXE(s);

    if SelectedIsDefault then lvPrograms.Selected.ImageIndex := -1;
end;
procedure TFrmConfig.cbDisableMonitoringMouseUp(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
var s : string;
begin
    s := lvPrograms.Selected.Caption;
    lvPrograms.Selected.ImageIndex := 5;

    frmSysTrayMenu.ToggletDisabledEXE(s);
    cbDisableMonitoring.Checked := frmSysTrayMenu.IsDisabledEXE(s);

    if SelectedIsDefault then lvPrograms.Selected.ImageIndex := -1;
end;
procedure TFrmConfig.cbxPasteMethodChange(Sender: TObject);
var s : string;
begin
    s := lvPrograms.Selected.Caption;
    lvPrograms.Selected.ImageIndex := 5;
    
    Paste.AssignPaste(s, TPasteMethod(cbxPasteMethod.ItemIndex));
    //frmSysTrayMenu.ToggletDisabledEXE(s);
    //cbDisableMonitoring.Checked := frmSysTrayMenu.IsDisabledEXE(s);
    if SelectedIsDefault then lvPrograms.Selected.ImageIndex := -1;
end;
procedure TFrmConfig.timUpdatePreviewTimer(Sender: TObject);
begin
    timUpdatePreview.Enabled := false;
    if frmPreviewPopup.Visible  then btnPreview.Click;

end;
procedure TFrmConfig.tsClipboardBarShow(Sender: TObject);
begin
    cbEnableClipboardBar.Checked := frmClipboardBar.IsVisible;
end;
procedure TFrmConfig.tsProgramOptionsShow(Sender: TObject);
var sl : TStringList;
    h : THandle;
    s : string;
    i : integer;
    li : TListItem;

    procedure AddName( sl : TStringList; src : TListView; DefaultValue : string = ''); overload;
    var i : integer;
        s : string;
        li : TListItem;
    begin
        for i := 0 to sl.count - 1 do begin
            s := sl.Names[i];
            if s <> '' then

                if src.FindCaption(0,s,false,true,false) = nil  then begin
                    li := src.Items.Add;
                    li.Caption := s;
                    //li.ImageIndex := -1;

                    if sl.ValueFromIndex[i] <> DefaultValue then
                        li.ImageIndex := 5;
                end;
        end;
    end;
begin
    sl := TStringList.create;
    lvPrograms.Items.Clear;

    Paste.GetEXEPasteList(sl);
    AddName(sl, lvPrograms, '4');

    frmSysTrayMenu.GetEXEDisabledList(sl);
    AddName(sl, lvPrograms, '0');

    frmSysTrayMenu.GetEXENoRightClickList(sl);
    AddName(sl, lvPrograms, '0');

    // check for programs with all default settings
    // and remove them from the list

    with lvPrograms do
        for i := items.count - 1 downto 0 do begin
            if items[i].imageindex = 0 then
                lvPrograms.Items.Delete(i);
        end;

    // Show currently running programs

    h := Windows.GetForegroundWindow;
    while h <> 0 do begin
        s := Lowercase(WindowHandleToEXEName(h));

        if lowercase(s) <> 'arsclip.exe' then begin
            if lvPrograms.FindCaption(0,s,false,true,false) = nil  then begin
                    li := lvPrograms.Items.Add;
                    li.Caption := s;
                    li.ImageIndex := -1;
            end;
        end;
        h := GetNextWindow(h);
    end;

    myfree(sl);
end;
procedure TFrmConfig.cbShowFormModeClick(Sender: TObject);
begin
    //FrmMainPopup.SetShowFormMode(cbShowFormMode.Checked);
end;
procedure TFrmConfig.cbTriggerWindowClick(Sender: TObject);
begin
	if not Assigned(FrmTriggerWindow) and  cbTriggerWindow.Checked then begin
        FrmTriggerWindow := TFrmTriggerWindow.Create(self);
        //FrmTriggerWindow.Visible := false;
        FrmTriggerWindow.prEnable := cbTriggerWindow.Checked;
    end;


	if Assigned(FrmTriggerWindow) and  not cbTriggerWindow.Checked then begin
    	FrmTriggerWindow.prEnable := false;
        FrmTriggerWindow.Free;
        FrmTriggerWindow := nil;

    end;

    //FrmScratchPad.prFadeTime := 100;
end;
procedure TFrmConfig.cbPopupDoubleclickClick(Sender: TObject);
begin
    if cbPopupDoubleclick.checked then
        cbPopupDoubleclickTray.checked := not cbPopupDoubleclick.checked;
end;
procedure TFrmConfig.cbPopupDoubleclickTrayClick(Sender: TObject);
begin
    if cbPopupDoubleclickTray.checked then
    cbPopupDoubleclick.checked := not cbPopupDoubleclickTray.checked;
end;
procedure TFrmConfig.bntSetFontClick(Sender: TObject);
var ini : TIniFile;
    c : cardinal;
    fs : TFontStyles;
begin
    if FontDialog.Execute then begin
        tempfont := FontDialog.Font;

        ini := TInifile.Create( self.GetINIFileName );

        //
        // Hotkey Panel
        //
        ini.WriteString('Font','Name', FontDialog.Font.Name);
        ini.WriteInteger('Font','CharSet', FontDialog.Font.Charset);
        ini.WriteInteger('Font','Color', FontDialog.Font.Color);
        ini.WriteInteger('Font','Size', FontDialog.Font.Size);

        fs :=FontDialog.Font.style;
        move(fs, c, 4);
        ini.WriteInteger('Font','Style', c);
        tempfont.Style := fs;
    end;
end;
procedure TFrmConfig.XcbShowAllItemsClick(Sender: TObject);
begin
    if cbShowAllItems.Checked then begin
        self.cbShowAllAsSubmenus.Checked := false;
    end;
end;
procedure TFrmConfig.XcbShowAllAsSubmenusClick(Sender: TObject);
begin
    if cbShowAllAsSubmenus.Checked then begin
        self.cbShowAllItems.Checked := false;
    end;
end;
procedure TFrmConfig.btnFormatUpClick(Sender: TObject);
var i : integer;
begin
    if lvFormats.Selected = nil then EXIT;
    i := lvFormats.Selected.Index;
    if i = 0 then EXIT;

    MoveListViewItem(lvFormats, i, i - 1 );

    lvFormats.Selected := lvFormats.Items[i - 1];
    lvFormats.ItemFocused := lvFormats.Selected;
end;
procedure TFrmConfig.btnFormatDownClick(Sender: TObject);
var i : integer;
begin
    if lvFormats.Selected = nil then EXIT;
    i := lvFormats.Selected.Index;
    if i = lvFormats.items.count - 1  then EXIT;

    MoveListViewItem(lvFormats, i, i + 1 );

    lvFormats.Selected := lvFormats.Items[i + 1];
    lvFormats.ItemFocused := lvFormats.Selected;
end;
procedure TFrmConfig.btnMenuUpClick(Sender: TObject);
var i : integer;
begin
    if lvOrder.Selected = nil then EXIT;
    i := lvOrder.Selected.Index;
    if i = 0 then EXIT;

    MoveListViewItem(lvOrder, i, i - 1 );

    lvOrder.Selected := lvOrder.Items[i - 1];
    lvOrder.ItemFocused := lvOrder.Selected;
end;
procedure TFrmConfig.btnMenuDownClick(Sender: TObject);
var i : integer;
begin
    if lvOrder.Selected = nil then EXIT;
    i := lvOrder.Selected.Index;
    if i = lvOrder.items.count - 1  then EXIT;

    MoveListViewItem(lvOrder, i, i + 1 );

    lvOrder.Selected := lvOrder.Items[i + 1];
    lvOrder.ItemFocused := lvOrder.Selected;
end;
procedure TFrmConfig.SpeedButton5Click(Sender: TObject);
var ini : TIniFile;
    c : cardinal;
    fs : TFontStyles;
begin
    if FontDialog.Execute then begin
        tempfont := FontDialog.Font;

        ini := TInifile.Create( self.GetINIFileName );

        //
        // Hotkey Panel
        //
        ini.WriteString('Font','Name', FontDialog.Font.Name);
        ini.WriteInteger('Font','CharSet', FontDialog.Font.Charset);
        ini.WriteInteger('Font','Color', FontDialog.Font.Color);
        ini.WriteInteger('Font','Size', FontDialog.Font.Size);

        fs :=FontDialog.Font.style;
        move(fs, c, 4);
        ini.WriteInteger('Font','Style', c);
        tempfont.Style := fs;

        self.UpdatePreview;
    end;
end;


type TDumbPanel = class(TPanel)
    public
        property canvas;

end;
procedure TFrmConfig.UpdateColorExample;
var r : TRect;
    startc, endc : TColor;
    txtheight : integer;
const
    SPACER = 6;
    LEFTX = 15;
begin
    txtheight :=   Canvas.TextHeight('ALKFJ');
    with imgPreview do begin
        Canvas.Brush.Color := pnlBackgroundColor.Color;
        Canvas.FillRect(ClientRect);


        r.Top := 6;
        r.Left := LEFTX;
        Canvas.Brush.Style := bsClear;
        Canvas.Font.Color := pnlFontColor.color;
        Canvas.TextOut(r.Left, r.top, 'Normal Text');

        inc(r.Top, txtheight + SPACER);
        r.Width := imgPreview.Width;
        r.Height :=  txtheight + 4;




        startc := unitMisc.Blend(pnlBackgroundColor.Color, pnlFontColor.Color, 90);;
        endc := UnitMisc.Blend(startc,pnlHighlightColor.Color,35);
        r.Left := 0;
        GraphUtil.GradientFillCanvas(canvas,startc,endc,r,gdVertical);

        canvas.Brush.Style := bsClear;
        canvas.font.Color := pnlFontColor.Color;
        r.Left := LEFTX;
        canvas.TextOut(r.Left, r.top, 'Higlighted Text');

        inc(r.Top, txtheight + SPACER);

        canvas.Brush.Style := bsClear;
        Canvas.Font.Color := pnlClickedColor.Color;
        Canvas.TextOut(r.left, r.top, 'Clicked Text');

    end;
end;

procedure TFrmConfig.btnColorExamplesClick(Sender: TObject);
begin
    UnitMisc.ShowPopupRight(btnColorExamples, pmExampleColors);
end;

procedure TFrmConfig.DefaultScheme1Click(Sender: TObject);
begin
    cbFontColor.Checked := false;
    cbBackgroundColor.Checked := false;
    cbHighlightColor.Checked := false;
    cbClickedColor.Checked := false;

    pnlBackgroundColor.Color  := clBtnFace;
    pnlHighlightColor.Color := ColorToRGB(clHighlight);
    pnlFontColor.Color := ColorToRGB(clBtnText);
    pnlClickedColor.Color := $00790079;

    UpdateColorExample;
end;
procedure TFrmConfig.JoeJoeSpecial1Click(Sender: TObject);
begin
    cbFontColor.Checked := true;
    cbBackgroundColor.Checked := true;
    cbHighlightColor.Checked := true;
    cbClickedColor.Checked := true;

    pnlBackgroundColor.Color  := 13810111;
    pnlHighlightColor.Color := 8935334;
    pnlFontColor.Color := 0;
    pnlClickedColor.Color := $2935034;
    UpdateColorExample;
end;




procedure TFrmConfig.SuperDark1Click(Sender: TObject);
begin
    cbFontColor.Checked := true;
    cbBackgroundColor.Checked := true;
    cbHighlightColor.Checked := true;
    cbClickedColor.Checked := true;

    pnlBackgroundColor.Color  := $0;;
    pnlHighlightColor.Color := $FFFFFF;
    pnlFontColor.Color := $FFFFFF;
    pnlClickedColor.Color := $808080;
    UpdateColorExample;
end;

procedure TFrmConfig.Greyscale1Click(Sender: TObject);
begin
    cbFontColor.Checked := true;
    cbBackgroundColor.Checked := true;
    cbHighlightColor.Checked := true;
    cbClickedColor.Checked := true;

    pnlBackgroundColor.Color  := 12895428;
    pnlHighlightColor.Color := 10526880;
    pnlFontColor.Color := 0;
    pnlClickedColor.Color := 5592405;
    UpdateColorExample;
end;

procedure TFrmConfig.MetroGreen1Click(Sender: TObject);
begin
    cbFontColor.Checked := true;
    cbBackgroundColor.Checked := true;
    cbHighlightColor.Checked := true;
    cbClickedColor.Checked := true;

    pnlBackgroundColor.Color  := 1550688;
    pnlHighlightColor.Color := 11119360;
    pnlFontColor.Color := $FFFFFF;
    pnlClickedColor.Color := 42623094;
    UpdateColorExample;
end;

procedure TFrmConfig.MetroSteelBlue1Click(Sender: TObject);
begin
cbFontColor.Checked := true;
    cbBackgroundColor.Checked := true;
    cbHighlightColor.Checked := true;
    cbClickedColor.Checked := true;

    pnlBackgroundColor.Color  := 8877668;
    pnlHighlightColor.Color := 173693;
    pnlFontColor.Color := 16777215;
    pnlClickedColor.Color := 10927532;
    UpdateColorExample;
end;

procedure TFrmConfig.Woodgrain1Click(Sender: TObject);
begin
 cbFontColor.Checked := true;
    cbBackgroundColor.Checked := true;
    cbHighlightColor.Checked := true;
    cbClickedColor.Checked := true;

    pnlBackgroundColor.Color  := 4286603;
    pnlHighlightColor.Color := 1650754;
    pnlFontColor.Color := 1055523;
    pnlClickedColor.Color := 3493478;
    UpdateColorExample;
end;

initialization
begin
    // The Hand loaded by Delphi is the old one, not the current system cursor
    screen.Cursors[crHandPoint] := LoadCursor(0, IDC_HAND);
end;
end.






