{
    This unit displays the main popup menu when a hotkey is pressed

    UnitFrmConfig is responsible for setting/releasing the hotkey -
    I had a good reason why, but I don't remeber it. I think there
    was a circular reference where each form required the other during
    creation.
}


unit UnitFrmMainPopup;

interface
uses

  UnitFolderWriteTest{},
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Clipbrd, Menus, StrUtils, ShellAPI, ExtCtrls, Buttons,
  IniFiles {for hashed}, UnitTooltipPopup,  UnitFrmConfig,
    UnitClipQueue, UnitTWideChar, UnitFramePopup,
   UnitFrameACPopup, UnitFrmACPopup, Vcl.Imaging.pngimage, System.Generics.collections;


  type
  TTargetProgramData = record
    icon : HICON;
    ExeName : string;
    x : integer;
    y : integer;
    SelectCompatible : boolean;
    SelectedText : string;
    ForegroundWindow : cardinal;
    FocusControl : cardinal;
    FocusControlClassname : string;
    DropFilesCompatible : boolean;
  end;

  type
  TFrmMainPopup = class(TForm)
    {$REGION 'default'}
    Memo1: TMemo;
    btnHide: TButton;
    imgA: TImage;
    imgRightArrow: TImage;
    imgIcon: TImage;
    imgFull: TImage;
    imgPasteAll: TImage;
    imgPaste: TImage;
    imgEdit: TImage;
    imgFlush: TImage;
    imgConfMode: TImage;
    imgPermCasc: TImage;
    imgRemoved: TImage;
    timMouseHeld: TTimer;
    ImgUnicode: TImage;
    imgRichText: TImage;
    imgFile: TImage;
    imgPlain: TImage;
    imgHTML: TImage;
    imgUnkown: TImage;
    imgPic: TImage;
    ImgMisc: TImage;
    imgAICon: TImage;
    timAutoSave: TTimer;
    imgSearch: TImage;
    imgDown: TImage;
    imgUp: TImage;
    imgPasteMini: TImage;
    timJumplist: TTimer;
    timLongCtrlVPress: TTimer;

    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure btnHideClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure timMouseHeldTimer(Sender: TObject);
    procedure timAutoSaveTimer(Sender: TObject);
    procedure timJumplistTimer(Sender: TObject);
    procedure timLongCtrlVPressTimer(Sender: TObject);
    {$ENDREGION}
  private
  protected
    { Private declarations }



    Popup: TPopupMenu;                  {text pasting popup}
    PopupShowing : boolean;

    LastStringSelected : string;         {last selected queue item from Popup}
    MenuItemText : string;

    SelectedClipboard : TClipItem;
    CTRLClickedItem : TClipItem;

    ThreadOurs : cardinal;               {Used soley by ThreadAttach/Detach}
    ThreadTarget : cardinal;
    ThreadAttached : boolean;

    {configuration options}
    PopupUseKB : boolean;
    UsePermanentItems : boolean;
    DoShowEditHistory : boolean;
    DoShowPasteAll : boolean;
    DoMoveSelectedToTop : boolean;
    DoShowCurrentItem : boolean;
    DoShowPermanentItemGroups : boolean;
    DoShowPermanentItemSubmenu : boolean;
    DoRememberHistory : boolean;
    DoShowLast : boolean;
    DoShowFormMode : boolean;
    IgnoreHotkey : boolean;

    PermanentItemsCurrentTop : integer;

    {keystrokes monitored when an item is clicked}
    CopyKey : integer;
    PermanentKey : integer;
    MimicKey : integer;

    {non-text items}
    UseOtherClipboardOnly : boolean;
    UseOtherPasting : boolean;
    UseFormMode : boolean;
    UseCtrlClickOpen, UseCtrlClickMenu : boolean;
    UseMousePositionOnce : boolean;

    UseNoWarningsModeOnce : boolean;

    FullMode : boolean; // user pressed Full Mode command
    PermanentItemPressed : boolean;

    ExplorerEditDetected : boolean;

    TooltipPopup : TTooltipPopup;
    HotkeyActive : boolean;
    PopupActive : boolean;

    ItemMenuOverride : boolean;
    TempMenuClick : boolean;
    {unicode poup}

    GatherTargetWarned : boolean;
    LastClipboardSequence : cardinal;
    IsAdminProgram : boolean;

    ItemPopupDismissed : boolean;
    SkipFocusReturn : boolean;
    LastHotkeyTime : cardinal;

    ACPopup : TACPopup;

    UseNewPopup : boolean;
    WarnedEXE : TDictionary<string,boolean>;


    procedure HandleCloseEvent;
    procedure HandleFormMode(sendtab : boolean = false);
    function ThreadAttach(TargetWindow: cardinal) : boolean;
    procedure ThreadDetach();

    procedure GatherTargetWindowData(overridehandle : THandle = 0);
    procedure GetTargetControl(var TargetData : TTargetProgramData);

    {
    // possible future use
    procedure MyOnDraw(Sender: TObject; ACanvas: TCanvas;
            ARect: TRect; Selected: Boolean);
    procedure MyOnMeasure(Sender: TObject; ACanvas: TCanvas;
            var Width, Height: Integer);
    }

    procedure ShowPopup(X,Y: integer);


    //
    // util functions
    //
    procedure ShowPreviewForm;
    //procedure PopulatePopupANSI(p : TPopupMenu); virtual; Abstract;




    procedure ShowPopupWithFocusRules;

    procedure CreateParams(var Params: TCreateParams); override;
    procedure WMStyleChanging(var msg : TWMStyleChanging); message WM_STYLECHANGING;
    procedure WMShow(var msg : TWMShowWindow); message WM_SHOWWINDOW;
  public
    TargetData : TTargetProgramData;
    CurrentClipboard : TClipItem;

    procedure ShowPopupCallback(Sender : TObject);

    function GetTargetEXE : string;
    procedure SetItemMenuOverride( enabled : boolean );

    procedure ShowPreviewEditForm;
    procedure ClearCurrentLast;

    {public declarations}
    procedure SendText(s : string; ci : TClipItem = nil; NoPlaintext : boolean = false);
    function GetNextWindow(inh : THandle=0) : THandle;
    procedure ShowOnNextWindow(ShowPopup : boolean = true);
    procedure ShowOnScratchPad(ShowPopup : boolean = true);
    function GetNextWindowProgramName : string;
    function PopupIsShowing : boolean;

    procedure ShowOnTaskbar;


    {configuration}
    procedure SetPopupUseKeyboard(usekb: boolean);
    function GetPopupUseKeyboard : boolean;
    function GetNeedsFocus : boolean;
    procedure SetPermanentItems(DoUse: boolean);
    procedure SetShowPermeanentItemGroups(enable : boolean);
    procedure SetShowPermanentItemSubmenu(value : boolean);

    procedure SetOtherPasteMethodPasting();
    procedure SetOtherPasteMethodClipboardOnly();
    procedure SetShowEditHistory(value : boolean);

    procedure SetShowPasteAll(DoShow: boolean);
    procedure SetMoveSelectedItemToTop(DoMove : boolean);
    procedure SetShowCurrentItem(DoShow: boolean);
    procedure SetRememberHistory(DoRemember: boolean);
    procedure SetDoShowLast(DoShow: boolean);
    procedure SetShowFormMode(DoShow : boolean);
    procedure SetCopyKey(key : integer);
    procedure SetPermanentKey(key : integer);
    procedure SetMimicKey(key : integer);
    procedure SetCtrlClickOpen(value : boolean);
    procedure SetCtrlClickMenu(value : boolean);


    {these are shared with FrmDummyUnicodePopup}
    //
    // menu items selected on Popup window
    //
    function GetUsePermanentItems : boolean;
    function GetDoShowEditHistory : boolean;
    function GetDoShowPasteAll : boolean;
    function GetDoMoveSelectedToTop : boolean;
    function GetDoShowCurrentItem : boolean;
    function GetDoShowPermanentItemGroups : boolean;
    function GetDoShowPermanentItemSubmenu : boolean;
    function GetDoRememberHistory : boolean;
    function GetDoShowLast : boolean;
    function GetDoShowFormMode : boolean;

    function GetLastStringSelected : string;
    function GetUseFormMode : boolean;
    function GetFullMode : boolean;
    function GetAccelerator(i: integer): char;
    function GetTrimmedItem(item : string) : string;
    function GetSelectedText : string;
    procedure ClearSelectedText;

    procedure SearchMenuItemClickEvent(Sender: Tobject);
    procedure SearchJumplistClickEvent();


    {system tray stuff/ windows messages}
    procedure WMHotKey(var Msg : TWMHotKey); message WM_HOTKEY;
    procedure WMEndSession(var msg : TWMQueryEndSession); message WM_QUERYENDSESSION;

    procedure AppendLog(s : string);
    procedure ShowOnSystemTray(overrideh : Thandle =0);

    procedure ApplicationException(Sender: TObject; E: Exception);
    procedure NewClipboardCallback;

    procedure SkipFocusReturnOnce;
    procedure FakePopupHotkey;
    procedure JumplistDefault;

    property MainPopup : TACPopup read acpopup;
  end;


implementation

uses UnitMisc, UnitFrmClipboardManager,
  UnitFrmPasteSelected, UnitOtherQueue, UnitKeyboardQuery,
  TLHelp32,  UnitFrmPermanentNew,
   UnitFrmSysTrayMenu, UnitPaste, Math,
  CommCtrl,
  UnitFrmEditItem, UnitMenuItemTagdata , UnitFrmSearch, UnitSound
  , UnitFrmDummyClipboardBar, UnitFrmEditTextExternal, Types,
  UnitFrmNewEditHistory, UnitIntegrity, UnitFrmTooltipNew,
  UnitFrmChainWatcher, UnitPopupGenerate;

{$R *.dfm}

CONST PASTE_ONLY_FILE : string = 'nopaste.txt';
const HAS_SELECTED_TEXT : string = '[Has Selected Text]';

{
--========================
-- // Public Interface //
--========================
}

procedure TFrmMainPopup.timJumplistTimer(Sender: TObject);
var msg : TWMHotKey;
    h : THandle;
    top,forced,next : string;
begin
    timJumplist.enabled := false;

//Show Configuration
//Trigger Popup
//Show Permanent Clips
//Show Edit History
//Show Search Window
//Edit Clipboard
    if FrmConfig.cbxClickedAction.ItemIndex <> 1 then begin
        ForceForeground(Application.Handle);
    end;

    case FrmConfig.cbxClickedAction.ItemIndex of
    0:  begin
            FrmConfig.Show;
        end;
    1:  begin
            self.ShowOnTaskbar;
        end;
    2:  begin
            FrmPermanent.ShowForm;
        end;
    3:  begin
            frmEditHistory.ShowPopup;
        end;
    4:  begin
            frmSearch.ShowAutomatted();
        end;
    5:  begin
            frmEditTextExternal.EditClipboard;
        end;
    end;

end;
procedure TFrmMainPopup.timLongCtrlVPressTimer(Sender: TObject);
begin
    timLongCtrlVPress.Enabled := false;
//    ShowMessage('hello');
end;

procedure TFrmMainPopup.JumplistDefault;
begin
    timJumplist.enabled := true;
end;
procedure TFrmMainPopup.FakePopupHotkey;
var msg : TWMHotKey;
    h : THandle;
begin
    msg.HotKey  := FrmConfig.GetHotKeyID;
    self.WMHotKey(msg);
end;

procedure TFrmMainPopup.WMShow(var msg : TWMShowWindow);
begin
    msg.Result := 0;
    //ShowWindow(self.Handle, SW_HIDE);
end;
procedure TFrmMainPopup.WMStyleChanging(var msg : TWMStyleChanging);
begin
    msg.StyleStruct.styleNew  := msg.StyleStruct.styleNew or  WS_EX_TOOLWINDOW;
    ShowWindow(self.Handle, SW_HIDE);
end;

procedure TFrmMainPopup.CreateParams(var Params: TCreateParams);
begin
    inherited CreateParams(params);

   	//Params.Style := WS_POPUP {or WS_TABSTOP or WS_CLIPSIBLINGS};
    Params.ExStyle := WS_EX_TOOLWINDOW or WS_EX_TOPMOST {or WS_EX_LAYERED};

    params.WndParent := GetDesktopWindow;
    {WS_EX_TRANSPARENT screws up in WinXP - causing a blank redraw}
end;

procedure TFrmMainPopup.SetShowFormMode(DoShow : boolean);
begin
    self.DoShowFormMode := DoShow;
end;
procedure TFrmMainPopup.SetCtrlClickOpen(value : boolean);
begin
    self.UseCtrlClickOpen := value;
    self.UseCtrlClickMenu := not value;
end;
procedure TFrmMainPopup.SetCtrlClickMenu(value : boolean);
begin
    self.UseCtrlClickOpen := not value;
    self.UseCtrlClickMenu := value;
end;

procedure TFrmMainPopup.SetMimicKey(key : integer);
begin
    self.MimicKey := VK_F1 + key;
end;
procedure TFrmMainPopup.SetCopyKey(key : integer);
begin
    self.CopyKey := VK_F1 + key;
end;
procedure TFrmMainPopup.SetPermanentKey(key : integer);
begin
    self.PermanentKey := VK_F1 + key;
end;

procedure TFrmMainPopup.SetShowEditHistory(value : boolean);
begin
    self.DoShowEditHistory := value;
end;

procedure TFrmMainPopup.SetShowPermanentItemSubmenu(value : boolean);
begin
    if (value) then begin
        DoShowPermanentItemSubmenu := true;
        DoShowPermanentItemGroups := false;
    end;
end;
procedure TFrmMainPopup.SetShowPermeanentItemGroups(enable : boolean);
begin
    if (enable) then begin
        DoShowPermanentItemSubmenu := false;
        DoShowPermanentItemGroups := true;
    end;
end;
procedure TFrmMainPopup.SetOtherPasteMethodPasting();
begin
    self.UseOtherClipboardOnly := false;
    self.UseOtherPasting := true;
end;
procedure TFrmMainPopup.SetOtherPasteMethodClipboardOnly();
begin
    self.UseOtherClipboardOnly := true;
    self.UseOtherPasting := false;
end;

procedure TFrmMainPopup.SetDoShowLast(DoShow: boolean);
begin
    self.DoShowLast := DoShow;
end;
procedure TFrmMainPopup.SetItemMenuOverride(enabled: boolean);
begin
    self.ItemMenuOverride := enabled;
end;

procedure TFrmMainPopup.SetRememberHistory(DoRemember: boolean);
begin
    self.DoRememberHistory := DoRemember;
end;
procedure TFrmMainPopup.SetShowCurrentItem(DoShow: boolean);
begin
    self.DoShowCurrentItem := doshow;
end;

procedure TFrmMainPopup.SetShowPasteAll(DoShow: boolean);
begin
    self.DoShowPasteAll := DoShow;
end;
procedure TFrmMainPopup.SetPopupUseKeyboard(usekb: boolean);
begin
    self.PopupUseKB := usekb;
end;
function TFrmMainPopup.GetPopupUseKeyboard : boolean;
begin
    result := self.PopupUseKB;
end;

function TFrmMainPopup.GetNeedsFocus : boolean;
begin
    result := not self.ExplorerEditDetected;
end;

procedure TFrmMainPopup.SetPermanentItems(DoUse: boolean);
begin
    self.UsePermanentItems := douse;
end;

procedure TFrmMainPopup.SetMoveSelectedItemToTop(DoMove : boolean);
begin
    DoMoveSelectedToTop := DoMove;
end;


{
--========================
-- // Create/Destroy   //
--========================

Popup menu
NoPaste file
Init vars

Handle a form close or a logoff/shutdown
}
var
    KBHook : HHOOk;
    VStartTime : boolean;

type
  tagKBDLLHOOKSTRUCT =  packed record
    vkCode :            DWORD;
    scanCode :          DWORD;
    flags :             DWORD;
    time :              DWORD;
    dwExtraInfo :       Integer;
  end;
  KBDLLHOOKSTRUCT      =  tagKBDLLHOOKSTRUCT;
  PKBDLLHOOKSTRUCT     =  ^KBDLLHOOKSTRUCT;

function KeyboardHookProc(Code: Integer; WP: WPARAM; LP : LPARAM) : LongInt; stdcall;
var msg : PKBDLLHOOKSTRUCT;
    key : word;
    ss : TShiftState;
    c : char;
    function KeyDown(c : LPARAM) : boolean;
    begin
        result := (c and $80000000) = 0;
    end;
begin
    result := 0;
    if code < 0 then begin
        result := CallNextHookEx(KBHook, code, wp, lp);
        EXIT;
    end;
    msg := pointer(lp);
    key := msg.vkCode;
    ss := KeyDataToShiftState(msg.flags);

    if (code = HC_ACTION) and
        FrmMainPopup.PopupIsShowing and (not FrmMainPopup.GetNeedsFocus)then begin

        if not (key in [VK_LWIN, VK_RWIN, VK_CONTROL, VK_MENU])
            and not ((key = Ord('V')) and (ss=[ssCtrl]))
            and not ((key = VK_INSERT) and (ss=[ssShift]))
            then begin
            case wp of
                WM_KEYDOWN:
                begin
                    FrmMainPopup.MainPopup.KeyDown(key, ss);
                end;
                WM_KEYUP:
                begin
                    FrmMainPopup.MainPopup.KeyUp(key, ss);
                    c := ConvertVitualKey(key);
                    FrmMainPopup.MainPopup.KeyPress( c );
                end;
            end;
            result := 1;
        end;
{    end else if (code = HC_ACTION) and (wp=WM_KEYDOWN) and (key = Ord('V')) and (ss=[ssCtrl] ) then begin
        FrmMainPopup.timLongCtrlVPress.Enabled := false;
        FrmMainPopup.timLongCtrlVPress.Enabled := true;
    end else if (code = HC_ACTION) and (wp=WM_KEYUP) and (key = Ord('V')) and (ss=[ssCtrl] ) then begin
        FrmMainPopup.timLongCtrlVPress.Enabled := false;}
    end;
end;
procedure TFrmMainPopup.FormCreate(Sender: TObject);
begin
    UnitMisc.AppendLog('FrmMainPopup - Creating');

    //TVistaAltFix.Create(Self);

    imgIcon.picture.Icon := application.Icon;
    //
    // popup & menu items init
    //
    self.ShowHint := true;
    Popup := TPopupMenu.Create(self);

    TooltipPopup := TTooltipPopup.Create;


    ThreadAttached := false;

    self.CurrentClipboard := TClipItem.Create;
    self.SelectedClipboard := TClipItem.Create;


    if Assigned(FrmConfig) then begin

    end;
    LastHotkeyTime := 0;

    ACPopup := TACPopup.Create(self);
    UseNewPopup := true;

    self.PopupShowing := false;

    WarnedEXE := TDictionary<string,boolean>.create;
end;
procedure TFrmMainPopup.FormClose(Sender: TObject; var Action: TCloseAction);
begin
    self.HandleCloseEvent;
    if USE_POPUP_KEYBOARD_HOOK and (KBHook <> 0) then begin
        WIndows.UnhookWindowsHookEx(KBHook);
    end;
end;

//
// When OS is shutting down/logging off
//
procedure TFrmMainPopup.WMEndSession(var msg : TWMQueryEndSession);
begin
    self.HandleCloseEvent;
    msg.Result := 1;       // do allow close
end;

procedure TFrmMainPopup.HandleCloseEvent;
begin
    if self.DoRememberHistory then begin
        frmClipboardManager.SaveHistory;
    end;

    FrmConfig.SaveClipboardBarState;

    FrmConfig.SaveLastPermPath;
    FrmPermanent.Close;

    MyFree(Self.CurrentClipboard);

    if not Application.Terminated  then begin
        Application.Terminate;
    end;
end;

procedure TFrmMainPopup.timAutoSaveTimer(Sender: TObject);
begin
    // AutoSave, but don't finalize and kill the process
    // -- This must be the same as HandleCloseEvent(), minus a few items
    if self.DoRememberHistory then begin
        frmClipboardManager.SaveHistory(false);
    end;

    FrmConfig.SaveClipboardBarState;

    FrmConfig.SaveLastPermPath;
    FrmPermanent.Close;
    unitmisc.AppendLog('[AutoSave] -- Activating');
    //MyFree(Self.CurrentClipboard);
end;



{
--======================
-- // HotKey Message  //
--======================

Description:
    Find the target control
    - Handle case when no target control
    - allow user to add problematic program to "No Paste" list

    Finally, pass control to  ShowPopupWithFocusRules


info collected here:
    HotKeyForeWindow
    HotKeyTarget
    TargetX
    TargetY
    TargetEXE
}

procedure TFrmMainPopup.WMHotKey(var Msg: TWMHotKey);
label EXIT_CODE;
var mods, key : word;

    procedure WaitOn(key, mods: integer);
    var w : word;
    begin

        if Boolean(mods and key) then begin
            case key of
            MOD_ALT : w := VK_MENU;
            MOD_CONTROL : w := VK_CONTROL;
            MOD_SHIFT : w := VK_SHIFT;
            MOD_WIN : w := 0;
            else
                w := 0;
            end;
            if w = 0 then begin
                KeyboardQuery.WaitUntilRelease(VK_LWIN);
                KeyboardQuery.WaitUntilRelease(VK_RWIN);
            end else begin
                KeyboardQuery.WaitUntilRelease(w);
            end;
        end;
    end;
var delay : integer;
    b : boolean;
begin

    Windows.SetLastError(ERROR_SUCCESS);
    mods := TMessage(msg).LParamLo;
    key := TMessage(msg).LParamHi;

    // Detect autorepeat being held down
    SystemParametersInfo(SPI_GETKEYBOARDSPEED, 0, @delay, 0); // repeats per second
    delay := max(delay,1); // NO DIVIDE BY ZERO
    delay := 1000 div delay; // convert to milliseconds


    if self.LastHotkeyTime <> 0 then begin
        if self.LastHotkeyTime > Windows.GetTickCount then begin
            self.LastHotkeyTime := 0;
        end else begin
            if (Windows.GetTickCount - self.LastHotkeyTime) <= (delay*2)  then begin
                unitmisc.AppendLog('Ignoring auto repeat');
                msg.Result := 0;
                self.LastHotkeyTime := Windows.GetTickCount;
                EXIT;
            end;
        end;
    end;
    self.LastHotkeyTime := Windows.GetTickCount;

    // Hotkey pressed while the popup is showing;
    if (self.HotkeyActive) and (msg.HotKey = frmConfig.GetHotKeyID) then begin
        mysleep(30);
    end;
    if ((self.HotkeyActive) and (msg.HotKey = frmConfig.GetHotKeyID)) or
    	(ACPopup.Showing) then begin
        UnitMisc.AppendLog('Duplicate hotkey press detected - moving highlight');
        ACPopup.HoverDown;
        
        EXIT;
    end;
    try
        self.HotkeyActive := true;

        // Ignore any hotkeys that don't belong to us
        if (not msg.HotKey = FrmConfig.GetHotKeyID) and
            (not msg.HotKey = FrmCOnfig.GetTTHotKeyID) and
            (not msg.HotKey = FrmCOnfig.GetPTTHotKeyID) and
            (not FrmPermanent.IsHotkeyIdent(msg.hotkey))
            then begin
            //goto EXIT_CODE;
            EXIT;
        end;

        if self.ThreadAttached then begin
            sleep(100);
            if self.ThreadAttached then begin
                UnitMisc.AppendLog('wm_hotkey - thread already attached');
                //goto EXIT_CODE;
                EXIT;
            end;
        end;

        // Ignore the clipboard as soon as the hotkey is pressed
        // Stop ignoring on an error exit
        // Each invididual menu item is responsible to stop ingoring the clipboard
        //frmClipboardManager.SetIgnoreClipboard(true);

        UnitMisc.AppendLog('WM_Hotkey - received');
        if (self.IgnoreHotkey) then begin
            UnitMisc.AppendLog('ignoring hotkey');
            //frmClipboardManager.SetIgnoreClipboard(false);
            //goto EXIT_CODE;
            EXIT;
        end;

        // get current foreground window
        // get the data needed to show the popup from the window

        TargetData.ForegroundWindow := Windows.GetForegroundWindow();
        if (TargetData.ForegroundWindow = 0) then begin
            UnitMisc.AppendLog('No Foreground Window');
            EXIT;
        end;
        self.GatherTargetWindowData;


        // Show the Popup, Next Tooltip, or Previous Toolip
        // or paste current as plain text



        if (msg.HotKey = FrmConfig.GetHotKeyID)  then begin
            self.FullMode := false;
            b := FrmChainWatcher.GetEnabled;
            if b then FrmChainWatcher.Disable;

            self.ShowPopupWithFocusRules;

            if b then FrmChainWatcher.Enable;
        end else if (msg.HotKey = FrmConfig.GetTTHotKeyID) then begin
            //
            // NOTE: The tooltip popup must be showing for Next/Prev to
            // function. Holding down modifiers is allowed, but just wait
            // for the main key to be released.
            //
            KeyboardQuery.WaitUntilRelease( key );
            self.HotkeyActive := false;
            TooltipPopup.ShowTooltipNext(TargetData.x + 10, TargetData.y+20);
            KeyboardQuery.WaitUntilRelease( key );
        end else if (msg.HotKey = FrmConfig.GetPTTHotKeyID) then begin
            KeyboardQuery.WaitUntilRelease( key );
            self.HotkeyActive := false;
            TooltipPopup.ShowTooltipPrev(TargetData.x + 10, TargetData.y+20);
            KeyboardQuery.WaitUntilRelease( key );

        end else if (msg.hotkey = FrmConfig.GetPlaintextHokeyID) then begin
            CurrentClipboard.GetClipboardItem(0);

            if (Paste.GetPasteMethod(TargetData.ExeName) in [PASTE_MIMIC]) or
            (Paste.GetDefaultPasteMethod in [PASTE_MIMIC]) then begin
                WaitOn(MOD_WIN, mods);
            end;
            // don't paste if a WINKEY is held down

            if CurrentClipboard.GetFormat = CF_HDROP then begin
                Paste.SendText(CurrentClipboard.GetAsPlaintext);
            end else begin
                Paste.SendText(Clipboard.AsText);
            end;

        end else if (FrmPermanent.IsHotkeyIdent(msg.hotkey)) then begin
        // otherwise, wait for the hotkeys to be released
            mods := TMessage(msg).LParamLo;
            key := TMessage(msg).LParamHi;

            KeyboardQuery.WaitUntilRelease(key);
            WaitOn(MOD_WIN, mods);
            WaitOn(MOD_ALT, mods);
            WaitOn(MOD_CONTROL, mods);
            WaitOn(MOD_SHIFT, mods);

            FrmPermanent.ReportHotkey(msg.hotkey);
        end;
    finally
        self.HotkeyActive := false;
        UnitMisc.AppendLog('WM_Hotkey - end');
    end;
end;

procedure TFrmMainPopup.GatherTargetWindowData;
var answer : longint;
    b : boolean;
begin
    Windows.SetLastError(ERROR_SUCCESS);
    self.GatherTargetWarned := false;

    // find control with focus on foreground window
    // ingore error when pasting option is "Clipboard Only"

    self.ExplorerEditDetected := false;
    if (overridehandle = 0) then begin
        self.GetTargetControl(TargetData);
    end else begin
        TargetData.ForegroundWindow := overridehandle;
        TargetData.focuscontrol := 1;
    end;

    if (TargetData.icon <> 0) then begin
        DestroyIcon(TargetData.icon);
    end;
    TargetData.icon := FrmClipboardManager.GetClipboardOwnerIcon(TargetData.ForegroundWindow);

    if (FrmConfig.cbDisplayAtMouseCursor.Checked) or (self.UseMousePositionOnce) then begin
        self.UseMousePositionOnce := false;
        TargetData.x := Mouse.CursorPos.X + 15;
        TargetData.y := Mouse.CursorPos.Y + 10;
    end;
    TargetData.ExeName := WindowHandleToEXEName(TargetData.ForegroundWindow);

    ExplorerEditDetected := (lowercase(TargetData.ExeName) = 'explorer.exe') and
        (
            (AnsiStartsText('Edit',TargetData.FocusControlClassname)) or
            (AnsiStartsText('DirectUIHWND',TargetData.FocusControlClassname))
        );
    if (ExplorerEditDetected) then begin

    end;

    Paste.ClearOnceFlags;
    case Paste.GetPasteMethod(TargetData.ExeName) of
        PASTE_CTRL_V    :            Paste.SetUsePasteCVOnce;
        PASTE_SHIFT_INS :            Paste.SetUsePasteSIOnce;
        PASTE_MIMIC     :            Paste.SetKeyboardMimicOnce;
        PASTE_CLIPBOARD :            Paste.SetClipboardOnlyOnce;
        PASTE_DEFAULT :
        begin
        end;
    end;


    if (lowercase(TargetData.ExeName) = 'cmd.exe') and
     not (Paste.GetPasteMethod(TargetData.ExeName) in [PASTE_CLIPBOARD, PASTE_MIMIC])  then begin
        Paste.SetClipboardOnlyOnce;
        Paste.AssignPaste(TargetData.ExeName, PASTE_CLIPBOARD);
    end;
    //
    // Default to mouse position when can't target a control
    //
    if (TargetData.focuscontrol = 0) then begin
        {
        Windows.GetWindowPlacement(TargetData.ForegroundWindow, @wp);
        TargetData.x := wp.rcNormalPosition.Left;
        TargetData.y := wp.rcNormalPosition.Top;
        }
        TargetData.x := Mouse.CursorPos.X;
        TargetData.y := Mouse.CursorPos.Y;

        //
        // Bitch if were not in ClipboardOnly mode
        // or per-program override can't paste the item right by default.
        // Allow user to always use ClipboardOnly for the problematic
        // program
        // [Answer Yes = add EXE name to NoPaste file]
        //

        if (Paste.GetPasteMethod(TargetData.ExeName) in [PASTE_CLIPBOARD, PASTE_MIMIC]) or
        (Paste.GetDefaultPasteMethod in [PASTE_CLIPBOARD, PASTE_MIMIC])
         then begin
            self.GatherTargetWarned := true;
            // Lie - we don't need a warning when we're already using non-default paste workarounds
        end;


        if (not (Paste.GetPasteMethod(TargetData.ExeName) in [PASTE_CLIPBOARD, PASTE_MIMIC]))
            and
           (not (Paste.GetDefaultPasteMethod in [PASTE_CLIPBOARD, PASTE_MIMIC]))
            then begin
            self.GatherTargetWarned := true;
            Windows.SetForegroundWindow(self.Handle);
            self.IsAdminProgram := false;
            if Integrity.GetLevel(TargetData.ForegroundWindow) = Integrity.IL_HIGH then begin
                if not WarnedEXE.ContainsKey(TargetData.ExeName) then begin
                    WarnedExe.Add(TargetData.ExeName, true);
                    ShowMessage('UAC Admin program detected. Using Clipboard Only for pasting.');
                end;
                Paste.SetClipboardOnlyOnce;
                self.IsAdminProgram := true;
            end else begin
                // automatically use Clipboard Only for the Command Prompt
                if (not self.UseNoWarningsModeOnce ) then begin
                    if not WarnedEXE.ContainsKey(TargetData.ExeName) then begin
                        answer := MessageDlg('Coudn''t find control to target in program ' + uppercase(TargetData.ExeName) + #13#10
                            + 'Would you like to use "Copy to clipboard only" for this program?',
                            mtConfirmation, [mbyes, mbno],0 );
                        if (answer = mryes) then begin
                            Paste.AssignPaste(TargetData.ExeName, PASTE_CLIPBOARD);
                            Windows.SetForegroundWindow(TargetData.ForegroundWindow);
                            Paste.SetClipboardOnlyOnce;
                            EXIT;
                        end;
                        WarnedExe.Add(TargetData.ExeName, true);
                    end;
                end else begin
                    Paste.SetClipboardOnlyOnce;
                    answer := mrno;
                end;
            end;
        end;
        if self.GetNeedsFocus then
            Windows.SetForegroundWindow(self.Handle);
    end;
end;
procedure TfrmMainPopup.GetTargetControl(var TargetData : TTargetProgramData );
var CaretPos, pt : TPoint;
    Rect, Rect2: TRect;
    c : cardinal;

    h : THandle;

begin
    Windows.SetLastError(ERROR_SUCCESS);

    // attempt to get target control's handle and
    // the position of the caret in the text window
    //
    TargetData.focuscontrol := 0;
    TargetData.selectedText := '';
    TargetData.SelectCompatible := false;
    TargetData.DropFilesCompatible := false;

    if (self.ThreadAttach(TargetData.ForegroundWindow)) then begin
        TargetData.focuscontrol := Windows.GetFocus();
        if (TargetData.focuscontrol <> 0) then begin
            h := TargetData.focuscontrol;
            c := Windows.GetWindowLong(TargetData.ForegroundWindow, GWL_EXSTYLE);

            TargetData.DropFilesCompatible := (c and WS_EX_ACCEPTFILES) > 0;

            fillchar(CaretPos,sizeof(CaretPos),#0);
            if Windows.GetCaretPos(CaretPos) then begin
                pt := CaretPos;

                Windows.ClientToScreen(TargetData.focuscontrol, pt);
                ThreadDetach;

                TargetData.x := pt.X;
                TargetData.y := pt.Y;

                AppendLog(Format('caretx=%d carety=%d x=%d y=%d',[caretpos.x, caretpos.y, TargetData.X,TargetData.y]));

                Windows.GetWindowRect(TargetData.ForegroundWindow, rect2);

                if Windows.EqualRect(rect, rect2)  then begin
                    AppendLog('Wrong GetWindowRect -using Mouse Position instead');
                    self.UseMousePositionOnce := true;
                end;
                Windows.GetWindowRect(TargetData.FocusControl, rect2);

                if (pt.X = rect2.left) and (pt.Y = rect2.top) then begin
                    AppendLog('CaretPos is the same as clientrect - using mouse intead');
                    self.UseMousePositionOnce := true;
                end;
            end else begin
                self.UseMousePositionOnce := true;
                AppendLog('==GetCaretPos failed - Using Mouse Position instead==');
                ThreadDetach;
            end;
        end else begin
            self.UseMousePositionOnce := true;
            AppendLog('==GetWindowRect failed - Using Mouse Position instead==');
            ThreadDetach;
        end;

        if TargetData.FocusControl <> 0 then begin
            TargetData.FocusControlClassname := StringOfChar(#0, MAX_PATH+1);
            GetClassName(TargetData.FocusControl, @TargetData.FocusControlClassname[1], MAX_PATH);

            TargetData.FocusControlClassname := PChar(TargetData.FocusControlClassname);
        end;
    end;
    {Select compatible testing no longer used}
    {
    selstart := 0;
    selend := 0;

    if h <> 0 then begin
        length := Windows.SendMessage(h,EM_GETSEL,integer(@selstart),integer(@selend));
        if length = 0 then begin
            h := TargetData.focuscontrol;
            length := Windows.SendMessage(h,EM_GETSEL,integer(@selstart),integer(@selend));
        end;

        self.TargetData.selectCompatible := (length <> 0);

        self.TargetData.selectedText := '';
        if (selstart <> selend) and (length <> 0) then begin
            self.TargetData.selectedText := HAS_SELECTED_TEXT;
        end;
    end;

    // detect the desktop and ignore
    Windows.GetClassName(TargetData.ForegroundWindow,cls, sizeof(cls));
    if (string(cls) = 'Progman') then begin
        self.TargetData.selectedText := '';
        self.TargetData.selectCompatible := false;
    end;
    }

end;
function TFrmMainPopup.GetTargetEXE: string;
begin
    result := TargetData.ExeName;
end;

//
// ShowPopupWithFocusRules: Wrapper function to call ShowPopup enforcing the
// focus rules. The rule is to return focus to the original window.
//
// Once the Hotkey has been pressed, you can reshow the
// popup again by calling this procedure.
//
// Program flow continues to a XXXClickEvent routine when the user
// selects an item from the popup window

procedure TFrmMainPopup.ShowPopupWithFocusRules;

begin
    Windows.SetLastError(ERROR_SUCCESS);
    self.LastClipboardSequence := 0;

    ACPopup.OnHideEvent := self.ShowPopupCallback;
    if (self.GetNeedsFocus) then begin
        // make sure focus is returned
        if ForceForeground(self.handle) then begin //if (self.ThreadAttach(TargetData.ForegroundWindow)) then begin
            self.ShowPopup(TargetData.x, TargetData.y);
        end else begin
            if (not self.GatherTargetWarned) and
                (not self.UseNoWarningsModeOnce) and
                not (Paste.GetPasteMethod(TargetData.ExeName) in [PASTE_CLIPBOARD, PASTE_MIMIC])
              then
                showmessage('Permission denied on target program.');
            // try anyways
            windows.SetForegroundWindow(self.Handle);
            self.ShowPopup(TargetData.x, TargetData.y);
        end;
    end else begin
        if (not self.ThreadAttach(TargetData.ForegroundWindow)) then begin
            if (not self.UseNoWarningsModeOnce) then
                ShowMessage('ERROR: Couldn''t attach popup menu to this window');
        	EXIT;
        end;

        self.ShowPopup(TargetData.x, TargetData.y);
        self.ThreadDetach();
    end;
    self.LastClipboardSequence := 0;

    // Can't clear flags here, MenuClick type events have not yet been fired
    //Paste.ClearOnceFlags;
    //self.UseNoWarningsModeOnce := false;
end;
procedure TFrmMainPopup.ShowPopupCallback(Sender: TObject);
begin
	if not self.SkipFocusReturn  then begin
		ForceForeground(TargetData.ForegroundWindow);
        UnitMisc.AppendLog('Returning Focus to - ' + WindowHandleToEXEName(TargetData.ForegroundWindow));
    end;
    ThreadDetach;
end;
procedure TFrmMainPopup.NewClipboardCallback;
begin
//    if (self.LastClipboardSequence <> 0)  then begin
//        self.SelectedClipboard.GetClipboardItem(0);
//        self.TargetData.selectedText := self.SelectedClipboard.GetAsText;
//        self.LastClipboardSequence := 0;
//    end;
end;
procedure TfrmMainPopup.ShowPopup(X,Y: integer);
begin
    if (self.PopupActive) then begin
        EXIT;
    end;
    self.IgnoreHotkey := true;
    self.PopupActive := true;

    try
        if not frmSysTrayMenu.GetJustSwitched then begin
            FrmPermanent.AutoSwitch(TargetData.ExeName);
        end;

        UnitMisc.AppendLog('Popup Start');
        self.SkipFocusReturn := false;

        if not acpopup.Showing then begin
            UnitMisc.AppendLog('Populate Popup');

            if USE_POPUP_KEYBOARD_HOOK and
                ExplorerEditDetected and (KBHook = 0) then begin
                KBHook:=SetWindowsHookEx(
                    WH_KEYBOARD_LL,
                    @KeyboardHookProc,
                    0{HInstance}, 0{GetCurrentThreadId()}
                );
            end;

            ACPopup.AutoPopulate;
            UnitMisc.AppendLog('Popup Activated');
            ACPopup.ShowPopup(max(x, screen.DesktopRect.left), max(y, screen.DesktopRect.top));
        end;

        UnitMisc.AppendLog('Popup End');
        //
        // show
        // NOTE: This code finishes before .SendText() is ever executed
        //       I need to stop ignoring here because the popup can be dismissed
        //       by ESC key or focus lost.
        //frmClipboardManager.SetIgnoreClipboard(false);
    finally
        self.IgnoreHotkey := false;
        self.PopupActive := false;
    end;
end;



//
// create a 1..9/0 keys for items 0 to 9 and A to Z keys for items 10 and so no
//
function TFrmMainPopup.GetAccelerator(i: integer): char;
const other : array[37..46] of char = (
    '-', '=',
    '[', ']', '\',
    ';', '''',
    ',', '.', '/'
);
begin
    result := ' ';

    case (i) of
    0..8: result := chr(byte('1') + i);
    9:    result := '0';
    10..36 : result := chr(byte('A') + (i - 10));
    37..46 : result := other[i];
    end;
end;

// show a ' ...' when item is too long
// handle tabs  and handle ampersans
function TFrmMainPopup.GetTrimmedItem(item : string) : string;
begin
    result := item;
    if (length(result) > 200) then begin
        result := leftstr(item, 200) + '...';
    end;

    // tabs make the windows too damn long
    // the #10 will make a funky box in the tab's place
    while pos(#9#9, result) > 0 do begin
        result := stringreplace(result, #9#9, #9, [rfreplaceall]);
    end;
    result := stringreplace(result, #9,#10, [rfReplaceAll]);
    while pos(#10#10, result) > 0 do begin
        result := stringreplace(result, #10#10, #10, [rfreplaceall]);
    end;

    //result := stringreplace(result, #13,#10, [rfReplaceAll]);
    result := stringreplace(result, '&', '&&', [rfReplaceAll]);
end;

procedure TFrmMainPopup.FormShow(Sender: TObject);
begin
    UnitMisc.FlushLog;
end;

procedure TFrmMainPopup.ShowPreviewForm;
begin
//    Windows.SetForegroundWindow(FrmPreview.Handle);
//
//    FrmPreview.Left := Self.TargetData.x;
//    FrmPreview.Top := Self.TargetData.y;
//    FrmPreview.ShowModal;
//    if FrmPreview.ModalResult = mrok then
//        self.ShowPopupWithFocusRules;
end;

procedure TFrmMainPopup.SkipFocusReturnOnce;
begin
    self.SkipFocusReturn := true;
end;

procedure TFrmMainPopup.SearchJumplistClickEvent;
var
    newclip : string;
begin


    //b := self.ThreadAttach(Windows.GetForegroundWindow);
    frmSearch.StatusBar1.panels[1].text := 'Pasting to Clipboard only';
    //p := frmSearch.Position;
    //frmSearch.Position := poDesigned;
    //frmSearch.Position := poScreenCenter;
    //frmSearch.Left := mouse.CursorPos.X;
    //frmSearch.Top := mouse.cursorpos.y;
    Windows.SetForegroundWindow(FrmSearch.Handle);
    Windows.SetForegroundWindow(FrmSearch.Handle);
    if frmSearch.Showing = false then frmSearch.ShowModal;
    //frmSearch.Position := p;
    //if b then self.ThreadDetach;



    frmSearch.StatusBar1.panels[1].text := '';
    if FrmSearch.ModalResult = mrOK then begin
        newclip := frmSearch.GetTextToPaste;
        if newclip <> '' then begin
            Paste.SetClipboardOnlyOnce;
            self.SendText(newclip, FrmSearch.GetClipToPaste);
        end;
    end;

end;

procedure TFrmMainPopup.SearchMenuItemClickEvent(Sender: Tobject);
var
    dis : boolean;
    s : string;
    i : integer;
    c1, c2 : Cardinal;
begin
    if FrmConfig.cbSearchDefault.checked then begin
        // select previous word
        // disable the copy
        // send CTRL+C (copy)
        // check the clipboard for a new item using the sequence number
        // unselect previous word (should return cursor)
        // extract text

        Paste.SendCTRL_SHIFT_LEFT;
        dis := frmClipboardManager.GetMonitoring;
        frmClipboardManager.SetDisableMonitoring(true);
        //frmClipboardManager.IgnoreClipboardOnce;

        c1 := Windows.GetClipboardSequenceNumber;
        Paste.SendCTRL_C;

        // detect new text on the clipboard for a maximum of 500 MS
        for i := 0 to 19  do begin
            c2 := Windows.GetClipboardSequenceNumber;
            if c1 <> c2 then BREAK;
            sleep(25);
        end;

        // the undo select was commented out - why? without unselecting the
        // default behavior is to destroy

        Paste.SendCTRL_SHIFT_RIGHT;

        frmClipboardManager.SetDisableMonitoring(not dis);

        FrmSearch.txtFind.Text := '';
        if (c1 <> c2) then begin
            s := Clipboard.AsText;

            FrmSearch.txtFind.Text := s;
            FrmSearch.txtFind.SelectAll;
        end;
    end;

    FrmSearch.ShowAutomatted;
end;

procedure TFrmMainPopup.ClearCurrentLast;
begin
    self.CurrentClipboard.Free;
    self.CurrentClipboard := TClipItem.Create;
    self.LastStringSelected := '';
end;

procedure TFrmMainPopup.ClearSelectedText;
begin
    self.TargetData.selectedText := '';
end;

procedure TFrmMainPopup.HandleFormMode(sendtab : boolean = false);
var w : word;
begin
    if self.UseFormMode then begin
        // focus back on target window and control
        // press tab
        // get current target window control again
        // re-show the popup
        if (self.GetNeedsFocus) then begin
            if (self.ThreadAttach(TargetData.ForegroundWindow)) then begin
                Windows.SetForegroundWindow(TargetData.ForegroundWindow);
                Windows.SetFocus(TargetData.focuscontrol);
            end else begin
                showmessage('ERROR: Unable to paste into target');
                exit;
            end;
        end;

        if (sendtab) then begin
            w := VkKeyScan(#9);
            keybd_event(VK_TAB, w, 0, 0);
            sleep(10);
            keybd_event(VK_TAB, w, KEYEVENTF_KEYUP, 0);
            sleep(100);
        end;
        
        if (self.GetNeedsFocus) then begin
            self.ThreadDetach;
        end;
        self.GetTargetControl(TargetData);


        self.ShowPopupWithFocusRules;
    end;
end;


/////////////////////////////////////////////////////////////////////////////
//
// ShowOnNextWindow - This lets another window cause the popup
// to show up on the text field that just lost focus
//

procedure TFrmMainPopup.ShowOnTaskbar;
var h : THandle;
    top, forced : string;
    msg : TWMHotKey;
begin
    ForceForeground(Application.Handle);
    Application.ProcessMessages;

    h := GetTopWindow(0);
    top := lowercase(WindowHandleToEXEName(h));
    AppendLog('TopLevel:'+top);
    if (top='arsclip.exe') then begin
        h := GetNextWindow;
        forced := lowercase(WindowHandleToEXEName(h));
        if forced = 'explorer.exe' then begin
            AppendLog('Forced1:'+forced);
            h := GetNextWindow(h);
        end;
    end else begin
        h := GetNextWindow;
    end;
    forced := lowercase(WindowHandleToEXEName(h));
    AppendLog('Forced2:'+forced);
    if (top='explorer.exe') and (forced=top) then begin
        h := self.GetNextWindow(h);
        forced := lowercase(WindowHandleToEXEName(h));
        AppendLog('Forced3:'+forced);
    end;
    ForceForeground(h);

    AppendLog('next:'+self.GetNextWindowProgramName);

    msg.HotKey  := FrmConfig.GetHotKeyID;
    self.WMHotKey(msg);
end;

function TFrmMainPopup.GetNextWindow(inh : THandle=0): THandle;
    function GetForegroundSafe : THandle;
    var
        h : THandle;
        i, ms : integer;
    begin
        h := Windows.GetForegroundWindow;
        result := 0;
        ms := 50;
        i := 0;
        while (h = 0) and (i<400) do begin
            h := Windows.GetForegroundWindow;
            mysleep(ms);
            inc(i,ms);
        end;
        if (h = 0) then begin
            UnitMisc.AppendLog('Can''t get foreground window', true);
            exit;
        end;

        result := h;
    end;
    function NextVisible(h : THandle) : THandle;
    var
        starting : THandle;
    begin
        Result := 0;
        h := Windows.GetNextWindow(h, GW_HWNDNEXT);
        if (h = 0) then begin
            UnitMisc.AppendLog('Can''t get next window', true);
            exit;
        end;
        starting := h;
        while not (
            (Windows.IsWindowVisible(h) or Windows.IsIconic(h))
            and (Windows.GetParent(h) in [0, GetDesktopWindow])
            )

            and (h<> 0)
         do begin
            h := Windows.GetNextWindow(h, GW_HWNDNEXT);
            if (h = 0) then begin
                UnitMisc.AppendLog('Can''t get next window in loop', true);
                BREAK;
            end;

            if (h=starting) then BREAK; {safety to prevent an infinite loop}
        end;

        result := h;
    end;
var h : thandle;
const
    debug = True;
begin
    Result := 0;

    if inh = 0 then begin
        h := GetForegroundSafe;
    end else begin
        h := inh;
    end;

    if h = 0 then Exit;

    UnitMisc.AppendLog('foreground: ' + WindowHandleToEXEName(h));


    h := NextVisible(h);
    if h = 0 then Exit;

    UnitMisc.AppendLog('NextVisible: ' + WindowHandleToEXEName(h));

    // the fix for Application.MainFormOnTaskBar caused a change in the
    // "visible" window order -- causing this program to be the previous window
    if  ExtractFileName(Application.ExeName) = UnitMisc.WindowHandleToEXEName(h) then begin
        h := NextVisible(h);
        UnitMisc.AppendLog('Self Found: ' + WindowHandleToEXEName(h));
    end;


    result := h;
end;
procedure TFrmMainPopup.ShowOnNextWindow(ShowPopup : boolean = true);
var h : THandle;
begin
    Windows.SetLastError(ERROR_SUCCESS);
    if (self.PopupShowing) then EXIT;
    try
    self.PopupShowing := true;

    // find the current foreground window
    // find the "next" window (which means below the current, not above)
    // skip any invisible windows

    // move back the the "next" window and attempt
    // to make the previously focused control get keyboard focus again

    h := self.GetNextWindow;
    if (h=0) then begin
        appendlog('ShowOnNextWindow: can''t GetNextWindow');
        EXIT;
    end;

    if (ShowPopup) then begin
        if (self.ThreadAttach(h)) then begin
        	self.ThreadDetach;
            ForceForeground(h);

        end else begin
            showmessage('Permission denied on target program.');
        end;
    end;

    TargetData.ForegroundWindow := h;
    self.GatherTargetWindowData;
    self.FullMode := false;

    if (ShowPopup) then begin
        self.ShowPopupWithFocusRules;
    end;

    finally
        self.PopupShowing := false;
    end;
end;
procedure TFrmMainPopup.ShowOnScratchPad(ShowPopup : boolean = true);
var h : THandle;
begin
    Windows.SetLastError(ERROR_SUCCESS);
    if (ACPopup.Showing) then EXIT;
    try
    self.PopupShowing := true;

    // find the current foreground window
    // find the "next" window (which means below the current, not above)
    // skip any invisible windows

    // move back the the "next" window and attempt
    // to make the previously focused control get keyboard focus again



    h := GetForegroundWindow;
    self.UseMousePositionOnce := true;
    self.UseNoWarningsModeOnce := true;
    {if (ShowPopup) then begin
        if (self.ThreadAttach(h)) then begin
            Windows.SetForegroundWindow(h);
            self.ThreadDetach;
        end else begin
            //showmessage('Permission denied on target program.');
        end;
    end;
    }
    TargetData.ForegroundWindow := h;

    self.GatherTargetWindowData;

    self.FullMode := false;

    if (ShowPopup) then begin
        self.ShowPopupWithFocusRules;
    end;
    //Paste.ClearOnceFlags;
    self.UseNoWarningsModeOnce := false;
    finally
        self.PopupShowing := false;
    end;
end;
function TFrmMainPopup.GetNextWindowProgramName: string;
var h : THandle;
begin
    Windows.SetLastError(ERROR_SUCCESS);

    h := self.GetNextWindow;
    if (h <> 0) then begin
        result := ExtractFilename(WindowHandleToEXEName(h));
    end else begin
        result := '';
    end;
end;
function TFrmMainPopup.GetSelectedText: string;
begin
    result := self.TargetData.selectedText;
end;
procedure TFrmMainPopup.ShowOnSystemTray(overrideh : Thandle = 0);
var h : THandle;
    CursorPos : TPoint;
    m : TMonitor;
begin
    Windows.SetLastError(ERROR_SUCCESS);
    if (self.PopupShowing) then EXIT;
    try
    self.PopupShowing := true;


    Windows.GetCursorPos(CursorPos);

    // find the current foreground window
    // find the "next" window (which means below the current, not above)
    // skip any invisible windows


    h := self.GetNextWindow;
    if (h=0) then begin
        appendlog('ShowOnSystemTray: can''t GetNextWindow');
        EXIT;
    end;
    TargetData.ForegroundWindow := h;

    {
    m := Screen.MonitorFromPoint(CursorPos);
    if m <> nil then begin
        if CursorPos.Y > (m.Height div 2) then begin
            CursorPos.Y := m.Height - (m.Height div 3);
        end;
    end;
    }


    self.GatherTargetWindowData(h);
    TargetData.focuscontrol := 0;
    self.TargetData.x := CursorPos.x;
    self.TargetData.y := CursorPos.Y;
    self.FullMode := false;

    Windows.SetForegroundWindow(self.Handle);

    self.ShowPopup(CursorPos.x + 15, CursorPos.y - 10);
    ACPopup.DodgePoint(cursorpos);
    //Paste.ClearOnceFlags;
    finally
        self.PopupShowing := false;
    end;
end;
function TFrmMainPopup.PopupIsShowing : boolean;
begin
    result := ACPopup.Showing;
end;
procedure TFrmMainPopup.SendText(s: string; ci : TClipItem = nil; NoPlaintext : boolean = false);
var prefix : string;
begin
    Windows.SetLastError(ERROR_SUCCESS);

    //
    // Since the popup may have stolen focus from the target,
    // it must be given keyboard focus again
    //
    if (self.GetNeedsFocus) then begin
        if (not (self.ThreadAttached)) and (self.ThreadAttach(TargetData.ForegroundWindow)) then begin
            Windows.SetForegroundWindow(TargetData.ForegroundWindow);
            if (TargetData.focuscontrol <> 0) then begin
                Windows.SetFocus(TargetData.focuscontrol);
            end;
        end else begin
            //showmessage('ERROR: Unable to paste into target');
            //EXIT;
            Windows.SetForegroundWindow(TargetData.ForegroundWindow);
        end;
    end;

    prefix :=uppercase(leftstr(s,6));

    if (prefix  = '[KEYS]') then begin
        Paste.SendTextWithKeystrokes(s);
    end else if (FrmPermanent.IsComplexItem(s)) then begin
        ci := FrmPermanent.GetComplexItem(s);

        Paste.SendText('', ci, NoPlaintext);
        MyFree(ci);
    end else begin
        Paste.SendText(s, ci, NoPlaintext);
    end;

    if (self.GetNeedsFocus) then begin
        self.ThreadDetach;
    end;
end;

{
--============================
-- // Thead utility methods //
--============================

Description: Mimic being part of the targeted window. This method is used
to get the keyboard focused item of an outside process and to associate a
popup menu with an outside process.

Update: Changed to allow ArsClip to paste into its own windows, like
Permanent Items.
}

function TfrmMainPopup.ThreadAttach(TargetWindow: cardinal) : boolean;
begin
    If (ThreadAttached) then begin
        showmessage('Error: Thread already attached');
        //self.Close;
    end;

    ThreadTarget := Windows.GetWindowThreadProcessId(TargetWindow, nil);
    ThreadOurs := Windows.GetCurrentThreadId();
    if (ThreadTarget <> ThreadOurs) then begin
        result := Windows.AttachThreadInput(ThreadTarget, ThreadOurs, true);
    end else begin
        result := true;
    end;
    ThreadAttached := result;
end;
procedure TfrmMainPopup.ThreadDetach();
begin
    if (ThreadTarget <> ThreadOurs) then begin
        Windows.AttachThreadInput(ThreadTarget, ThreadOurs, false);
    end;
    ThreadAttached := false;
end;

procedure TFrmMainPopup.timMouseHeldTimer(Sender: TObject);
var msg : TWMHotKey;

    //tw : TTooltipWindow;
    tt : TFrmTooltipNew;

    p, oldp : TPoint;

    h : THandle;
    m : TMonitor;
    r : TRect;
    startpoint : TPoint;
    wp : tagWINDOWPLACEMENT;
    name : string;
    delay, curdelay : integer;
    ShowPopup, SkipSecondCheck : boolean;
CONST
    MOUSE_THRESHOLD = 6;
    function IsRightTrigger : boolean;
    begin
        result := FrmConfig.cbxMouseButton.ItemIndex = 0;
    end;
    function MouseHeld : boolean;
    begin
        if IsRightTrigger then begin
            result :=  KeyboardQuery.IsClicked(rightButton);
        end else begin
            result := KeyboardQuery.IsClicked(MiddleButton);
        end;
    end;
    function MouseMoved : boolean;
    begin
        result :=
            (abs(startpoint.X - mouse.CursorPos.X) > MOUSE_THRESHOLD) or
            (abs(startpoint.Y - mouse.CursorPos.Y) > MOUSE_THRESHOLD);
    end;
    procedure WaitForDelayWhileHeld;
    begin
        delay := FrmConfig.GetRightClickDelay;
        curdelay := 0;
        while curdelay < delay do begin
            mysleep(50);
            inc(curdelay,50);
            if not MouseHeld then begin
                BREAK;
            end;
        end;
    end;
    procedure WaitForMouseRelease;
    begin
        while mouseheld do begin
            MySleep(50);
        end;
    end;
    function CurrentProgramOK : boolean;
    begin
        result := not (frmSysTrayMenu.IsNoRightClickEXE(name) or
            (lowercase(name)='arsclip.exe'));
    end;
    function MonitorAndWindowOK : boolean;
    begin
        result := true;
        if GetWindowRect(h,r) then begin
            m := screen.MonitorFromRect(r);
            if m = nil then begin
                UnitMisc.AppendLog('MonitorFromRect failed', true);
                result := false;
                EXIT;
            end;

            SkipSecondCheck := false;
            if GetWindowPlacement(h, wp) then begin
                if wp.showCmd = SW_SHOWMAXIMIZED then begin
                    UnitMisc.AppendLog('RightClickTrigger - Maximized detected');
                    result := true;
                    EXIT;
                end;
            end;


            UnitMisc.appendlog('RightClickTrigger monitor' + inttostr(m.boundsrect.Right) + ' ' + inttostr(m.boundsrect.bottom) );
            UnitMisc.appendlog('RightClickTrigger monitor' + inttostr(m.boundsrect.left) + ' ' + inttostr(m.boundsrect.top) );
            UnitMisc.appendlog('RightClickTrigger test ' + name  + inttostr(r.Right) + ' ' + inttostr(r.bottom) );
            UnitMisc.appendlog('RightClickTrigger test ' + name + inttostr(r.left) + ' ' + inttostr(r.top) );

            if ((r.Bottom-r.Top) >= (m.BoundsRect.Bottom-m.BoundsRect.top)) and
                ((r.Right-r.left) >= (m.boundsrect.Right-m.boundsrect.Left))
            then begin
                if lowercase(name) <> 'explorer.exe' then begin
                    UnitMisc.AppendLog('fullscreen detected');
                    result := false;
                    EXIT;
                end;
            end;
        end else begin
            UnitMisc.AppendLog('GetWindowRect failed', true);
        end;
    end;
    function UserRejected : boolean;
    begin
        result := false;
        if not FrmConfig.GetRightclickTriggerWarned then begin
            WaitForMouseRelease;
            if Dialogs.MessageDlg(
                '(Setting: [Configuration>Popup>Hotkey Alternatives])'#13#10#13#10 +
                'ArsClip is set by default to trigger the popup when this mouse button is held. Keep this setting?'
                ,
                Dialogs.mtConfirmation, [mbYes, mbNo], 0
            ) = mrNo then begin
                FrmConfig.cbRightTriggerEnable.Checked := false;
                result := true;
            end;
            FrmConfig.SetRightclickTriggerWarned;
        end;
    end;
    procedure ShowTooltip;
    begin
        p := mouse.cursorpos;
        dec(p.x, 5);
        dec(p.Y, 5);

        tt := TFrmTooltipNew.Create(application);
        tt.HideHeader;
        tt.CloseOnLostFocus := False;
        tt.SmallFontOnce := true;
        tt.OnClick := nil;
        tt.DodgeMouse := false;
        tt.ShowTooltip('     Popup',p);
        if IsRightTrigger then
            ForceForeground(tt.Handle);
    end;
    procedure HideTooltip;
    begin
        tt.Hide;
        myfree(tt);
        mysleep(100);
        if IsRightTrigger then
            Paste.SendESC;
    end;
    procedure TriggerPopup;
    begin
        msg.HotKey := FrmConfig.GetHotKeyID;
        self.UseMousePositionOnce := true;
        self.WMHotKey(msg);
    end;

    procedure ExitCode;
    begin
        WaitForMouseRelease;
        timMouseHeld.Enabled := true;
    end;
begin
    if not Assigned(frmSysTrayMenu) then EXIT;
    if not Assigned(frmConfig) then EXIT;
    if self.PopupActive  then EXIT;

    if MouseHeld then begin
        timMouseHeld.Enabled := false;
        startpoint := mouse.CursorPos;
        h := Windows.GetForegroundWindow;
        name := WindowHandleToEXEName(h);

        WaitForDelayWhileHeld;
        if (not MouseHeld) or MouseMoved then begin
            ExitCode;
            EXIT;
        end;
        if not CurrentProgramOK then begin
            ExitCode;
            EXIT;
        end;
        if not MonitorAndWindowOK then begin
            ExitCode;
            EXIT;
        end;
        if MouseHeld and (not UserRejected) then begin
            ShowTooltip;
            WaitForMouseRelease;
            HideTooltip;
            TriggerPopup;
        end;

        timMouseHeld.Enabled := true;
    end;

end;

{
--===========
-- // Etc. //
--===========
}
procedure TfrmMainPopup.AppendLog(s : string);
begin
    if length(memo1.text) > 30000 then memo1.Text := '';
    // Cheezy Debugging Info[tm]
    // make sure we don't overflow the text, only accept 1000 characters
    // at a time
    memo1.Text := leftstr(s, 1000) + #13 + #10 + memo1.text;
end;

procedure TFrmMainPopup.ApplicationException(Sender: TObject; E: Exception);
begin
    UnitMisc.ApplicationException(Sender, E); 
end;

procedure TfrmMainPopup.btnHideClick(Sender: TObject);
begin
    self.Hide;                  
end;


function TFrmMainPopup.GetLastStringSelected: string;
begin
    result := self.LastStringSelected;
end;
function TFrmMainPopup.GetUseFormMode: boolean;
begin
    result := self.UseFormMode;
end;
function TFrmMainPopup.GetFullMode: boolean;
begin
    result := self.FullMode;
end;
function TFrmMainPopup.GetDoMoveSelectedToTop: boolean;
begin
    result := DoMoveSelectedToTop;
end;
function TFrmMainPopup.GetDoRememberHistory: boolean;
begin
    result := DoRememberHistory;
end;
function TFrmMainPopup.GetDoShowCurrentItem: boolean;
begin
    result := DoShowCurrentItem;
end;
function TFrmMainPopup.GetDoShowEditHistory: boolean;
begin
    result := DoShowEditHistory;
end;
function TFrmMainPopup.GetDoShowFormMode: boolean;
begin
    result := DoShowFormMode;
end;
function TFrmMainPopup.GetDoShowLast: boolean;
begin
    result := DoShowLast;
end;
function TFrmMainPopup.GetDoShowPasteAll: boolean;
begin
    result := DoShowPasteAll;
end;
function TFrmMainPopup.GetDoShowPermanentItemGroups: boolean;
begin
    result := DoShowPermanentItemGroups;
end;
function TFrmMainPopup.GetDoShowPermanentItemSubmenu: boolean;
begin
    result := DoShowPermanentItemSubmenu
end;
function TFrmMainPopup.GetUsePermanentItems: boolean;
begin
    result := UsePermanentItems;
end;

procedure TFrmMainPopup.ShowPreviewEditForm;
begin
    Windows.SetForegroundWindow(FrmEditItem.Handle);

//    FrmEditItem.Left := Self.TargetData.x;
//    FrmEditItem.Top := Self.TargetData.y;
    FrmEditItem.Left := mouse.CursorPos.x;
    FrmEditItem.Top := mouse.CursorPos.y;

    FrmEditItem.ShowModal;
end;


end.
